type token =
  | TUnknown of (Ast_c.info)
  | TCommentSpace of (Ast_c.info)
  | TCommentNewline of (Ast_c.info)
  | TComment of (Ast_c.info)
  | TInt of ((string * (Ast_c.sign * Ast_c.base)) * Ast_c.info)
  | TFloat of ((string * Ast_c.floatType) * Ast_c.info)
  | TChar of ((string * Ast_c.isWchar) * Ast_c.info)
  | TString of ((string * Ast_c.isWchar) * Ast_c.info)
  | TQuote of ((string * Ast_c.isWchar) * Ast_c.info)
  | TPct of (Ast_c.info)
  | TFormat of (string * Ast_c.info)
  | TSubString of (string * Ast_c.info)
  | TDecimal of ((string * string (*n*) * string (*p*)) * Ast_c.info)
  | TIdent of (string * Ast_c.info)
  | TKRParam of (string * Ast_c.info)
  | Tconstructorname of (string * Ast_c.info)
  | TypedefIdent of (string * Ast_c.info)
  | TOPar of (Ast_c.info)
  | TCPar of (Ast_c.info)
  | TOBrace of (Ast_c.info)
  | TCBrace of (Ast_c.info)
  | TOCro of (Ast_c.info)
  | TCCro of (Ast_c.info)
  | TDot of (Ast_c.info)
  | TComma of (Ast_c.info)
  | TPtrOp of (Ast_c.info)
  | TInc of (Ast_c.info)
  | TDec of (Ast_c.info)
  | TAssign of (Ast_c.assignOp)
  | TEq of (Ast_c.info)
  | TWhy of (Ast_c.info)
  | TTilde of (Ast_c.info)
  | TBang of (Ast_c.info)
  | TEllipsis of (Ast_c.info)
  | TDotDot of (Ast_c.info)
  | TPtVirg of (Ast_c.info)
  | TOrLog of (Ast_c.info)
  | TAndLog of (Ast_c.info)
  | TOr of (Ast_c.info)
  | TXor of (Ast_c.info)
  | TAnd of (Ast_c.info)
  | TEqEq of (Ast_c.info)
  | TNotEq of (Ast_c.info)
  | TInf of (Ast_c.info)
  | TSup of (Ast_c.info)
  | TInfEq of (Ast_c.info)
  | TSupEq of (Ast_c.info)
  | TShl of (Ast_c.info)
  | TShr of (Ast_c.info)
  | TPlus of (Ast_c.info)
  | TMinus of (Ast_c.info)
  | TMul of (Ast_c.info)
  | TDiv of (Ast_c.info)
  | TMod of (Ast_c.info)
  | TMax of (Ast_c.info)
  | TMin of (Ast_c.info)
  | Tchar of (Ast_c.info)
  | Tshort of (Ast_c.info)
  | Tint of (Ast_c.info)
  | Tdouble of (Ast_c.info)
  | Tfloat of (Ast_c.info)
  | Tlong of (Ast_c.info)
  | Tunsigned of (Ast_c.info)
  | Tsigned of (Ast_c.info)
  | Tvoid of (Ast_c.info)
  | Tsize_t of (Ast_c.info)
  | Tssize_t of (Ast_c.info)
  | Tptrdiff_t of (Ast_c.info)
  | Tauto of (Ast_c.info)
  | Tregister of (Ast_c.info)
  | Textern of (Ast_c.info)
  | Tstatic of (Ast_c.info)
  | Ttypedef of (Ast_c.info)
  | Tconst of (Ast_c.info)
  | Tvolatile of (Ast_c.info)
  | Tstruct of (Ast_c.info)
  | Tunion of (Ast_c.info)
  | Tenum of (Ast_c.info)
  | Tdecimal of (Ast_c.info)
  | Texec of (Ast_c.info)
  | Tbreak of (Ast_c.info)
  | Telse of (Ast_c.info)
  | Tswitch of (Ast_c.info)
  | Tcase of (Ast_c.info)
  | Tcontinue of (Ast_c.info)
  | Tfor of (Ast_c.info)
  | Tdo of (Ast_c.info)
  | Tif of (Ast_c.info)
  | Twhile of (Ast_c.info)
  | Treturn of (Ast_c.info)
  | Tgoto of (Ast_c.info)
  | Tdefault of (Ast_c.info)
  | Tsizeof of (Ast_c.info)
  | Tnew of (Ast_c.info)
  | Tdelete of (Ast_c.info)
  | Tdefined of (Ast_c.info)
  | TOParCplusplusInit of (Ast_c.info)
  | Tnamespace of (Ast_c.info)
  | Trestrict of (Ast_c.info)
  | Tasm of (Ast_c.info)
  | Tattribute of (Ast_c.info)
  | TattributeNoarg of (Ast_c.info)
  | Tinline of (Ast_c.info)
  | Ttypeof of (Ast_c.info)
  | TDefine of (Ast_c.info)
  | TDefParamVariadic of ((string * Ast_c.info))
  | TCppEscapedNewline of (Ast_c.info)
  | TCppConcatOp of (Ast_c.info)
  | TOParDefine of (Ast_c.info)
  | TOBraceDefineInit of (Ast_c.info)
  | TIdentDefine of ((string * Ast_c.info))
  | TDefEOL of (Ast_c.info)
  | TInclude of ((string * string * bool ref * Ast_c.info))
  | TIncludeStart of ((Ast_c.info * bool ref))
  | TIncludeFilename of ((string * Ast_c.info))
  | TIfdef of ((Ast_c.ifdef_guard * (int * int) option ref * Ast_c.info))
  | TIfdefelif of ((Ast_c.ifdef_guard * (int * int) option ref * Ast_c.info))
  | TIfdefelse of (((int * int) option ref * Ast_c.info))
  | TEndif of (((int * int) option ref * Ast_c.info))
  | TIfdefBool of ((bool * (int * int) option ref * Ast_c.info))
  | TIfdefMisc of ((bool * (int * int) option ref * Ast_c.info))
  | TIfdefVersion of ((bool * (int * int) option ref * Ast_c.info))
  | TUifdef of (Ast_c.info)
  | TUelseif of (Ast_c.info)
  | TUendif of (Ast_c.info)
  | TUndef of (Ast_c.info)
  | TPragma of (Ast_c.info)
  | TCppDirectiveOther of (Ast_c.info)
  | TMacroAttr of ((string * Ast_c.info))
  | TMacroStmt of ((string * Ast_c.info))
  | TMacroIdentBuilder of ((string * Ast_c.info))
  | TMacroString of ((string * Ast_c.info))
  | TMacroDecl of ((string * Ast_c.info))
  | TMacroDeclConst of (Ast_c.info)
  | TMacroIterator of ((string * Ast_c.info))
  | TCommentSkipTagStart of (Ast_c.info)
  | TCommentSkipTagEnd of (Ast_c.info)
  | TCParEOL of (Ast_c.info)
  | TAction of (Ast_c.info)
  | TCommentMisc of (Ast_c.info)
  | TCommentCpp of ((Token_c.cppcommentkind * Ast_c.info))
  | EOF of (Ast_c.info)
  | TTODO of (Ast_c.info)

open Parsing;;
let _ = parse_error;;
# 2 "parser_c.mly"
(* Yoann Padioleau
 *
 * Copyright (C) 2002, 2006, 2007, 2008, 2009 Yoann Padioleau
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License (GPL)
 * version 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * file license.txt for more details.
 *)

(**
 * This grammar has been inspired by:
 * http://www.lysator.liu.se/c/ANSI-C-grammar-y.html
 *)

open Common

open Ast_c

module LP = Lexer_parser
open Lexer_parser (* for the fields *)

open Semantic_c (* Semantic exn *)
module T = Token_c

(*****************************************************************************)
(* Wrappers *)
(*****************************************************************************)
let warning s v =
  if !Flag_parsing_c.verbose_parsing
  then Common.warning ("PARSING: " ^ s) v
  else v

let pr2, pr2_once = Common.mk_pr2_wrappers Flag_parsing_c.verbose_parsing

(*****************************************************************************)
(* Parse helpers functions *)
(*****************************************************************************)

(*-------------------------------------------------------------------------- *)
(* Type related *)
(*-------------------------------------------------------------------------- *)

type shortLong      = Short  | Long | LongLong

type decl = {
  storageD: storagebis wrap;
  typeD: ((sign option) * (shortLong option) * (typeCbis option)) wrap;
  qualifD: typeQualifierbis wrap;
  inlineD: bool             wrap;
  (* note: have a full_info: parse_info list; to remember ordering
   * between storage, qualifier, type ? well this info is already in
   * the Ast_c.info, just have to sort them to get good order *)
}

let nullDecl = {
  storageD = NoSto, [];
  typeD = (None, None, None), [];
  qualifD = nullQualif;
  inlineD = false, [];
}
let fake_pi = Common.fake_parse_info

let addStorageD  = function
  | ((x,ii), ({storageD = (NoSto,[])} as v)) -> { v with storageD = (x, [ii]) }
  | ((x,ii), ({storageD = (y, ii2)} as v)) ->
      if x = y then warning "duplicate storage classes" v
      else raise (Semantic ("multiple storage classes", fake_pi))

let addInlineD  = function
  | ((true,ii), ({inlineD = (false,[])} as v)) -> { v with inlineD=(true,[ii])}
  | ((true,ii), ({inlineD = (true, ii2)} as v)) -> warning "duplicate inline" v
  | _ -> raise (Impossible 86)


let addTypeD     = function
  | ((Left3 Signed,ii)   ,({typeD = ((Some Signed,  b,c),ii2)} as v)) ->
      warning "duplicate 'signed'"   v
  | ((Left3 UnSigned,ii) ,({typeD = ((Some UnSigned,b,c),ii2)} as v)) ->
      warning "duplicate 'unsigned'" v
  | ((Left3 _,ii),        ({typeD = ((Some _,b,c),ii2)} as _v)) ->
      raise (Semantic ("both signed and unsigned specified", fake_pi))
  | ((Left3 x,ii),        ({typeD = ((None,b,c),ii2)} as v))   ->
      {v with typeD = (Some x,b,c),ii @ ii2}

  | ((Middle3 Short,ii),  ({typeD = ((a,Some Short,c),ii2)} as v)) ->
      warning "duplicate 'short'" v


  (* gccext: long long allowed *)
  | ((Middle3 Long,ii),   ({typeD = ((a,Some Long ,c),ii2)} as v)) ->
      { v with typeD = (a, Some LongLong, c),ii @ ii2 }
  | ((Middle3 Long,ii),   ({typeD = ((a,Some LongLong ,c),ii2)} as v)) ->
      warning "triplicate 'long'" v


  | ((Middle3 _,ii),      ({typeD = ((a,Some _,c),ii2)} as _v)) ->
      raise (Semantic ("both long and short specified", fake_pi))
  | ((Middle3 x,ii),      ({typeD = ((a,None,c),ii2)} as v))  ->
      {v with typeD = (a, Some x,c),ii @ ii2}

  | ((Right3 t,ii),       ({typeD = ((a,b,Some x),ii2)} as _v)) ->
      raise (Semantic ((Printf.sprintf "two or more data types: t %s ii %s\ntypeD %s ii2 %s\n" (Dumper.dump t) (Dumper.dump ii) (Dumper.dump x) (Dumper.dump ii2)), fake_pi))
  | ((Right3 t,ii),       ({typeD = ((a,b,None),ii2)} as v))   ->
      {v with typeD = (a,b, Some t),ii @ ii2}


let addQualif = function
  | ({const=true},   ({const=true} as x)) ->   warning "duplicate 'const'" x
  | ({volatile=true},({volatile=true} as x))-> warning "duplicate 'volatile'" x
  | ({const=true},    v) -> {v with const=true}
  | ({volatile=true}, v) -> {v with volatile=true}
  | _ ->
      internal_error "there is no noconst or novolatile keyword"

let addQualifD ((qu,ii), ({qualifD = (v,ii2)} as x)) =
  { x with qualifD = (addQualif (qu, v),ii::ii2) }


(*-------------------------------------------------------------------------- *)
(* Declaration/Function related *)
(*-------------------------------------------------------------------------- *)


(* stdC: type section, basic integer types (and ritchie)
 * To understand the code, just look at the result (right part of the PM)
 * and go back.
 *)
let (fixDeclSpecForDecl: decl -> (fullType * (storage wrap)))  = function
 {storageD = (st,iist);
  qualifD = (qu,iiq);
  typeD = (ty,iit);
  inlineD = (inline,iinl);
  } ->
   let ty',iit' =
   (match ty with
 | (None,None,None)       ->
     (* generate fake_info, otherwise type_annotater can crash in
      * offset.
      *)
     warning "type defaults to 'int'" (defaultInt, [fakeInfo fake_pi])
 | (None, None, Some t)   -> (t, iit)

 | (Some sign,   None, (None| Some (BaseType (IntType (Si (_,CInt))))))  ->
     BaseType(IntType (Si (sign, CInt))), iit
 | ((None|Some Signed),Some x,(None|Some(BaseType(IntType (Si (_,CInt)))))) ->
     BaseType(IntType (Si (Signed, [Short,CShort; Long, CLong; LongLong, CLongLong] +> List.assoc x))), iit
 | (Some UnSigned, Some x, (None| Some (BaseType (IntType (Si (_,CInt))))))->
     BaseType(IntType (Si (UnSigned, [Short,CShort; Long, CLong; LongLong, CLongLong] +> List.assoc x))), iit
 | (Some sign,   None, (Some (BaseType (IntType CChar))))   ->
     BaseType(IntType (Si (sign, CChar2))), iit
 | (None, Some Long,(Some(BaseType(FloatType CDouble))))    ->
     BaseType (FloatType (CLongDouble)), iit

 | (Some _,_, Some _) ->
     (*mine*)
     raise (Semantic ("signed, unsigned valid only for char and int", fake_pi))
 | (_,Some _,(Some(BaseType(FloatType (CFloat|CLongDouble))))) ->
     raise (Semantic ("long or short specified with floating type", fake_pi))
 | (_,Some Short,(Some(BaseType(FloatType CDouble)))) ->
     raise (Semantic ("the only valid combination is long double", fake_pi))

 | (_, Some _, Some _) ->
     (* mine *)
     raise (Semantic ("long, short valid only for int or float", fake_pi))

     (* if do short uint i, then gcc say parse error, strange ? it is
      * not a parse error, it is just that we dont allow with typedef
      * either short/long or signed/unsigned. In fact, with
      * parse_typedef_fix2 (with et() and dt()) now I say too parse
      * error so this code is executed only when do short struct
      * {....} and never with a typedef cos now we parse short uint i
      * as short ident ident => parse error (cos after first short i
      * pass in dt() mode) *)

   )
   in
   ((qu, iiq),
   (ty', iit'))
     ,((st, inline),iist @ iinl)


let fixDeclSpecForParam = function ({storageD = (st,iist)} as r) ->
  let ((qu,ty) as v,_st) = fixDeclSpecForDecl r in
  match st with
  | (Sto Register) -> (v, true), iist
  | NoSto -> (v, false), iist
  | _ ->
      raise
        (Semantic ("storage class specified for parameter of function",
                  fake_pi))

let fixDeclSpecForMacro = function ({storageD = (st,iist)} as r) ->
  let ((qu,ty) as v,_st) = fixDeclSpecForDecl r in
  match st with
  | NoSto -> v
  | _ ->
      raise
        (Semantic ("storage class specified for macro type decl",
                  fake_pi))


let fixDeclSpecForFuncDef x =
  let (returnType,storage) = fixDeclSpecForDecl x in
  (match fst (unwrap storage) with
  | StoTypedef ->
      raise (Semantic ("function definition declared 'typedef'", fake_pi))
  | _ -> (returnType, storage)
  )


(* parameter: (this is the context where we give parameter only when
 * in func DEFINITION not in funct DECLARATION) We must have a name.
 * This function ensure that we give only parameterTypeDecl with well
 * formed Classic constructor todo?: do we accept other declaration
 * in ? so I must add them to the compound of the deffunc. I dont
 * have to handle typedef pb here cos C forbid to do VF f { ... }
 * with VF a typedef of func cos here we dont see the name of the
 * argument (in the typedef)
 *)
let (fixOldCDecl: fullType -> fullType) = fun ty ->
  match Ast_c.unwrap_typeC ty with
  | FunctionType (fullt, (params, (b, iib))) ->

      (* stdC: If the prototype declaration declares a parameter for a
       * function that you are defining (it is part of a function
       * definition), then you must write a name within the declarator.
       * Otherwise, you can omit the name. *)
      (match params with
      | [{p_namei = None; p_type = ty2},_] ->
          (match Ast_c.unwrap_typeC ty2 with
          | BaseType Void ->
              ty
          | _ ->
              pr2_once ("SEMANTIC:parameter name omitted, but I continue");
              ty
          )

      | params ->
          (params +> List.iter (fun (param,_) ->
            match param with
            | {p_namei = None} ->
              (* if majuscule, then certainly macro-parameter *)
                pr2_once ("SEMANTIC:parameter name omitted, but I continue");
	    | _ -> ()
          ));
          ty
      )

        (* todo? can we declare prototype in the decl or structdef,
           ... => length <> but good kan meme *)
  | _ ->
      (* gcc say parse error but dont see why *)
      raise (Semantic ("seems this is not a function", fake_pi))


let fixFunc (typ, compound, old_style_opt) =
  let (cp,iicp) = compound in

  let (name, ty,   (st,iist),  attrs) = typ in

  let (qu, tybis) = ty in

  match Ast_c.unwrap_typeC ty with
  | FunctionType (fullt, (params,abool)) ->
      let iifunc = Ast_c.get_ii_typeC_take_care tybis in

      let iistart = Ast_c.fakeInfo () in
      assert (qu = nullQualif);

      (match params with
      | [{p_namei= None; p_type = ty2}, _] ->
          (match Ast_c.unwrap_typeC ty2 with
          | BaseType Void ->  ()
          | _ ->
                (* failwith "internal errror: fixOldCDecl not good" *)
              ()
          )
      | params ->
          params +> List.iter (function
          | ({p_namei = Some s}, _) -> ()
	  | _ -> ()
                (* failwith "internal errror: fixOldCDecl not good" *)
          )
      );
      (* bugfix: cf tests_c/function_pointer4.c.
       * Apparemment en C on peut syntaxiquement ecrire ca:
       *
       *   void a(int)(int x);
       * mais apres gcc gueule au niveau semantique avec:
       *   xxx.c:1: error: 'a' declared as function returning a function
       * Je ne faisais pas cette verif. Sur du code comme
       *   void METH(foo)(int x) { ...} , le parser croit (a tort) que foo
       * est un typedef, et donc c'est parsé comme l'exemple precedent,
       * ce qui ensuite confuse l'unparser qui n'est pas habitué
       * a avoir dans le returnType un FunctionType et qui donc
       * pr_elem les ii dans le mauvais sens ce qui genere au final
       * une exception. Hence this fix to at least detect the error
       * at parsing time (not unparsing time).
       *)
      (match Ast_c.unwrap_typeC fullt with
      | FunctionType _ ->
          let s = Ast_c.str_of_name name in
          let iis = Ast_c.info_of_name name in
          pr2 (spf "WEIRD: %s declared as function returning a function." s);
          pr2 (spf "This is probably because of a macro. Extend standard.h");
          raise (Semantic (spf "error: %s " s, Ast_c.parse_info_of_info iis))
      | _ -> ()
      );

      (* it must be nullQualif,cos parser construct only this*)
      {f_name = name;
       f_type = (fullt, (params, abool));
       f_storage = st;
       f_body =
	if !Flag_parsing_c.parsing_header_for_types
	then []
	else cp;
       f_attr = attrs;
       f_old_c_style = old_style_opt;
      },
      (iifunc @ iicp @ [iistart] @ iist)
  | _ ->
      raise
        (Semantic
            ("you are trying to do a function definition but you dont give " ^
             "any parameter", fake_pi))


(*-------------------------------------------------------------------------- *)
(* parse_typedef_fix2 *)
(*-------------------------------------------------------------------------- *)

let dt s () =
  if !Flag_parsing_c.debug_etdt then pr2 ("<" ^ s);
  LP.disable_typedef ()

let et s () =
  if !Flag_parsing_c.debug_etdt then pr2 (">" ^ s);
  LP.enable_typedef ()


let fix_add_params_ident x =
  let (s, ty, st, _attrs) = x in
  match Ast_c.unwrap_typeC ty with
  | FunctionType (fullt, (params, bool)) ->

      (match params with
      | [{p_namei=None; p_type=ty2}, _] ->
          (match Ast_c.unwrap_typeC ty2 with
          | BaseType Void -> ()
          | _ ->
              (* failwith "internal errror: fixOldCDecl not good" *)
              ()
          )
      | params ->
          params +> List.iter (function
          | ({p_namei= Some name}, _) ->
              LP.add_ident (Ast_c.str_of_name s)
	  | _ ->
              ()
                (* failwith "internal errror: fixOldCDecl not good" *)
          )
      )
  | _ -> ()

(*-------------------------------------------------------------------------- *)
(* shortcuts *)
(*-------------------------------------------------------------------------- *)

let mk_e e ii = Ast_c.mk_e e ii

let mk_string_wrap (s,info) = (s, [info])

(*-------------------------------------------------------------------------- *)
(* support for functions with no return type *)
(*-------------------------------------------------------------------------- *)

let args_are_params l =
  match l with
    [Right (ArgAction(ActMisc [x])), ii] when Ast_c.is_fake x -> true
  | _ -> List.for_all (function Right (ArgType x), ii -> true | _ -> false) l
let args_to_params l pb =
  let pi =
    match pb with Some pb -> Ast_c.parse_info_of_info pb | None -> fake_pi in
  match l with
    [(Right (ArgAction(ActMisc [x])), ii)] when Ast_c.is_fake x -> []
  | l ->
      List.map
	(function
	    Right (ArgType x), ii -> x, ii
	  | x ->
	      raise
		(Semantic
		   ("function with no return type must have types in param list",
		    pi)))
	l

# 552 "parser_c.ml"
let yytransl_const = [|
    0|]

let yytransl_block = [|
  257 (* TUnknown *);
  258 (* TCommentSpace *);
  259 (* TCommentNewline *);
  260 (* TComment *);
  261 (* TInt *);
  262 (* TFloat *);
  263 (* TChar *);
  264 (* TString *);
  265 (* TQuote *);
  266 (* TPct *);
  267 (* TFormat *);
  268 (* TSubString *);
  269 (* TDecimal *);
  270 (* TIdent *);
  271 (* TKRParam *);
  272 (* Tconstructorname *);
  273 (* TypedefIdent *);
  274 (* TOPar *);
  275 (* TCPar *);
  276 (* TOBrace *);
  277 (* TCBrace *);
  278 (* TOCro *);
  279 (* TCCro *);
  280 (* TDot *);
  281 (* TComma *);
  282 (* TPtrOp *);
  283 (* TInc *);
  284 (* TDec *);
  285 (* TAssign *);
  286 (* TEq *);
  287 (* TWhy *);
  288 (* TTilde *);
  289 (* TBang *);
  290 (* TEllipsis *);
  291 (* TDotDot *);
  292 (* TPtVirg *);
  293 (* TOrLog *);
  294 (* TAndLog *);
  295 (* TOr *);
  296 (* TXor *);
  297 (* TAnd *);
  298 (* TEqEq *);
  299 (* TNotEq *);
  300 (* TInf *);
  301 (* TSup *);
  302 (* TInfEq *);
  303 (* TSupEq *);
  304 (* TShl *);
  305 (* TShr *);
  306 (* TPlus *);
  307 (* TMinus *);
  308 (* TMul *);
  309 (* TDiv *);
  310 (* TMod *);
  311 (* TMax *);
  312 (* TMin *);
  313 (* Tchar *);
  314 (* Tshort *);
  315 (* Tint *);
  316 (* Tdouble *);
  317 (* Tfloat *);
  318 (* Tlong *);
  319 (* Tunsigned *);
  320 (* Tsigned *);
  321 (* Tvoid *);
  322 (* Tsize_t *);
  323 (* Tssize_t *);
  324 (* Tptrdiff_t *);
  325 (* Tauto *);
  326 (* Tregister *);
  327 (* Textern *);
  328 (* Tstatic *);
  329 (* Ttypedef *);
  330 (* Tconst *);
  331 (* Tvolatile *);
  332 (* Tstruct *);
  333 (* Tunion *);
  334 (* Tenum *);
  335 (* Tdecimal *);
  336 (* Texec *);
  337 (* Tbreak *);
  338 (* Telse *);
  339 (* Tswitch *);
  340 (* Tcase *);
  341 (* Tcontinue *);
  342 (* Tfor *);
  343 (* Tdo *);
  344 (* Tif *);
  345 (* Twhile *);
  346 (* Treturn *);
  347 (* Tgoto *);
  348 (* Tdefault *);
  349 (* Tsizeof *);
  350 (* Tnew *);
  351 (* Tdelete *);
  352 (* Tdefined *);
  353 (* TOParCplusplusInit *);
  354 (* Tnamespace *);
  355 (* Trestrict *);
  356 (* Tasm *);
  357 (* Tattribute *);
  358 (* TattributeNoarg *);
  359 (* Tinline *);
  360 (* Ttypeof *);
  361 (* TDefine *);
  362 (* TDefParamVariadic *);
  363 (* TCppEscapedNewline *);
  364 (* TCppConcatOp *);
  365 (* TOParDefine *);
  366 (* TOBraceDefineInit *);
  367 (* TIdentDefine *);
  368 (* TDefEOL *);
  369 (* TInclude *);
  370 (* TIncludeStart *);
  371 (* TIncludeFilename *);
  372 (* TIfdef *);
  373 (* TIfdefelif *);
  374 (* TIfdefelse *);
  375 (* TEndif *);
  376 (* TIfdefBool *);
  377 (* TIfdefMisc *);
  378 (* TIfdefVersion *);
  379 (* TUifdef *);
  380 (* TUelseif *);
  381 (* TUendif *);
  382 (* TUndef *);
  383 (* TPragma *);
  384 (* TCppDirectiveOther *);
  385 (* TMacroAttr *);
  386 (* TMacroStmt *);
  387 (* TMacroIdentBuilder *);
  388 (* TMacroString *);
  389 (* TMacroDecl *);
  390 (* TMacroDeclConst *);
  391 (* TMacroIterator *);
  392 (* TCommentSkipTagStart *);
  393 (* TCommentSkipTagEnd *);
  394 (* TCParEOL *);
  395 (* TAction *);
  396 (* TCommentMisc *);
  397 (* TCommentCpp *);
    0 (* EOF *);
  398 (* TTODO *);
    0|]

let yylhs = "\255\255\
\001\000\006\000\006\000\006\000\008\000\008\000\009\000\010\000\
\010\000\012\000\012\000\012\000\011\000\011\000\011\000\013\000\
\013\000\004\000\004\000\015\000\015\000\015\000\016\000\016\000\
\018\000\018\000\018\000\018\000\018\000\018\000\018\000\018\000\
\018\000\018\000\018\000\018\000\018\000\018\000\018\000\018\000\
\018\000\018\000\018\000\018\000\018\000\017\000\017\000\020\000\
\020\000\020\000\020\000\020\000\020\000\020\000\020\000\020\000\
\020\000\020\000\025\000\025\000\025\000\025\000\025\000\025\000\
\024\000\024\000\024\000\024\000\024\000\024\000\024\000\023\000\
\023\000\023\000\023\000\023\000\023\000\023\000\023\000\023\000\
\023\000\028\000\028\000\028\000\028\000\028\000\028\000\028\000\
\028\000\028\000\028\000\028\000\031\000\031\000\035\000\035\000\
\036\000\037\000\037\000\037\000\040\000\040\000\040\000\039\000\
\041\000\044\000\021\000\022\000\003\000\045\000\045\000\045\000\
\045\000\045\000\045\000\045\000\045\000\045\000\045\000\046\000\
\046\000\046\000\046\000\053\000\053\000\055\000\055\000\055\000\
\034\000\057\000\057\000\059\000\059\000\059\000\060\000\060\000\
\060\000\060\000\060\000\047\000\047\000\048\000\048\000\048\000\
\048\000\048\000\049\000\049\000\049\000\049\000\049\000\049\000\
\049\000\049\000\050\000\050\000\050\000\050\000\050\000\050\000\
\032\000\032\000\051\000\051\000\065\000\067\000\067\000\067\000\
\067\000\067\000\052\000\052\000\052\000\052\000\069\000\069\000\
\069\000\069\000\070\000\070\000\068\000\071\000\071\000\071\000\
\071\000\071\000\071\000\071\000\071\000\071\000\071\000\071\000\
\071\000\071\000\071\000\071\000\071\000\071\000\071\000\071\000\
\071\000\071\000\071\000\071\000\071\000\071\000\071\000\071\000\
\071\000\071\000\071\000\071\000\071\000\071\000\071\000\071\000\
\071\000\071\000\071\000\072\000\072\000\072\000\072\000\072\000\
\072\000\072\000\072\000\072\000\072\000\072\000\072\000\072\000\
\072\000\072\000\072\000\072\000\072\000\072\000\027\000\075\000\
\075\000\075\000\076\000\076\000\077\000\077\000\078\000\078\000\
\078\000\078\000\080\000\080\000\079\000\079\000\079\000\079\000\
\079\000\079\000\082\000\083\000\087\000\087\000\087\000\088\000\
\088\000\088\000\088\000\088\000\088\000\088\000\088\000\088\000\
\086\000\086\000\090\000\090\000\090\000\090\000\038\000\092\000\
\092\000\093\000\095\000\095\000\095\000\095\000\096\000\081\000\
\081\000\081\000\081\000\005\000\005\000\097\000\098\000\098\000\
\098\000\098\000\100\000\100\000\100\000\105\000\105\000\105\000\
\105\000\105\000\105\000\105\000\105\000\105\000\105\000\104\000\
\104\000\104\000\104\000\106\000\106\000\054\000\091\000\107\000\
\107\000\107\000\102\000\109\000\108\000\108\000\108\000\110\000\
\110\000\103\000\103\000\103\000\029\000\029\000\114\000\114\000\
\114\000\114\000\114\000\116\000\116\000\116\000\030\000\030\000\
\117\000\117\000\117\000\122\000\122\000\122\000\122\000\123\000\
\123\000\123\000\123\000\123\000\124\000\124\000\126\000\126\000\
\126\000\127\000\127\000\073\000\118\000\130\000\128\000\129\000\
\120\000\120\000\074\000\074\000\074\000\135\000\135\000\136\000\
\061\000\138\000\138\000\139\000\139\000\137\000\137\000\137\000\
\140\000\141\000\141\000\143\000\143\000\142\000\142\000\062\000\
\062\000\062\000\062\000\062\000\062\000\145\000\145\000\145\000\
\144\000\144\000\144\000\144\000\144\000\144\000\144\000\144\000\
\144\000\144\000\144\000\144\000\148\000\148\000\148\000\148\000\
\148\000\063\000\063\000\063\000\063\000\063\000\063\000\063\000\
\149\000\149\000\149\000\149\000\007\000\007\000\002\000\002\000\
\002\000\002\000\002\000\002\000\002\000\002\000\056\000\058\000\
\132\000\134\000\112\000\113\000\119\000\121\000\084\000\085\000\
\033\000\033\000\064\000\064\000\066\000\066\000\026\000\026\000\
\101\000\101\000\146\000\146\000\131\000\131\000\125\000\125\000\
\133\000\133\000\099\000\099\000\089\000\089\000\042\000\042\000\
\043\000\043\000\014\000\014\000\014\000\115\000\115\000\150\000\
\150\000\094\000\111\000\147\000\147\000\019\000\019\000\000\000\
\000\000\000\000\000\000\000\000"

let yylen = "\002\000\
\002\000\000\000\002\000\006\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\003\000\002\000\004\000\001\000\
\003\000\001\000\003\000\001\000\003\000\003\000\001\000\005\000\
\001\000\003\000\003\000\003\000\003\000\003\000\003\000\003\000\
\003\000\003\000\003\000\003\000\003\000\003\000\003\000\003\000\
\003\000\003\000\003\000\003\000\003\000\001\000\004\000\001\000\
\002\000\002\000\002\000\002\000\004\000\002\000\005\000\002\000\
\002\000\004\000\004\000\003\000\004\000\003\000\001\000\004\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\004\000\004\000\003\000\003\000\003\000\002\000\002\000\005\000\
\007\000\001\000\001\000\001\000\001\000\003\000\001\000\001\000\
\003\000\001\000\002\000\003\000\000\000\002\000\002\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\002\000\005\000\006\000\001\000\004\000\003\000\
\004\000\006\000\003\000\001\000\001\000\002\000\003\000\002\000\
\003\000\000\000\001\000\001\000\001\000\002\000\001\000\001\000\
\001\000\001\000\001\000\001\000\002\000\005\000\007\000\005\000\
\009\000\011\000\005\000\007\000\006\000\007\000\006\000\007\000\
\005\000\004\000\002\000\001\000\001\000\001\000\002\000\003\000\
\001\000\001\000\002\000\001\000\002\000\001\000\004\000\007\000\
\001\000\000\000\000\000\004\000\003\000\002\000\000\000\003\000\
\003\000\004\000\000\000\003\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\006\000\004\000\001\000\004\000\004\000\001\000\001\000\
\001\000\001\000\003\000\001\000\002\000\001\000\001\000\002\000\
\002\000\003\000\001\000\001\000\001\000\003\000\003\000\004\000\
\003\000\004\000\001\000\001\000\001\000\001\000\002\000\003\000\
\002\000\003\000\003\000\004\000\002\000\003\000\003\000\004\000\
\001\000\003\000\001\000\002\000\002\000\001\000\001\000\001\000\
\002\000\001\000\001\000\001\000\002\000\002\000\001\000\001\000\
\001\000\002\000\002\000\001\000\002\000\001\000\002\000\003\000\
\006\000\008\000\002\000\001\000\000\000\001\000\001\000\001\000\
\001\000\001\000\002\000\002\000\002\000\002\000\002\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\003\000\004\000\001\000\001\000\001\000\002\000\002\000\004\000\
\005\000\001\000\004\000\002\000\001\000\003\000\001\000\004\000\
\002\000\003\000\003\000\002\000\003\000\005\000\001\000\000\000\
\005\000\004\000\002\000\001\000\001\000\002\000\002\000\001\000\
\001\000\005\000\001\000\001\000\003\000\002\000\001\000\002\000\
\003\000\001\000\002\000\001\000\001\000\001\000\001\000\001\000\
\001\000\000\000\005\000\006\000\002\000\001\000\003\000\001\000\
\001\000\001\000\002\000\001\000\002\000\002\000\003\000\003\000\
\001\000\002\000\001\000\003\000\004\000\001\000\002\000\002\000\
\004\000\007\000\003\000\004\000\001\000\003\000\002\000\001\000\
\001\000\001\000\001\000\001\000\002\000\002\000\001\000\005\000\
\006\000\004\000\005\000\000\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\005\000\005\000\004\000\002\000\001\000\001\000\005\000\001\000\
\001\000\001\000\001\000\005\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\002\000\001\000\002\000\001\000\003\000\001\000\003\000\
\001\000\003\000\001\000\002\000\001\000\002\000\001\000\003\000\
\001\000\003\000\001\000\003\000\001\000\003\000\001\000\002\000\
\000\000\002\000\000\000\001\000\003\000\001\000\002\000\001\000\
\002\000\001\000\001\000\001\000\000\000\001\000\000\000\002\000\
\002\000\002\000\002\000\002\000"

let yydefred = "\000\000\
\002\000\000\000\000\000\000\000\000\000\000\000\232\001\000\000\
\007\000\000\000\236\000\181\001\221\000\228\000\222\000\224\000\
\223\000\229\000\231\000\230\000\220\000\225\000\226\000\227\000\
\058\001\059\001\057\001\056\001\061\001\240\000\241\000\000\000\
\000\000\000\000\000\000\000\000\242\000\000\000\000\000\000\000\
\000\000\000\000\000\000\162\001\164\001\163\001\165\001\166\001\
\167\001\168\001\000\000\000\000\141\001\244\000\182\001\233\001\
\176\001\000\000\000\000\174\001\173\001\177\001\179\001\239\000\
\232\000\233\000\000\000\000\000\000\000\062\001\000\000\000\000\
\063\001\000\000\108\001\000\000\109\001\121\001\000\000\129\001\
\131\001\178\001\083\000\084\000\087\000\000\000\000\000\088\000\
\000\000\011\000\000\000\183\001\000\000\000\000\069\000\070\000\
\140\000\071\000\065\000\067\000\068\000\066\000\000\000\157\000\
\000\000\000\000\156\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\118\000\000\000\000\000\000\000\234\001\000\000\082\000\
\000\000\000\000\018\000\020\000\000\000\000\000\046\000\000\000\
\000\000\000\000\072\000\000\000\111\000\109\000\110\000\112\000\
\113\000\114\000\000\000\000\000\000\000\000\000\009\000\236\001\
\000\000\000\000\031\001\000\000\000\000\001\000\003\000\191\001\
\000\000\224\001\094\001\000\000\095\001\005\000\006\000\185\001\
\000\000\000\000\000\000\000\000\000\000\000\000\060\001\054\001\
\000\000\000\000\136\001\000\000\000\000\000\000\172\001\052\001\
\053\001\055\001\000\000\039\001\252\000\251\000\253\000\000\000\
\000\000\000\000\000\000\000\000\068\001\000\000\211\001\130\001\
\000\000\043\001\051\001\189\001\000\000\000\000\126\001\122\001\
\124\001\000\000\000\000\000\000\000\000\096\000\000\000\000\000\
\000\000\000\000\000\000\049\000\000\000\050\000\000\000\000\000\
\106\000\025\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\012\000\155\000\000\000\052\000\000\000\000\000\
\000\000\000\000\000\000\063\000\056\000\000\000\057\000\000\000\
\000\000\014\000\000\000\000\000\000\000\000\000\141\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\078\000\079\000\051\000\161\000\
\162\000\193\001\000\000\115\000\000\000\000\000\000\000\136\000\
\000\000\135\000\133\000\000\000\131\000\000\000\137\000\138\000\
\139\000\029\001\030\001\000\000\000\000\000\000\000\000\038\001\
\000\000\037\001\000\000\019\001\192\001\213\001\132\001\000\000\
\000\000\023\001\000\000\225\001\000\000\120\001\000\000\209\001\
\000\000\000\000\002\000\000\000\000\000\243\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\139\001\000\000\203\001\000\000\000\000\
\000\000\101\000\102\000\201\001\103\000\105\000\000\000\000\000\
\000\000\227\001\070\001\000\000\000\000\003\001\000\000\000\000\
\032\001\033\001\248\000\000\000\000\000\040\001\067\001\000\000\
\000\000\000\000\000\000\097\001\000\000\099\001\100\001\000\000\
\000\000\110\001\096\001\205\001\000\000\000\000\128\001\123\001\
\127\001\125\001\097\000\095\000\086\000\094\000\016\000\000\000\
\089\000\092\000\000\000\216\000\217\000\219\000\218\000\000\000\
\213\000\208\000\209\000\206\000\207\000\212\000\189\000\190\000\
\192\000\191\000\210\000\211\000\000\000\200\000\199\000\204\000\
\205\000\203\000\193\000\194\000\198\000\197\000\196\000\195\000\
\202\000\201\000\182\000\183\000\184\000\185\000\186\000\188\000\
\187\000\215\000\214\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\125\000\123\000\
\124\000\000\000\000\000\000\000\000\000\098\000\000\000\199\001\
\099\000\100\000\104\000\000\000\000\000\000\000\000\000\000\000\
\157\001\158\001\160\001\161\001\159\001\000\000\220\001\000\000\
\000\000\019\000\120\000\021\000\022\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\026\000\027\000\
\030\000\029\000\028\000\108\000\000\000\075\000\000\000\000\000\
\076\000\077\000\194\001\000\000\000\000\000\000\184\001\129\000\
\134\000\013\001\000\000\009\001\000\000\000\000\000\000\000\000\
\000\000\002\000\133\001\000\000\000\000\000\000\000\000\026\001\
\020\001\021\001\000\000\000\000\000\000\000\000\235\000\000\000\
\000\000\000\000\000\000\195\001\000\000\238\000\237\000\000\000\
\000\000\000\000\000\000\000\000\187\001\000\000\000\000\000\000\
\079\001\000\000\000\000\077\001\000\000\222\001\150\001\149\001\
\137\001\143\001\000\000\140\001\204\001\218\001\000\000\000\000\
\171\001\254\000\000\000\000\000\004\001\000\000\255\000\001\001\
\000\000\034\001\035\001\250\000\212\001\000\000\074\001\065\001\
\000\000\000\000\000\000\000\000\111\001\102\001\000\000\000\000\
\207\001\000\000\000\000\190\001\090\001\206\001\071\001\000\000\
\000\000\000\000\000\000\000\000\119\000\174\000\000\000\000\000\
\121\000\000\000\000\000\000\000\000\000\000\000\000\000\060\000\
\000\000\062\000\000\000\216\001\000\000\000\000\000\000\058\000\
\000\000\000\000\000\000\015\000\000\000\154\000\000\000\000\000\
\000\000\047\000\074\000\073\000\000\000\008\001\010\001\014\001\
\011\001\000\000\015\001\000\000\000\000\018\001\214\001\025\001\
\000\000\210\001\186\001\115\001\119\001\000\000\175\001\000\000\
\000\000\169\000\000\000\197\001\196\001\180\001\000\000\000\000\
\000\000\000\000\000\000\084\001\000\000\000\000\000\000\188\001\
\000\000\081\001\000\000\223\001\142\001\169\001\170\001\202\001\
\000\000\000\000\000\001\002\001\066\001\000\000\076\001\000\000\
\089\001\000\000\107\001\000\000\101\001\000\000\112\001\104\001\
\017\000\000\000\173\000\000\000\000\000\000\000\000\000\144\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\147\000\
\059\000\061\000\000\000\200\001\064\000\116\000\000\000\000\000\
\221\001\153\000\024\000\080\000\000\000\012\001\016\001\004\000\
\116\001\234\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\085\001\000\000\083\001\078\001\000\000\000\000\082\001\
\072\001\000\000\000\000\041\001\000\000\000\000\208\001\105\001\
\180\000\000\000\000\000\000\000\172\000\122\000\149\000\000\000\
\151\000\000\000\000\000\000\000\117\000\000\000\000\000\181\000\
\000\000\000\000\198\001\000\000\000\000\138\001\000\000\228\001\
\152\001\080\001\073\001\075\001\000\000\098\001\000\000\176\000\
\177\000\150\000\152\000\148\000\143\000\000\000\081\000\167\000\
\000\000\000\000\086\001\042\001\178\000\000\000\000\000\000\000\
\000\000\145\000\000\000\000\000\168\000\146\000"

let yydgoto = "\006\000\
\007\000\056\000\199\001\127\000\152\000\008\000\159\000\048\002\
\125\001\128\000\151\000\130\000\144\001\222\001\131\000\132\000\
\133\000\134\000\231\001\135\000\136\000\253\001\137\000\138\000\
\243\000\207\001\059\000\139\000\050\002\029\002\215\000\140\000\
\076\001\141\000\216\000\140\001\208\001\099\001\210\001\100\001\
\101\001\211\001\102\001\191\002\142\000\143\000\144\000\145\000\
\146\000\147\000\077\001\188\001\200\001\201\001\043\001\148\000\
\044\001\008\002\045\001\046\001\061\000\048\001\049\001\035\002\
\036\002\155\002\156\002\009\003\199\002\099\002\189\001\064\000\
\065\000\066\000\067\000\068\000\192\000\193\000\194\000\195\000\
\116\001\111\001\071\002\055\001\063\001\064\001\011\002\057\001\
\065\001\066\001\067\001\025\002\026\002\163\000\155\000\156\000\
\058\001\070\000\196\000\071\000\103\001\121\001\080\002\175\000\
\073\000\074\000\197\000\198\000\199\000\107\001\108\001\051\002\
\170\002\052\002\053\002\054\002\075\000\076\000\206\000\129\001\
\093\002\077\000\130\001\131\001\088\002\089\002\090\002\091\002\
\192\002\132\001\133\001\170\000\071\001\148\002\072\001\073\001\
\078\000\211\000\212\000\079\000\080\000\200\000\081\000\091\001\
\095\001\096\001\017\003\223\001\082\000\164\000"

let yysindex = "\093\003\
\000\000\040\009\131\016\180\020\193\020\000\000\000\000\113\009\
\000\000\055\255\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\008\255\
\008\255\234\000\108\255\097\255\000\000\111\255\191\255\129\016\
\008\000\005\255\110\255\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\167\255\179\255\000\000\000\000\000\000\000\000\
\000\000\128\255\129\016\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\129\016\129\016\192\007\000\000\198\255\178\255\
\000\000\129\016\000\000\038\001\000\000\000\000\132\025\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\147\255\000\000\
\023\000\000\000\114\018\000\000\180\020\180\020\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\167\000\000\000\
\170\000\180\020\000\000\180\000\131\016\202\000\251\000\180\020\
\180\255\072\000\180\020\126\026\180\020\058\255\042\255\239\000\
\182\000\000\000\011\001\000\000\028\001\000\000\084\000\000\000\
\000\000\019\001\000\000\000\000\093\000\046\005\000\000\193\020\
\182\002\180\020\000\000\039\255\000\000\000\000\000\000\000\000\
\000\000\000\000\030\001\125\015\023\000\032\001\000\000\000\000\
\193\020\193\020\000\000\077\000\072\001\000\000\000\000\000\000\
\206\023\000\000\000\000\008\255\000\000\000\000\000\000\000\000\
\059\001\047\255\180\020\069\001\039\255\082\001\000\000\000\000\
\092\017\238\012\000\000\248\000\112\255\022\012\000\000\000\000\
\000\000\000\000\085\001\000\000\000\000\000\000\000\000\250\254\
\101\000\049\000\081\001\100\000\000\000\028\255\000\000\000\000\
\098\001\000\000\000\000\000\000\107\001\134\023\000\000\000\000\
\000\000\192\007\205\025\007\000\138\001\000\000\152\001\147\255\
\148\001\186\000\157\001\000\000\193\020\000\000\124\027\180\020\
\000\000\000\000\134\000\242\016\089\001\180\020\180\020\032\001\
\023\000\180\020\000\000\000\000\000\016\000\000\193\020\163\001\
\170\001\130\012\175\001\000\000\000\000\148\255\000\000\039\255\
\185\001\000\000\194\001\250\255\250\009\180\020\000\000\000\016\
\180\020\180\020\180\020\180\020\180\020\180\020\180\020\180\020\
\180\020\180\020\180\020\180\020\180\020\180\020\180\020\180\020\
\180\020\180\020\180\020\180\020\180\020\180\020\180\020\196\001\
\102\010\180\020\047\255\047\255\000\000\000\000\000\000\000\000\
\000\000\000\000\039\255\000\000\000\000\180\020\192\001\000\000\
\205\001\000\000\000\000\220\001\000\000\125\015\000\000\000\000\
\000\000\000\000\000\000\153\001\206\018\070\000\096\024\000\000\
\021\001\000\000\231\001\000\000\000\000\000\000\000\000\240\001\
\012\002\000\000\009\001\000\000\047\255\000\000\021\002\000\000\
\010\002\005\001\000\000\031\255\031\002\000\000\032\002\033\002\
\131\016\057\255\250\255\074\018\000\000\084\000\000\000\125\015\
\000\000\248\006\217\001\000\000\210\010\000\000\218\001\222\001\
\197\001\000\000\000\000\000\000\000\000\000\000\038\255\035\002\
\060\255\000\000\000\000\000\000\049\000\000\000\246\018\206\023\
\000\000\000\000\000\000\081\001\085\001\000\000\000\000\022\012\
\082\019\022\012\134\023\000\000\057\002\000\000\000\000\250\006\
\058\002\000\000\000\000\000\000\134\023\250\254\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\232\001\
\000\000\000\000\196\001\000\000\000\000\000\000\000\000\061\002\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\148\255\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\051\002\124\027\022\001\180\020\000\016\
\122\019\122\019\070\002\023\001\056\001\032\001\000\000\000\000\
\000\000\196\001\062\011\170\011\026\002\000\000\065\001\000\000\
\000\000\000\000\000\000\180\020\081\002\082\002\039\255\180\020\
\000\000\000\000\000\000\000\000\000\000\104\001\000\000\131\016\
\106\001\000\000\000\000\000\000\000\000\032\001\133\002\118\003\
\234\001\129\004\015\002\072\005\235\003\235\003\025\003\025\003\
\025\003\025\003\193\001\193\001\245\002\245\002\000\000\000\000\
\000\000\000\000\000\000\000\000\214\019\000\000\120\001\123\001\
\000\000\000\000\000\000\207\000\000\016\000\016\000\000\000\000\
\000\000\000\000\150\002\000\000\147\002\021\001\240\001\254\019\
\206\023\000\000\000\000\023\024\079\255\008\255\065\255\000\000\
\000\000\000\000\021\002\047\255\153\002\180\020\000\000\180\020\
\242\024\165\000\136\002\000\000\139\002\000\000\000\000\088\002\
\039\255\160\002\128\001\023\000\000\000\180\020\216\000\144\002\
\000\000\155\002\198\017\000\000\214\000\000\000\000\000\000\000\
\000\000\000\000\132\001\000\000\000\000\000\000\157\255\022\012\
\000\000\000\000\039\255\165\002\000\000\164\002\000\000\000\000\
\240\001\000\000\000\000\000\000\000\000\141\001\000\000\000\000\
\198\017\154\001\058\002\022\012\000\000\000\000\008\255\102\000\
\000\000\156\002\180\020\000\000\000\000\000\000\000\000\178\002\
\173\002\184\002\124\027\087\001\000\000\000\000\131\016\161\002\
\000\000\069\020\109\020\180\020\131\016\131\016\173\002\000\000\
\158\001\000\000\166\001\000\000\149\026\022\012\241\001\000\000\
\167\002\186\002\171\001\000\000\250\255\000\000\131\016\180\020\
\238\017\000\000\000\000\000\000\000\016\000\000\000\000\000\000\
\000\000\192\002\000\000\240\001\059\025\000\000\000\000\000\000\
\153\002\000\000\000\000\000\000\000\000\188\002\000\000\183\002\
\167\000\000\000\191\002\000\000\000\000\000\000\199\002\205\002\
\039\255\250\014\149\000\000\000\074\018\074\018\204\002\000\000\
\155\002\000\000\074\018\000\000\000\000\000\000\000\000\000\000\
\207\002\039\255\000\000\000\000\000\000\155\002\000\000\236\255\
\000\000\181\001\000\000\253\000\000\000\180\020\000\000\000\000\
\000\000\061\002\000\000\180\020\215\002\216\002\124\027\000\000\
\000\016\131\016\198\001\131\016\206\001\207\001\212\002\000\000\
\000\000\000\000\175\001\000\000\000\000\000\000\210\002\131\016\
\000\000\000\000\000\000\000\000\155\002\000\000\000\000\000\000\
\000\000\000\000\180\020\016\003\165\000\180\020\167\002\028\003\
\193\002\000\000\180\020\000\000\000\000\023\003\029\003\000\000\
\000\000\032\003\029\003\000\000\082\019\017\003\000\000\000\000\
\000\000\246\001\087\001\087\001\000\000\000\000\000\000\131\016\
\000\000\131\016\018\003\131\016\000\000\226\002\039\003\000\000\
\045\003\057\003\000\000\233\001\210\002\000\000\043\003\000\000\
\000\000\000\000\000\000\000\000\031\003\000\000\087\001\000\000\
\000\000\000\000\000\000\000\000\000\000\136\000\000\000\000\000\
\050\003\018\003\000\000\000\000\000\000\131\016\131\016\180\020\
\200\002\000\000\052\003\131\016\000\000\000\000"

let yyrindex = "\000\000\
\000\000\206\002\000\000\000\000\000\000\000\000\000\000\206\002\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\045\001\
\054\001\000\000\000\000\000\000\000\000\000\000\000\000\043\020\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\170\021\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\198\021\222\021\000\000\000\000\000\000\065\022\
\000\000\234\021\000\000\000\000\000\000\000\000\206\002\000\000\
\000\000\000\000\000\000\000\000\000\000\056\004\073\003\000\000\
\044\026\000\000\180\026\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\053\003\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\108\004\000\000\000\000\000\000\000\000\
\083\026\000\000\000\000\000\000\155\006\105\000\000\000\000\000\
\165\005\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\035\255\085\002\088\004\000\000\000\000\
\067\008\017\009\000\000\025\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\034\255\000\000\000\000\000\000\000\000\
\076\003\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\165\255\000\000\000\000\000\000\046\255\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\218\022\
\000\000\004\021\188\000\000\000\000\000\160\000\000\000\000\000\
\000\000\000\000\000\000\000\000\194\003\071\003\000\000\000\000\
\000\000\000\000\206\002\000\000\000\000\000\000\000\000\073\003\
\000\000\000\000\000\000\000\000\000\000\000\000\066\003\000\000\
\000\000\000\000\000\000\206\002\000\000\000\000\000\000\067\003\
\226\004\000\000\000\000\000\000\206\002\000\000\000\000\000\000\
\123\005\000\000\203\005\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\235\001\000\000\000\000\000\000\206\002\
\000\000\000\000\069\003\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\018\005\000\000\143\022\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\255\000\000\000\000\
\000\000\000\000\000\000\169\024\000\000\031\000\000\000\000\000\
\062\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\090\003\000\000\067\255\000\000\000\000\000\000\155\003\000\000\
\017\002\000\000\000\000\159\003\000\000\000\000\000\000\000\000\
\000\000\000\000\235\001\000\000\113\013\070\003\244\013\206\002\
\119\014\074\003\000\000\000\000\000\000\000\000\000\000\078\003\
\046\255\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\057\023\104\021\000\000\000\000\000\000\
\000\000\000\000\000\000\064\002\000\000\000\000\000\000\243\001\
\000\000\243\001\071\003\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\160\003\040\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\214\002\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\012\027\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\066\003\000\000\000\000\206\002\
\000\000\000\000\000\000\000\000\000\000\147\003\000\000\000\000\
\000\000\000\000\000\000\000\000\020\002\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\157\003\000\000\039\008\
\166\003\016\008\199\001\057\001\194\004\245\007\097\007\133\007\
\177\007\215\007\017\007\049\007\113\006\193\006\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\207\255\224\255\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\089\000\000\000\000\000\
\000\000\000\000\000\000\000\000\169\024\088\255\109\255\000\000\
\000\000\000\000\155\003\172\003\000\000\000\000\000\000\000\000\
\206\002\200\000\176\003\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\244\005\000\000\000\000\000\000\000\000\
\000\000\155\003\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\046\255\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\243\001\000\000\000\000\033\000\000\000\
\000\000\179\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\066\003\068\027\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\027\006\000\000\
\000\000\000\000\000\000\000\000\000\000\243\001\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\240\255\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\206\002\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\215\000\
\000\000\000\000\189\255\000\000\000\000\000\000\000\000\000\000\
\000\000\165\255\000\000\000\000\000\000\172\003\000\000\000\000\
\155\003\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\155\003\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\012\027\000\000\000\000\000\000\000\000\066\003\000\000\
\206\002\000\000\000\000\000\000\000\000\000\000\151\008\000\000\
\000\000\000\000\075\006\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\155\003\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\200\000\000\000\084\003\000\000\
\000\000\000\000\000\000\000\000\000\000\086\003\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\068\027\068\027\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\087\003\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\068\027\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\094\003\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000"

let yygindex = "\000\000\
\000\000\000\000\005\000\012\000\187\255\219\254\207\004\235\255\
\255\255\249\000\253\255\247\255\000\000\127\003\098\255\021\000\
\138\000\125\008\000\000\050\000\235\000\228\254\000\000\000\000\
\101\002\093\255\133\000\000\000\160\254\002\255\004\004\123\255\
\081\004\192\255\000\000\000\000\000\000\138\009\000\000\004\254\
\000\000\022\003\125\003\162\255\000\000\000\000\069\255\000\000\
\000\000\000\000\036\255\096\254\030\255\002\000\000\000\000\000\
\000\000\000\000\094\255\095\255\114\255\042\000\044\000\000\000\
\240\002\000\000\047\002\237\001\146\253\098\002\000\000\000\000\
\000\000\000\000\066\010\246\255\089\255\149\255\081\255\000\000\
\000\000\000\000\224\002\004\000\218\254\235\254\137\255\237\254\
\000\000\000\000\001\000\000\000\000\000\225\255\000\000\135\255\
\000\000\000\000\000\000\000\000\186\254\112\002\054\002\003\000\
\178\001\000\000\000\000\000\000\183\003\000\000\167\003\177\254\
\220\253\107\255\000\000\250\002\000\000\000\000\100\004\184\003\
\225\002\000\000\000\000\000\000\000\000\121\002\000\000\220\002\
\122\002\178\003\000\000\144\004\245\003\170\002\033\003\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\154\002\
\000\000\000\000\000\000\194\002\000\000\000\000"

let yytablesize = 7380
let yytable = "\129\000\
\058\000\165\000\069\000\060\000\072\000\047\001\034\001\126\000\
\069\000\060\000\072\000\227\000\169\000\161\000\207\000\150\000\
\088\001\109\001\080\001\104\001\132\000\162\000\162\000\098\001\
\036\001\019\002\219\000\214\001\102\002\227\001\005\001\050\001\
\051\001\015\002\014\002\089\001\056\001\033\002\032\001\034\001\
\193\001\081\002\134\001\062\000\183\002\063\000\032\001\226\001\
\054\001\078\002\226\001\082\002\226\001\226\001\205\000\130\000\
\063\002\119\001\226\001\248\000\233\000\006\001\064\002\090\000\
\217\001\034\002\024\001\176\002\226\001\226\001\217\001\149\000\
\160\000\072\002\041\002\246\000\074\001\067\002\149\000\210\000\
\208\000\072\000\021\002\206\001\128\001\022\001\053\001\115\001\
\007\001\225\001\073\002\022\001\149\000\105\001\206\001\226\001\
\021\002\010\002\228\001\229\001\053\001\223\000\218\000\236\000\
\023\000\129\000\024\001\079\001\039\000\235\000\172\000\132\000\
\024\001\229\000\034\001\178\000\249\000\255\001\097\002\189\000\
\209\000\212\002\206\001\232\000\120\001\171\000\225\000\005\001\
\173\000\093\001\190\000\042\002\045\001\005\001\068\002\106\001\
\054\000\153\000\041\001\009\002\024\003\025\003\220\000\222\000\
\129\000\182\000\135\001\137\001\069\000\042\001\072\000\147\001\
\040\001\068\001\120\000\022\002\213\000\003\002\214\000\047\001\
\070\001\149\000\033\001\183\000\238\000\120\000\235\000\045\001\
\037\003\202\001\033\001\226\001\120\000\111\002\129\000\065\002\
\092\000\123\000\090\001\087\001\072\000\055\002\085\001\217\001\
\114\001\059\002\120\000\247\000\123\000\086\001\206\001\225\000\
\174\002\233\000\195\002\123\000\090\000\112\001\003\002\004\002\
\054\001\047\001\018\003\024\002\022\001\134\001\020\003\165\000\
\174\000\123\000\169\002\210\000\136\001\072\000\013\002\023\002\
\087\002\098\001\079\002\098\001\005\001\105\002\094\001\165\000\
\179\000\024\001\056\002\128\000\210\000\194\001\072\000\234\000\
\136\002\129\000\139\002\190\001\141\002\210\000\023\002\072\000\
\182\002\196\001\197\001\226\000\126\000\198\001\005\001\126\001\
\244\000\127\001\122\002\140\002\129\000\138\001\245\000\120\000\
\210\000\128\001\072\000\014\002\127\000\106\002\107\002\217\001\
\076\002\119\001\218\001\128\001\153\000\186\002\230\001\244\002\
\070\002\001\002\002\002\031\001\156\001\180\000\123\000\235\000\
\235\000\177\000\092\000\219\001\145\002\153\000\153\000\120\000\
\221\002\181\000\180\002\227\001\041\001\000\002\253\002\113\002\
\115\002\045\001\129\000\036\001\206\001\206\001\069\000\042\001\
\072\000\005\001\040\001\167\002\226\000\153\000\123\000\202\000\
\041\000\106\001\225\000\070\001\017\002\191\000\128\000\220\001\
\069\001\235\000\160\000\106\001\106\001\069\001\110\001\221\000\
\221\000\225\000\201\000\069\001\160\002\129\000\041\001\126\000\
\006\001\034\001\153\000\045\001\129\000\040\002\006\001\052\001\
\069\000\042\001\072\000\053\001\040\001\239\000\052\001\127\000\
\104\002\153\000\053\001\221\001\045\001\223\002\177\002\109\001\
\049\002\075\002\237\000\007\001\254\000\104\001\247\000\042\000\
\112\001\007\001\149\000\153\000\045\001\189\000\187\000\255\000\
\043\000\001\001\002\001\023\000\117\001\023\000\188\002\023\000\
\190\000\023\000\217\000\225\000\051\000\052\000\053\000\118\001\
\069\001\189\002\023\000\023\000\023\000\226\000\226\000\226\000\
\226\000\226\000\226\000\226\000\226\000\226\000\226\000\226\000\
\226\000\226\000\226\000\226\000\226\000\226\000\226\000\226\000\
\226\000\098\001\105\002\034\001\126\001\081\002\127\001\191\001\
\192\001\023\002\239\002\234\002\152\002\006\001\126\001\226\000\
\127\001\138\002\009\000\191\000\009\000\098\001\235\002\243\002\
\064\001\191\000\153\002\224\000\129\000\034\001\226\000\149\002\
\210\000\150\002\072\000\064\001\232\002\228\000\043\000\006\001\
\007\001\247\000\191\000\103\001\145\001\247\000\247\000\163\002\
\120\000\247\000\254\000\225\000\247\000\242\002\103\001\098\001\
\023\000\176\000\170\000\230\000\129\000\226\000\007\003\119\002\
\170\000\219\002\007\001\123\002\126\002\166\000\254\002\123\000\
\167\000\166\000\170\000\046\002\184\000\047\002\213\001\166\000\
\191\001\133\002\023\000\171\002\185\000\186\000\144\002\166\000\
\226\000\166\000\167\000\203\000\250\000\168\000\175\002\153\000\
\088\001\129\000\129\000\038\003\039\003\210\000\210\000\072\000\
\072\000\153\000\149\000\162\000\231\000\251\000\187\000\236\002\
\237\002\017\002\070\001\089\001\087\002\240\002\149\000\031\002\
\235\000\164\002\021\002\034\001\252\000\032\002\053\001\085\002\
\154\002\069\000\060\000\072\000\225\000\189\000\160\000\247\000\
\103\002\109\002\016\002\247\000\034\001\253\000\254\000\254\000\
\190\000\189\000\225\000\166\000\225\000\000\001\167\000\187\002\
\254\000\204\000\092\001\191\000\190\000\092\001\247\000\249\000\
\092\001\036\001\225\000\093\001\008\003\247\000\093\001\049\002\
\226\000\093\001\110\002\041\000\162\000\041\000\168\000\041\000\
\254\000\041\000\191\000\117\002\008\000\059\001\079\002\041\000\
\075\001\118\002\041\000\041\000\041\000\041\000\041\000\041\000\
\041\000\041\000\149\000\129\000\078\001\049\002\187\000\092\001\
\120\000\129\000\129\000\200\002\196\002\191\000\197\002\225\000\
\198\002\207\002\208\002\122\001\120\000\203\002\205\002\206\002\
\191\000\189\000\124\002\129\000\127\002\189\000\204\000\123\000\
\125\002\129\000\118\002\218\002\190\000\210\000\130\002\072\000\
\190\000\008\003\131\002\123\000\015\003\069\000\060\000\072\000\
\118\002\132\002\162\002\254\000\139\001\049\002\173\002\228\002\
\125\002\226\000\030\000\031\000\118\002\100\002\129\000\181\002\
\141\001\143\001\090\001\087\001\072\000\064\002\085\001\226\000\
\041\000\226\000\052\001\010\002\184\002\086\001\053\001\146\001\
\209\002\195\001\064\002\037\000\203\001\039\000\118\002\226\000\
\210\002\049\002\049\002\204\001\226\000\216\002\118\002\049\002\
\120\000\189\000\041\000\254\000\212\001\129\000\129\000\246\002\
\129\000\210\000\215\001\072\000\190\000\064\002\255\002\250\002\
\001\003\054\000\225\000\216\001\129\000\013\000\252\001\123\000\
\000\003\043\000\226\000\043\000\006\003\043\000\254\000\043\000\
\002\003\003\003\005\002\154\002\226\000\043\000\254\000\254\000\
\043\000\043\000\043\000\043\000\043\000\043\000\043\000\006\002\
\007\002\012\003\017\001\018\001\019\001\020\001\021\001\022\001\
\023\001\244\000\018\002\034\003\129\000\219\001\129\000\225\000\
\129\000\254\000\061\001\219\001\026\003\217\001\027\003\213\002\
\029\003\254\000\226\000\217\001\023\003\191\000\254\000\191\000\
\006\001\007\001\008\001\009\001\010\001\011\001\012\001\013\001\
\014\001\015\001\016\001\017\001\018\001\019\001\020\001\021\001\
\022\001\023\001\129\000\129\000\020\002\118\001\215\001\030\002\
\129\000\118\001\041\003\042\003\215\001\028\002\226\000\226\000\
\046\003\037\002\038\002\039\002\226\000\066\002\043\000\008\001\
\009\001\010\001\011\001\012\001\013\001\014\001\015\001\016\001\
\017\001\018\001\019\001\020\001\021\001\022\001\023\001\226\000\
\057\002\060\002\084\002\117\001\061\002\249\000\092\002\097\001\
\043\000\249\000\249\000\096\002\098\002\249\000\101\002\108\002\
\249\000\008\000\008\000\008\000\008\000\001\000\002\000\003\000\
\004\000\005\000\008\000\120\002\121\002\008\000\008\000\008\000\
\008\000\008\000\008\000\008\000\008\000\008\000\008\000\008\000\
\008\000\008\000\008\000\008\000\226\000\008\000\008\000\008\000\
\008\000\008\000\008\000\008\000\008\000\008\000\008\000\008\000\
\008\000\008\000\008\000\008\000\008\000\008\000\008\000\008\000\
\008\000\008\000\008\000\008\000\008\000\008\000\008\000\008\000\
\008\000\008\000\008\000\008\000\008\000\008\000\008\000\008\000\
\008\000\008\000\008\000\008\000\008\000\008\000\008\000\008\000\
\008\000\008\000\008\000\008\000\205\001\044\000\008\000\128\002\
\134\002\135\002\034\002\249\000\008\000\147\002\158\002\249\000\
\159\002\161\002\165\002\166\002\191\000\008\000\178\002\008\000\
\008\000\008\000\069\002\008\000\008\000\008\000\085\002\193\002\
\129\002\091\001\249\000\201\002\008\000\194\002\008\000\025\001\
\227\002\249\000\214\002\026\001\215\002\027\001\226\002\028\001\
\029\001\030\001\008\000\008\000\008\000\008\000\222\002\229\002\
\230\002\008\000\013\000\013\000\013\000\013\000\008\000\231\002\
\238\002\241\002\008\000\013\000\251\002\252\002\013\000\013\000\
\013\000\013\000\013\000\013\000\013\000\013\000\013\000\013\000\
\013\000\013\000\013\000\013\000\013\000\005\003\013\000\013\000\
\013\000\013\000\013\000\013\000\013\000\013\000\013\000\013\000\
\013\000\013\000\013\000\013\000\013\000\013\000\013\000\013\000\
\013\000\013\000\013\000\013\000\013\000\013\000\013\000\013\000\
\013\000\013\000\013\000\013\000\013\000\013\000\013\000\013\000\
\013\000\013\000\013\000\013\000\013\000\013\000\013\000\013\000\
\013\000\013\000\013\000\013\000\013\000\004\003\010\003\013\000\
\019\001\020\001\021\001\022\001\023\001\013\000\013\003\016\003\
\014\003\168\002\019\003\030\003\022\003\028\003\013\000\085\000\
\013\000\013\000\013\000\031\003\013\000\013\000\013\000\032\003\
\033\003\035\003\036\003\040\003\044\003\013\000\045\003\013\000\
\015\001\016\001\017\001\018\001\019\001\020\001\021\001\022\001\
\023\001\093\000\045\001\013\000\013\000\013\000\013\000\235\001\
\158\000\117\001\013\000\114\001\117\001\117\001\117\001\013\000\
\117\001\117\001\117\001\013\000\117\001\171\000\159\000\231\001\
\117\001\117\001\117\001\090\000\017\001\117\001\117\001\117\001\
\117\001\117\001\117\001\117\001\117\001\117\001\117\001\117\001\
\117\001\117\001\117\001\117\001\117\001\117\001\117\001\117\001\
\117\001\117\001\117\001\117\001\117\001\117\001\117\001\117\001\
\117\001\117\001\117\001\117\001\117\001\117\001\117\001\117\001\
\117\001\117\001\117\001\117\001\117\001\117\001\117\001\117\001\
\117\001\117\001\117\001\005\001\006\001\007\001\008\001\009\001\
\010\001\011\001\012\001\013\001\014\001\015\001\016\001\017\001\
\018\001\019\001\020\001\021\001\022\001\023\001\117\001\088\001\
\117\001\164\000\117\001\117\001\113\001\145\001\160\000\117\001\
\044\000\148\001\044\000\117\001\044\000\144\001\044\000\230\001\
\087\001\039\000\163\000\154\001\044\000\229\001\155\001\044\000\
\044\000\044\000\044\000\044\000\117\001\153\001\117\001\091\001\
\057\000\043\002\091\001\091\001\091\001\117\001\091\001\091\001\
\091\001\211\002\091\001\142\001\035\001\062\002\091\001\091\001\
\091\001\010\000\116\002\091\001\091\001\091\001\091\001\091\001\
\091\001\091\001\091\001\091\001\091\001\091\001\091\001\091\001\
\091\001\091\001\091\001\091\001\091\001\091\001\091\001\091\001\
\091\001\091\001\091\001\091\001\091\001\091\001\091\001\091\001\
\091\001\091\001\091\001\091\001\091\001\091\001\091\001\091\001\
\091\001\091\001\091\001\091\001\091\001\091\001\091\001\091\001\
\091\001\091\000\157\002\011\003\043\003\044\000\011\001\012\001\
\013\001\014\001\015\001\016\001\017\001\018\001\019\001\020\001\
\021\001\022\001\023\001\249\002\091\001\179\002\091\001\245\002\
\091\001\091\001\021\003\077\002\095\002\091\001\172\002\044\000\
\123\001\091\001\083\002\185\002\247\002\190\002\094\002\248\002\
\069\001\027\002\225\002\233\002\146\002\000\000\217\002\161\000\
\000\000\000\000\091\001\000\000\091\001\000\000\000\000\000\000\
\000\000\085\000\085\000\091\001\085\000\085\000\085\000\085\000\
\085\000\085\000\085\000\085\000\085\000\085\000\085\000\000\000\
\000\000\085\000\085\000\085\000\085\000\085\000\085\000\085\000\
\085\000\085\000\085\000\085\000\085\000\085\000\085\000\085\000\
\085\000\085\000\085\000\085\000\085\000\085\000\085\000\085\000\
\000\000\000\000\000\000\162\000\000\000\000\000\000\000\000\000\
\000\000\000\000\236\000\000\000\000\000\090\000\090\000\000\000\
\090\000\090\000\090\000\090\000\090\000\090\000\090\000\090\000\
\090\000\090\000\090\000\000\000\000\000\090\000\090\000\090\000\
\090\000\090\000\090\000\090\000\090\000\090\000\090\000\090\000\
\090\000\090\000\090\000\090\000\090\000\090\000\090\000\090\000\
\090\000\090\000\090\000\090\000\048\000\000\000\000\000\085\000\
\007\001\008\001\009\001\010\001\011\001\012\001\013\001\014\001\
\015\001\016\001\017\001\018\001\019\001\020\001\021\001\022\001\
\023\001\000\000\000\000\161\000\000\000\000\000\000\000\000\000\
\000\000\085\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\054\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\039\000\000\000\039\000\000\000\
\039\000\000\000\039\000\090\000\000\000\000\000\000\000\000\000\
\039\000\000\000\000\000\039\000\039\000\039\000\039\000\039\000\
\039\000\039\000\039\000\039\000\039\000\000\000\000\000\162\000\
\000\000\000\000\000\000\010\000\010\000\090\000\010\000\010\000\
\010\000\010\000\010\000\010\000\010\000\010\000\010\000\010\000\
\010\000\000\000\000\000\010\000\010\000\010\000\010\000\010\000\
\010\000\010\000\010\000\010\000\010\000\010\000\010\000\010\000\
\010\000\010\000\010\000\010\000\010\000\010\000\010\000\010\000\
\010\000\010\000\053\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\091\000\091\000\000\000\091\000\091\000\
\091\000\091\000\091\000\091\000\091\000\091\000\091\000\091\000\
\091\000\039\000\000\000\091\000\091\000\091\000\091\000\091\000\
\091\000\091\000\091\000\091\000\091\000\091\000\091\000\091\000\
\091\000\091\000\091\000\091\000\091\000\091\000\091\000\091\000\
\091\000\091\000\055\000\039\000\003\001\000\000\000\000\000\000\
\000\000\010\000\004\001\005\001\006\001\007\001\008\001\009\001\
\010\001\011\001\012\001\013\001\014\001\015\001\016\001\017\001\
\018\001\019\001\020\001\021\001\022\001\023\001\000\000\000\000\
\000\000\000\000\000\000\010\000\000\000\000\000\000\000\000\000\
\031\000\009\001\010\001\011\001\012\001\013\001\014\001\015\001\
\016\001\017\001\018\001\019\001\020\001\021\001\022\001\023\001\
\000\000\091\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\236\000\000\000\236\000\
\236\000\236\000\000\000\236\000\000\000\000\000\000\000\236\000\
\236\000\236\000\025\000\091\000\236\000\236\000\236\000\236\000\
\236\000\236\000\236\000\236\000\236\000\236\000\236\000\236\000\
\236\000\236\000\236\000\236\000\236\000\236\000\236\000\236\000\
\236\000\236\000\236\000\000\000\000\000\000\000\000\000\048\000\
\000\000\048\000\000\000\048\000\000\000\048\000\000\000\000\000\
\032\000\048\000\048\000\048\000\000\000\000\000\048\000\048\000\
\048\000\048\000\048\000\048\000\048\000\048\000\048\000\048\000\
\048\000\048\000\048\000\048\000\048\000\048\000\048\000\048\000\
\048\000\048\000\048\000\048\000\048\000\054\000\000\000\054\000\
\000\000\054\000\000\000\054\000\000\000\000\000\000\000\054\000\
\054\000\054\000\236\000\000\000\054\000\054\000\054\000\054\000\
\054\000\054\000\054\000\054\000\054\000\054\000\054\000\054\000\
\054\000\054\000\054\000\054\000\054\000\054\000\054\000\054\000\
\054\000\054\000\054\000\000\000\236\000\008\000\000\000\000\000\
\008\000\008\000\000\000\008\000\008\000\008\000\008\000\008\000\
\033\000\000\000\008\000\000\000\048\000\000\000\005\000\000\000\
\008\000\008\000\008\000\008\000\008\000\008\000\008\000\008\000\
\008\000\008\000\008\000\008\000\008\000\008\000\008\000\008\000\
\008\000\008\000\008\000\008\000\000\000\053\000\048\000\053\000\
\034\000\053\000\000\000\053\000\000\000\000\000\000\000\053\000\
\053\000\053\000\054\000\000\000\053\000\053\000\053\000\053\000\
\053\000\053\000\053\000\053\000\053\000\053\000\053\000\053\000\
\053\000\053\000\053\000\053\000\053\000\053\000\053\000\053\000\
\053\000\053\000\053\000\000\000\054\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\055\000\000\000\055\000\
\035\000\055\000\000\000\055\000\000\000\000\000\000\000\055\000\
\055\000\055\000\000\000\000\000\055\000\055\000\055\000\055\000\
\055\000\055\000\055\000\055\000\055\000\055\000\055\000\055\000\
\055\000\055\000\055\000\055\000\055\000\055\000\055\000\055\000\
\055\000\055\000\055\000\031\000\036\000\031\000\000\000\031\000\
\000\000\031\000\053\000\000\000\000\000\000\000\000\000\031\000\
\000\000\000\000\031\000\031\000\031\000\031\000\031\000\031\000\
\031\000\031\000\031\000\031\000\031\000\031\000\031\000\031\000\
\031\000\031\000\031\000\031\000\053\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\025\000\000\000\025\000\
\037\000\025\000\000\000\025\000\000\000\000\000\000\000\000\000\
\000\000\025\000\055\000\000\000\025\000\025\000\025\000\025\000\
\025\000\025\000\025\000\025\000\025\000\025\000\025\000\025\000\
\025\000\025\000\025\000\025\000\025\000\025\000\025\000\025\000\
\025\000\025\000\025\000\032\000\055\000\032\000\038\000\032\000\
\000\000\032\000\000\000\000\000\000\000\000\000\000\000\032\000\
\031\000\000\000\032\000\032\000\032\000\032\000\032\000\032\000\
\032\000\032\000\032\000\032\000\032\000\032\000\032\000\032\000\
\032\000\032\000\032\000\032\000\040\000\000\000\000\000\000\000\
\000\000\000\000\031\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\149\000\000\000\149\000\
\000\000\021\002\025\000\187\000\000\000\053\001\000\000\042\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\188\000\085\002\086\002\000\000\000\000\
\189\000\000\000\189\000\033\000\025\000\033\000\045\000\033\000\
\000\000\033\000\000\000\190\000\000\000\190\000\000\000\033\000\
\032\000\000\000\033\000\033\000\033\000\033\000\033\000\033\000\
\033\000\033\000\033\000\033\000\033\000\033\000\033\000\033\000\
\033\000\033\000\027\001\034\000\000\000\034\000\000\000\034\000\
\000\000\034\000\032\000\000\000\000\000\000\000\000\000\034\000\
\000\000\000\000\034\000\034\000\034\000\034\000\034\000\034\000\
\034\000\034\000\034\000\034\000\034\000\034\000\034\000\034\000\
\034\000\034\000\000\000\120\000\000\000\120\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\035\000\000\000\035\000\000\000\035\000\
\000\000\035\000\123\000\000\000\123\000\000\000\000\000\035\000\
\033\000\000\000\035\000\035\000\035\000\035\000\035\000\035\000\
\035\000\035\000\035\000\035\000\035\000\035\000\035\000\035\000\
\000\000\000\000\000\000\000\000\000\000\000\000\142\000\036\000\
\000\000\036\000\033\000\036\000\000\000\036\000\000\000\000\000\
\034\000\000\000\000\000\036\000\000\000\000\000\036\000\036\000\
\036\000\036\000\036\000\036\000\036\000\036\000\036\000\036\000\
\036\000\036\000\036\000\036\000\000\000\000\000\000\000\000\000\
\000\000\000\000\034\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\037\000\000\000\037\000\000\000\037\000\
\000\000\037\000\000\000\000\000\000\000\149\000\000\000\037\000\
\035\000\187\000\037\000\037\000\037\000\037\000\037\000\037\000\
\037\000\037\000\037\000\037\000\037\000\037\000\037\000\037\000\
\000\000\000\000\000\000\188\000\000\000\000\000\000\000\000\000\
\189\000\038\000\035\000\038\000\000\000\038\000\000\000\038\000\
\000\000\000\000\000\000\190\000\036\000\038\000\000\000\000\000\
\038\000\038\000\038\000\038\000\038\000\038\000\038\000\038\000\
\038\000\038\000\038\000\038\000\038\000\038\000\000\000\040\000\
\000\000\040\000\000\000\040\000\000\000\040\000\036\000\000\000\
\028\001\000\000\000\000\040\000\000\000\000\000\040\000\040\000\
\040\000\040\000\040\000\040\000\040\000\040\000\040\000\040\000\
\037\000\000\000\042\000\000\000\042\000\000\000\042\000\055\000\
\042\000\000\000\000\000\120\000\000\000\000\000\042\000\000\000\
\000\000\042\000\042\000\042\000\042\000\042\000\042\000\000\000\
\000\000\045\000\037\000\045\000\000\000\045\000\000\000\045\000\
\000\000\000\000\123\000\000\000\000\000\045\000\038\000\000\000\
\045\000\045\000\045\000\045\000\000\000\000\000\000\000\000\000\
\027\001\000\000\000\000\000\000\027\001\027\001\000\000\000\000\
\027\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\038\000\000\000\000\000\000\000\040\000\027\001\027\001\000\000\
\000\000\000\000\000\000\027\001\000\000\000\000\000\000\000\000\
\158\000\000\000\000\000\000\000\000\000\000\000\027\001\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\040\000\042\000\
\232\001\233\001\234\001\235\001\236\001\237\001\238\001\239\001\
\240\001\241\001\242\001\243\001\244\001\245\001\246\001\247\001\
\248\001\249\001\250\001\251\001\000\000\000\000\045\000\000\000\
\000\000\042\000\000\000\142\000\142\000\142\000\142\000\142\000\
\000\000\000\000\000\000\142\000\142\000\000\000\142\000\142\000\
\142\000\000\000\142\000\142\000\000\000\000\000\027\001\000\000\
\045\000\142\000\142\000\000\000\000\000\000\000\142\000\142\000\
\000\000\000\000\142\000\000\000\142\000\000\000\000\000\142\000\
\000\000\000\000\000\000\000\000\000\000\027\001\000\000\000\000\
\142\000\142\000\142\000\000\000\000\000\000\000\000\000\142\000\
\142\000\142\000\142\000\142\000\142\000\142\000\142\000\142\000\
\142\000\142\000\142\000\142\000\142\000\142\000\142\000\142\000\
\142\000\142\000\142\000\142\000\142\000\142\000\142\000\142\000\
\000\000\142\000\142\000\142\000\142\000\142\000\142\000\142\000\
\142\000\142\000\142\000\142\000\142\000\142\000\142\000\000\000\
\000\000\142\000\142\000\142\000\000\000\142\000\142\000\142\000\
\000\000\000\000\142\000\000\000\000\000\000\000\142\000\000\000\
\142\000\000\000\142\000\142\000\142\000\142\000\142\000\142\000\
\142\000\142\000\000\000\142\000\142\000\142\000\142\000\142\000\
\142\000\142\000\142\000\142\000\000\000\142\000\028\001\000\000\
\000\000\000\000\028\001\028\001\000\000\000\000\028\001\000\000\
\000\000\000\000\062\001\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\028\001\028\001\009\000\000\000\010\000\
\011\000\028\001\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\028\001\000\000\154\000\000\000\
\000\000\000\000\000\000\012\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\013\000\014\000\015\000\016\000\017\000\018\000\019\000\020\000\
\021\000\022\000\023\000\024\000\025\000\026\000\027\000\028\000\
\029\000\030\000\031\000\032\000\033\000\034\000\035\000\000\000\
\000\000\000\000\000\000\209\001\028\001\000\000\000\000\000\000\
\010\000\011\000\000\000\000\000\000\000\000\000\209\001\000\000\
\000\000\036\000\037\000\038\000\039\000\000\000\040\000\041\000\
\042\000\000\000\000\000\028\001\000\000\000\000\000\000\000\000\
\000\000\043\000\000\000\044\000\045\000\046\000\047\000\048\000\
\049\000\050\000\209\001\000\000\000\000\051\000\052\000\053\000\
\054\000\013\000\014\000\015\000\016\000\017\000\018\000\019\000\
\020\000\021\000\022\000\023\000\024\000\025\000\026\000\027\000\
\028\000\029\000\030\000\031\000\032\000\033\000\034\000\035\000\
\062\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\154\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\157\000\037\000\000\000\039\000\000\000\040\000\
\041\000\000\000\154\000\154\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\209\001\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\054\000\154\000\000\000\000\000\000\000\000\000\000\000\
\000\000\062\001\000\000\000\000\000\000\000\000\083\000\084\000\
\085\000\086\000\087\000\000\000\113\001\000\000\088\000\149\000\
\060\001\000\000\011\000\091\000\224\001\000\000\000\000\154\000\
\000\000\000\000\000\000\000\000\093\000\094\000\000\000\000\000\
\000\000\095\000\096\000\000\000\000\000\000\000\154\000\098\000\
\000\000\000\000\099\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\100\000\101\000\102\000\000\000\000\000\
\154\000\000\000\013\000\014\000\015\000\016\000\017\000\018\000\
\019\000\020\000\021\000\022\000\023\000\024\000\025\000\026\000\
\027\000\028\000\029\000\030\000\031\000\032\000\033\000\034\000\
\035\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\209\001\209\001\115\000\116\000\
\117\000\118\000\000\000\000\000\037\000\000\000\039\000\000\000\
\040\000\041\000\000\000\000\000\000\000\120\000\000\000\000\000\
\000\000\000\000\083\000\084\000\085\000\086\000\087\000\000\000\
\000\000\000\000\088\000\149\000\060\001\000\000\011\000\091\000\
\254\001\000\000\054\000\000\000\123\000\124\000\000\000\000\000\
\093\000\094\000\000\000\000\000\205\001\095\000\096\000\000\000\
\000\000\000\000\000\000\098\000\000\000\000\000\099\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\100\000\
\101\000\102\000\062\001\000\000\000\000\143\002\013\000\014\000\
\015\000\016\000\017\000\018\000\019\000\020\000\021\000\022\000\
\023\000\024\000\025\000\026\000\027\000\028\000\029\000\030\000\
\031\000\032\000\033\000\034\000\035\000\074\002\000\000\000\000\
\000\000\000\000\000\000\000\000\154\000\000\000\000\000\000\000\
\000\000\000\000\115\000\116\000\117\000\118\000\154\000\000\000\
\037\000\000\000\039\000\000\000\040\000\041\000\000\000\000\000\
\000\000\120\000\000\000\000\000\000\000\000\000\083\000\084\000\
\085\000\086\000\087\000\000\000\000\000\000\000\088\000\149\000\
\060\001\000\000\011\000\091\000\058\002\000\000\054\000\000\000\
\123\000\124\000\000\000\000\000\093\000\094\000\000\000\000\000\
\205\001\095\000\096\000\000\000\000\000\000\000\000\000\098\000\
\000\000\000\000\099\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\100\000\101\000\102\000\000\000\000\000\
\000\000\000\000\013\000\014\000\015\000\016\000\017\000\018\000\
\019\000\020\000\021\000\022\000\023\000\024\000\025\000\026\000\
\027\000\028\000\029\000\030\000\031\000\032\000\033\000\034\000\
\035\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\115\000\116\000\
\117\000\118\000\000\000\000\000\037\000\000\000\039\000\000\000\
\040\000\041\000\000\000\000\000\000\000\120\000\000\000\000\000\
\000\000\000\000\083\000\084\000\085\000\086\000\087\000\000\000\
\000\000\000\000\088\000\149\000\060\001\000\000\011\000\091\000\
\112\002\000\000\054\000\000\000\123\000\124\000\000\000\000\000\
\093\000\094\000\000\000\000\000\205\001\095\000\096\000\000\000\
\000\000\000\000\000\000\098\000\000\000\000\000\099\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\100\000\
\101\000\102\000\000\000\000\000\000\000\000\000\013\000\014\000\
\015\000\016\000\017\000\018\000\019\000\020\000\021\000\022\000\
\023\000\024\000\025\000\026\000\027\000\028\000\029\000\030\000\
\031\000\032\000\033\000\034\000\035\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\115\000\116\000\117\000\118\000\000\000\000\000\
\037\000\000\000\039\000\000\000\040\000\041\000\000\000\000\000\
\000\000\120\000\000\000\000\000\000\000\000\000\083\000\084\000\
\085\000\086\000\087\000\000\000\000\000\000\000\088\000\149\000\
\060\001\000\000\011\000\091\000\114\002\000\000\054\000\000\000\
\123\000\124\000\000\000\000\000\093\000\094\000\000\000\000\000\
\205\001\095\000\096\000\000\000\000\000\000\000\000\000\098\000\
\000\000\000\000\099\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\100\000\101\000\102\000\000\000\000\000\
\000\000\000\000\013\000\014\000\015\000\016\000\017\000\018\000\
\019\000\020\000\021\000\022\000\023\000\024\000\025\000\026\000\
\027\000\028\000\029\000\030\000\031\000\032\000\033\000\034\000\
\035\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\115\000\116\000\
\117\000\118\000\000\000\000\000\037\000\000\000\039\000\000\000\
\040\000\041\000\000\000\000\000\000\000\120\000\000\000\000\000\
\000\000\000\000\083\000\084\000\085\000\086\000\087\000\000\000\
\000\000\000\000\088\000\149\000\060\001\000\000\011\000\091\000\
\000\000\000\000\054\000\000\000\123\000\124\000\000\000\000\000\
\093\000\094\000\000\000\000\000\205\001\095\000\096\000\000\000\
\000\000\000\000\000\000\098\000\000\000\000\000\099\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\100\000\
\101\000\102\000\000\000\000\000\000\000\000\000\013\000\014\000\
\015\000\016\000\017\000\018\000\019\000\020\000\021\000\022\000\
\023\000\024\000\025\000\026\000\027\000\028\000\029\000\030\000\
\031\000\032\000\033\000\034\000\035\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\115\000\116\000\117\000\118\000\000\000\000\000\
\037\000\000\000\039\000\000\000\040\000\041\000\000\000\000\000\
\000\000\120\000\000\000\000\000\000\000\000\000\083\000\084\000\
\085\000\086\000\087\000\000\000\000\000\000\000\088\000\149\000\
\060\001\000\000\011\000\091\000\000\000\000\000\054\000\000\000\
\123\000\124\000\000\000\000\000\093\000\094\000\000\000\000\000\
\097\001\095\000\096\000\000\000\000\000\000\000\000\000\098\000\
\000\000\000\000\099\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\100\000\101\000\102\000\000\000\000\000\
\000\000\000\000\013\000\014\000\015\000\016\000\017\000\018\000\
\019\000\020\000\021\000\022\000\023\000\024\000\025\000\026\000\
\027\000\028\000\029\000\030\000\031\000\032\000\033\000\034\000\
\035\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\115\000\116\000\
\117\000\118\000\000\000\000\000\037\000\000\000\039\000\000\000\
\040\000\041\000\000\000\000\000\000\000\120\000\000\000\000\000\
\000\000\000\000\083\000\084\000\085\000\086\000\087\000\000\000\
\000\000\000\000\088\000\089\000\000\000\010\000\037\001\091\000\
\000\000\092\000\054\000\000\000\123\000\124\000\000\000\000\000\
\093\000\094\000\000\000\000\000\205\001\095\000\096\000\000\000\
\000\000\097\000\000\000\098\000\000\000\000\000\099\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\100\000\
\101\000\102\000\000\000\000\000\000\000\000\000\013\000\014\000\
\015\000\016\000\017\000\018\000\019\000\020\000\021\000\022\000\
\023\000\024\000\025\000\026\000\027\000\028\000\029\000\030\000\
\031\000\032\000\033\000\034\000\035\000\103\000\104\000\000\000\
\105\000\106\000\107\000\108\000\081\001\110\000\111\000\112\000\
\113\000\114\000\115\000\116\000\117\000\118\000\000\000\000\000\
\037\000\082\001\039\000\000\000\040\000\041\000\042\000\000\000\
\000\000\120\000\083\001\084\001\000\000\000\000\000\000\043\000\
\000\000\044\000\045\000\046\000\047\000\048\000\049\000\050\000\
\121\000\000\000\000\000\051\000\052\000\053\000\054\000\122\000\
\123\000\124\000\000\000\000\000\125\000\136\000\136\000\136\000\
\136\000\136\000\000\000\000\000\000\000\136\000\136\000\000\000\
\136\000\136\000\136\000\000\000\136\000\000\000\000\000\000\000\
\000\000\000\000\000\000\136\000\136\000\000\000\000\000\000\000\
\136\000\136\000\000\000\000\000\136\000\000\000\136\000\000\000\
\000\000\136\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\136\000\136\000\136\000\000\000\000\000\000\000\
\000\000\136\000\136\000\136\000\136\000\136\000\136\000\136\000\
\136\000\136\000\136\000\136\000\136\000\136\000\136\000\136\000\
\136\000\136\000\136\000\136\000\136\000\136\000\136\000\136\000\
\136\000\136\000\000\000\136\000\136\000\136\000\136\000\136\000\
\136\000\136\000\136\000\136\000\136\000\136\000\136\000\136\000\
\136\000\000\000\000\000\136\000\136\000\136\000\000\000\136\000\
\136\000\136\000\000\000\000\000\136\000\000\000\000\000\000\000\
\146\001\000\000\136\000\000\000\136\000\136\000\136\000\136\000\
\136\000\136\000\136\000\136\000\000\000\000\000\136\000\136\000\
\136\000\136\000\136\000\136\000\136\000\136\000\000\000\136\000\
\135\000\135\000\135\000\135\000\135\000\000\000\000\000\000\000\
\135\000\135\000\000\000\135\000\135\000\135\000\000\000\135\000\
\000\000\000\000\000\000\000\000\000\000\000\000\135\000\135\000\
\000\000\000\000\000\000\135\000\135\000\000\000\000\000\135\000\
\000\000\135\000\000\000\000\000\135\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\135\000\135\000\135\000\
\000\000\000\000\000\000\000\000\135\000\135\000\135\000\135\000\
\135\000\135\000\135\000\135\000\135\000\135\000\135\000\135\000\
\135\000\135\000\135\000\135\000\135\000\135\000\135\000\135\000\
\135\000\135\000\135\000\135\000\135\000\000\000\135\000\135\000\
\135\000\135\000\135\000\135\000\135\000\135\000\135\000\135\000\
\135\000\135\000\135\000\135\000\000\000\000\000\135\000\135\000\
\135\000\000\000\135\000\135\000\135\000\000\000\000\000\135\000\
\000\000\000\000\000\000\147\001\000\000\135\000\000\000\135\000\
\135\000\135\000\135\000\135\000\135\000\135\000\135\000\000\000\
\000\000\135\000\135\000\135\000\135\000\135\000\135\000\135\000\
\135\000\000\000\135\000\137\000\137\000\137\000\137\000\137\000\
\000\000\000\000\000\000\137\000\137\000\000\000\137\000\137\000\
\137\000\000\000\137\000\000\000\000\000\000\000\000\000\000\000\
\000\000\137\000\137\000\000\000\000\000\000\000\137\000\137\000\
\000\000\000\000\137\000\000\000\137\000\000\000\000\000\137\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\137\000\137\000\137\000\000\000\000\000\000\000\000\000\137\000\
\137\000\137\000\137\000\137\000\137\000\137\000\137\000\137\000\
\137\000\137\000\137\000\137\000\137\000\137\000\137\000\137\000\
\137\000\137\000\137\000\137\000\137\000\137\000\137\000\137\000\
\000\000\137\000\137\000\137\000\137\000\137\000\137\000\137\000\
\137\000\137\000\137\000\137\000\137\000\137\000\137\000\000\000\
\000\000\137\000\137\000\137\000\000\000\137\000\137\000\137\000\
\000\000\000\000\137\000\000\000\000\000\000\000\151\001\000\000\
\137\000\000\000\137\000\137\000\137\000\137\000\137\000\137\000\
\137\000\137\000\000\000\000\000\137\000\137\000\137\000\137\000\
\137\000\137\000\137\000\137\000\000\000\137\000\083\000\084\000\
\085\000\086\000\087\000\000\000\000\000\000\000\088\000\089\000\
\000\000\010\000\037\001\091\000\000\000\092\000\000\000\000\000\
\000\000\000\000\000\000\000\000\093\000\094\000\000\000\000\000\
\000\000\095\000\096\000\000\000\000\000\097\000\000\000\098\000\
\000\000\000\000\099\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\100\000\101\000\102\000\000\000\000\000\
\000\000\000\000\013\000\014\000\015\000\016\000\017\000\018\000\
\019\000\020\000\021\000\022\000\023\000\024\000\025\000\026\000\
\027\000\028\000\029\000\030\000\031\000\032\000\033\000\034\000\
\035\000\103\000\104\000\000\000\105\000\106\000\107\000\108\000\
\081\001\110\000\111\000\112\000\113\000\114\000\115\000\116\000\
\117\000\118\000\000\000\000\000\037\000\082\001\039\000\000\000\
\040\000\041\000\042\000\000\000\000\000\120\000\000\000\084\001\
\000\000\000\000\000\000\043\000\000\000\044\000\045\000\046\000\
\047\000\048\000\049\000\050\000\121\000\000\000\000\000\051\000\
\052\000\053\000\054\000\122\000\123\000\124\000\000\000\000\000\
\125\000\083\000\084\000\085\000\086\000\087\000\000\000\000\000\
\000\000\088\000\089\000\000\000\010\000\037\001\091\000\000\000\
\092\000\000\000\000\000\000\000\000\000\000\000\000\000\093\000\
\094\000\000\000\000\000\000\000\095\000\096\000\000\000\000\000\
\097\000\000\000\098\000\000\000\000\000\099\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\100\000\101\000\
\102\000\000\000\000\000\000\000\000\000\013\000\014\000\015\000\
\016\000\017\000\018\000\019\000\020\000\021\000\022\000\023\000\
\024\000\025\000\026\000\027\000\028\000\029\000\030\000\031\000\
\032\000\033\000\034\000\035\000\103\000\104\000\000\000\105\000\
\038\001\107\000\108\000\109\000\110\000\111\000\112\000\113\000\
\039\001\115\000\116\000\117\000\118\000\000\000\000\000\037\000\
\119\000\039\000\000\000\040\000\041\000\042\000\000\000\000\000\
\120\000\000\000\000\000\000\000\000\000\000\000\043\000\000\000\
\044\000\045\000\046\000\047\000\048\000\049\000\050\000\121\000\
\000\000\000\000\051\000\052\000\053\000\054\000\122\000\123\000\
\124\000\000\000\000\000\125\000\083\000\084\000\085\000\086\000\
\087\000\000\000\000\000\000\000\088\000\089\000\000\000\000\000\
\037\001\091\000\000\000\092\000\000\000\000\000\000\000\000\000\
\000\000\000\000\093\000\094\000\000\000\000\000\000\000\095\000\
\096\000\000\000\000\000\097\000\000\000\098\000\000\000\000\000\
\099\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\100\000\101\000\102\000\000\000\000\000\000\000\000\000\
\013\000\014\000\015\000\016\000\017\000\018\000\019\000\020\000\
\021\000\022\000\023\000\024\000\025\000\026\000\027\000\028\000\
\029\000\030\000\031\000\032\000\033\000\034\000\035\000\103\000\
\104\000\000\000\105\000\106\000\107\000\108\000\109\000\110\000\
\111\000\112\000\113\000\114\000\115\000\116\000\117\000\118\000\
\000\000\000\000\037\000\119\000\039\000\000\000\040\000\041\000\
\000\000\000\000\000\000\120\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\121\000\000\000\000\000\000\000\000\000\000\000\
\054\000\122\000\123\000\124\000\000\000\000\000\125\000\083\000\
\084\000\085\000\086\000\087\000\000\000\000\000\000\000\088\000\
\089\000\011\000\000\000\090\000\091\000\000\000\092\000\000\000\
\000\000\000\000\000\000\000\000\000\000\093\000\094\000\000\000\
\000\000\000\000\095\000\096\000\000\000\000\000\097\000\000\000\
\098\000\000\000\000\000\099\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\100\000\101\000\102\000\000\000\
\000\000\013\000\014\000\015\000\016\000\017\000\018\000\019\000\
\020\000\021\000\022\000\023\000\024\000\025\000\026\000\027\000\
\028\000\029\000\030\000\031\000\032\000\033\000\034\000\035\000\
\000\000\000\000\103\000\104\000\000\000\105\000\106\000\107\000\
\108\000\109\000\110\000\111\000\112\000\113\000\114\000\115\000\
\116\000\117\000\118\000\037\000\000\000\039\000\119\000\040\000\
\041\000\000\000\000\000\000\000\000\000\000\000\120\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\083\000\084\000\
\085\000\086\000\087\000\000\000\000\000\121\000\088\000\149\000\
\000\000\054\000\011\000\091\000\122\000\123\000\124\000\000\000\
\000\000\125\000\000\000\000\000\093\000\094\000\000\000\000\000\
\000\000\095\000\096\000\000\000\000\000\097\000\000\000\098\000\
\000\000\000\000\099\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\100\000\101\000\102\000\000\000\000\000\
\000\000\000\000\013\000\014\000\015\000\016\000\017\000\018\000\
\019\000\020\000\021\000\022\000\023\000\024\000\025\000\026\000\
\027\000\028\000\029\000\030\000\031\000\032\000\033\000\034\000\
\035\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\115\000\116\000\
\117\000\118\000\000\000\000\000\037\000\000\000\039\000\000\000\
\040\000\041\000\000\000\000\000\000\000\120\000\000\000\000\000\
\083\000\084\000\085\000\086\000\087\000\000\000\000\000\000\000\
\088\000\149\000\000\000\000\000\011\000\091\000\000\000\000\000\
\000\000\000\000\054\000\000\000\123\000\124\000\093\000\094\000\
\000\000\000\000\000\000\095\000\096\000\000\000\000\000\000\000\
\000\000\098\000\000\000\000\000\099\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\100\000\101\000\102\000\
\000\000\000\000\000\000\000\000\013\000\014\000\015\000\016\000\
\017\000\018\000\019\000\020\000\021\000\022\000\023\000\024\000\
\000\000\000\000\000\000\000\000\000\000\030\000\031\000\032\000\
\033\000\034\000\035\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\115\000\116\000\117\000\118\000\000\000\000\000\037\000\000\000\
\000\000\000\000\000\000\041\000\000\000\000\000\000\000\120\000\
\000\000\000\000\083\000\084\000\085\000\086\000\087\000\000\000\
\000\000\000\000\088\000\044\002\000\000\000\000\167\000\091\000\
\000\000\045\002\168\002\046\002\000\000\047\002\123\000\124\000\
\093\000\094\000\000\000\000\000\000\000\095\000\096\000\000\000\
\000\000\000\000\000\000\098\000\000\000\000\000\099\000\000\000\
\000\000\000\000\083\000\084\000\085\000\086\000\087\000\100\000\
\101\000\102\000\088\000\044\002\000\000\000\000\167\000\091\000\
\000\000\045\002\220\002\046\002\000\000\047\002\000\000\000\000\
\093\000\094\000\000\000\000\000\000\000\095\000\096\000\000\000\
\000\000\000\000\000\000\098\000\000\000\000\000\099\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\100\000\
\101\000\102\000\115\000\116\000\117\000\118\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\120\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\123\000\124\000\115\000\116\000\117\000\118\000\083\000\084\000\
\085\000\086\000\087\000\000\000\000\000\000\000\088\000\044\002\
\000\000\120\000\167\000\091\000\000\000\045\002\000\000\046\002\
\000\000\047\002\000\000\000\000\093\000\094\000\000\000\000\000\
\000\000\095\000\096\000\000\000\000\000\000\000\000\000\098\000\
\123\000\124\000\099\000\000\000\000\000\000\000\083\000\084\000\
\085\000\086\000\087\000\100\000\101\000\102\000\088\000\149\000\
\000\000\000\000\000\000\091\000\000\000\092\000\000\000\000\000\
\000\000\000\000\000\000\000\000\093\000\094\000\000\000\000\000\
\000\000\095\000\096\000\000\000\000\000\000\000\000\000\098\000\
\000\000\000\000\099\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\100\000\101\000\102\000\115\000\116\000\
\117\000\118\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\120\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\123\000\124\000\115\000\116\000\
\117\000\118\000\083\000\084\000\085\000\086\000\087\000\000\000\
\000\000\000\000\088\000\149\000\000\000\120\000\000\000\091\000\
\000\000\000\000\000\000\000\000\012\002\000\000\000\000\000\000\
\093\000\094\000\000\000\000\000\000\000\095\000\096\000\000\000\
\000\000\000\000\000\000\098\000\123\000\124\000\099\000\000\000\
\000\000\000\000\083\000\084\000\085\000\086\000\087\000\100\000\
\101\000\102\000\088\000\149\000\000\000\000\000\000\000\091\000\
\000\000\000\000\000\000\000\000\069\002\000\000\000\000\000\000\
\093\000\094\000\000\000\000\000\000\000\095\000\096\000\000\000\
\000\000\000\000\000\000\098\000\000\000\000\000\099\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\100\000\
\101\000\102\000\115\000\116\000\117\000\118\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\120\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\123\000\124\000\115\000\116\000\117\000\118\000\083\000\084\000\
\085\000\086\000\087\000\000\000\000\000\000\000\088\000\149\000\
\000\000\120\000\000\000\091\000\000\000\045\002\000\000\000\000\
\000\000\000\000\000\000\000\000\093\000\094\000\000\000\000\000\
\000\000\095\000\096\000\000\000\000\000\000\000\000\000\098\000\
\123\000\124\000\099\000\000\000\000\000\000\000\083\000\084\000\
\085\000\086\000\087\000\100\000\101\000\102\000\088\000\149\000\
\000\000\000\000\000\000\091\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\093\000\094\000\000\000\000\000\
\000\000\095\000\096\000\000\000\000\000\097\000\000\000\098\000\
\000\000\000\000\099\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\100\000\101\000\102\000\115\000\116\000\
\117\000\118\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\120\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\123\000\124\000\115\000\116\000\
\117\000\118\000\083\000\084\000\085\000\086\000\087\000\000\000\
\000\000\000\000\088\000\149\000\000\000\120\000\000\000\091\000\
\000\000\129\002\000\000\000\000\000\000\000\000\000\000\000\000\
\093\000\094\000\000\000\000\000\000\000\095\000\096\000\000\000\
\000\000\000\000\000\000\098\000\123\000\124\000\099\000\000\000\
\000\000\000\000\083\000\084\000\085\000\086\000\087\000\100\000\
\101\000\102\000\088\000\149\000\000\000\000\000\000\000\091\000\
\000\000\000\000\000\000\000\000\137\002\000\000\000\000\000\000\
\093\000\094\000\000\000\000\000\000\000\095\000\096\000\000\000\
\000\000\000\000\000\000\098\000\000\000\000\000\099\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\100\000\
\101\000\102\000\115\000\116\000\117\000\118\000\000\000\000\000\
\049\001\000\000\000\000\000\000\049\001\049\001\000\000\000\000\
\049\001\120\000\000\000\049\001\000\000\000\000\000\000\000\000\
\000\000\083\000\084\000\085\000\086\000\087\000\049\001\000\000\
\000\000\088\000\149\000\049\001\000\000\000\000\091\000\202\002\
\123\000\124\000\115\000\116\000\117\000\118\000\049\001\093\000\
\094\000\000\000\000\000\000\000\095\000\096\000\000\000\000\000\
\000\000\120\000\098\000\000\000\000\000\099\000\000\000\000\000\
\000\000\083\000\084\000\085\000\086\000\087\000\100\000\101\000\
\102\000\088\000\149\000\000\000\000\000\000\000\091\000\204\002\
\123\000\124\000\000\000\000\000\000\000\000\000\000\000\093\000\
\094\000\000\000\000\000\000\000\095\000\096\000\000\000\000\000\
\000\000\000\000\098\000\000\000\000\000\099\000\049\001\000\000\
\000\000\000\000\049\001\000\000\000\000\000\000\100\000\101\000\
\102\000\115\000\116\000\117\000\118\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\049\001\000\000\000\000\
\120\000\000\000\000\000\000\000\049\001\000\000\000\000\000\000\
\083\000\084\000\085\000\086\000\087\000\000\000\000\000\000\000\
\088\000\149\000\000\000\000\000\000\000\091\000\000\000\123\000\
\124\000\115\000\116\000\117\000\118\000\000\000\093\000\094\000\
\000\000\011\000\000\000\095\000\096\000\000\000\000\000\000\000\
\120\000\098\000\000\000\000\000\099\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\100\000\101\000\102\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\123\000\
\124\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\013\000\014\000\015\000\016\000\017\000\018\000\019\000\
\020\000\021\000\022\000\023\000\024\000\000\000\000\000\000\000\
\000\000\000\000\030\000\031\000\032\000\033\000\034\000\035\000\
\115\000\116\000\117\000\118\000\246\000\000\000\246\000\246\000\
\000\000\000\000\000\000\000\000\246\000\000\000\000\000\120\000\
\000\000\246\000\000\000\037\000\000\000\000\000\246\000\246\000\
\041\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\123\000\124\000\
\000\000\000\000\000\000\000\000\246\000\246\000\246\000\246\000\
\246\000\246\000\246\000\246\000\246\000\246\000\246\000\246\000\
\246\000\246\000\246\000\246\000\246\000\246\000\246\000\246\000\
\246\000\246\000\246\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\246\000\000\000\246\000\246\000\
\246\000\000\000\246\000\246\000\246\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\246\000\000\000\000\000\
\245\000\000\000\245\000\245\000\000\000\000\000\000\000\000\000\
\245\000\246\000\246\000\246\000\246\000\245\000\000\000\000\000\
\246\000\000\000\245\000\245\000\000\000\246\000\000\000\000\000\
\000\000\246\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\245\000\245\000\245\000\245\000\245\000\245\000\245\000\245\000\
\245\000\245\000\245\000\245\000\245\000\245\000\245\000\245\000\
\245\000\245\000\245\000\245\000\245\000\245\000\245\000\047\001\
\000\000\000\000\000\000\047\001\047\001\000\000\000\000\047\001\
\000\000\000\000\047\001\000\000\000\000\000\000\000\000\000\000\
\245\000\000\000\245\000\245\000\245\000\047\001\245\000\245\000\
\245\000\000\000\047\001\048\001\000\000\000\000\000\000\048\001\
\048\001\245\000\000\000\048\001\000\000\047\001\048\001\000\000\
\000\000\000\000\000\000\000\000\000\000\245\000\245\000\245\000\
\245\000\048\001\000\000\050\001\245\000\000\000\048\001\050\001\
\050\001\245\000\000\000\050\001\000\000\245\000\050\001\046\001\
\000\000\048\001\000\000\046\001\046\001\000\000\000\000\046\001\
\000\000\050\001\046\001\000\000\000\000\000\000\050\001\000\000\
\000\000\000\000\000\000\000\000\000\000\046\001\000\000\000\000\
\000\000\050\001\046\001\000\000\000\000\047\001\000\000\000\000\
\000\000\047\001\000\000\000\000\000\000\046\001\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\047\001\000\000\000\000\000\000\
\000\000\048\001\000\000\047\001\000\000\048\001\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\048\001\050\001\000\000\000\000\000\000\050\001\060\001\048\001\
\000\000\060\001\060\001\000\000\000\000\046\001\060\001\000\000\
\000\000\046\001\000\000\000\000\000\000\000\000\000\000\000\000\
\050\001\000\000\000\000\000\000\060\001\000\000\000\000\050\001\
\000\000\060\001\000\000\000\000\046\001\000\000\000\000\000\000\
\000\000\000\000\000\000\046\001\060\001\000\000\000\000\000\000\
\000\000\060\001\060\001\060\001\060\001\060\001\060\001\060\001\
\060\001\060\001\060\001\060\001\060\001\060\001\060\001\060\001\
\060\001\060\001\060\001\060\001\060\001\060\001\060\001\060\001\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\236\000\000\000\000\000\236\000\
\236\000\000\000\000\000\060\001\236\000\060\001\000\000\060\001\
\060\001\000\000\000\000\000\000\060\001\000\000\000\000\000\000\
\060\001\011\000\236\000\000\000\000\000\000\000\000\000\236\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\060\001\236\000\060\001\000\000\044\001\000\000\236\000\
\236\000\236\000\236\000\236\000\236\000\236\000\236\000\236\000\
\236\000\236\000\236\000\236\000\236\000\236\000\236\000\236\000\
\236\000\236\000\236\000\236\000\236\000\236\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\134\001\000\000\000\000\134\001\000\000\000\000\
\000\000\236\000\069\001\236\000\000\000\236\000\236\000\069\001\
\000\000\000\000\236\000\000\000\000\000\069\001\236\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\236\000\
\000\000\236\000\134\001\134\001\134\001\134\001\134\001\134\001\
\134\001\134\001\134\001\134\001\134\001\134\001\134\001\134\001\
\134\001\134\001\134\001\134\001\134\001\134\001\134\001\134\001\
\134\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\069\001\000\000\134\001\000\000\134\001\000\000\
\134\001\134\001\134\001\000\000\000\000\000\000\000\000\000\000\
\000\000\135\001\000\000\134\001\135\001\000\000\000\000\000\000\
\000\000\071\001\000\000\000\000\000\000\000\000\071\001\134\001\
\134\001\134\001\134\001\000\000\071\001\000\000\134\001\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\135\001\135\001\135\001\135\001\135\001\135\001\135\001\
\135\001\135\001\135\001\135\001\135\001\135\001\135\001\135\001\
\135\001\135\001\135\001\135\001\135\001\135\001\135\001\135\001\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\009\000\000\000\000\000\011\000\000\000\
\000\000\071\001\000\000\135\001\000\000\135\001\000\000\135\001\
\135\001\135\001\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\124\001\135\001\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\135\001\135\001\
\135\001\135\001\000\000\000\000\000\000\135\001\013\000\014\000\
\015\000\016\000\017\000\018\000\019\000\020\000\021\000\022\000\
\023\000\024\000\000\000\000\000\000\000\000\000\000\000\030\000\
\031\000\032\000\033\000\034\000\035\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\060\001\000\000\011\000\000\000\
\061\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\037\000\000\000\000\000\000\000\000\000\041\000\042\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\043\000\
\000\000\044\000\045\000\046\000\047\000\048\000\049\000\050\000\
\000\000\000\000\000\000\051\000\052\000\053\000\013\000\014\000\
\015\000\016\000\017\000\018\000\019\000\020\000\021\000\022\000\
\023\000\024\000\025\000\026\000\027\000\028\000\029\000\030\000\
\031\000\032\000\033\000\034\000\035\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\060\001\000\000\011\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\037\000\000\000\039\000\000\000\040\000\041\000\000\000\000\000\
\142\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\054\000\013\000\
\014\000\015\000\016\000\017\000\018\000\019\000\020\000\021\000\
\022\000\023\000\024\000\025\000\026\000\027\000\028\000\029\000\
\030\000\031\000\032\000\033\000\034\000\035\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\060\001\000\000\
\011\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\037\000\000\000\039\000\000\000\040\000\041\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\054\000\
\013\000\014\000\015\000\016\000\017\000\018\000\019\000\020\000\
\021\000\022\000\023\000\024\000\025\000\026\000\027\000\028\000\
\029\000\030\000\031\000\032\000\033\000\034\000\035\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\191\001\
\000\000\191\001\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\037\000\000\000\039\000\000\000\040\000\041\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\054\000\191\001\191\001\191\001\191\001\191\001\191\001\191\001\
\191\001\191\001\191\001\191\001\191\001\191\001\191\001\191\001\
\191\001\191\001\191\001\191\001\191\001\191\001\191\001\191\001\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\010\000\011\000\000\000\000\000\000\000\151\002\000\000\
\000\000\000\000\000\000\191\001\000\000\191\001\000\000\191\001\
\191\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\191\001\013\000\014\000\015\000\016\000\017\000\018\000\
\019\000\020\000\021\000\022\000\023\000\024\000\025\000\026\000\
\027\000\028\000\029\000\030\000\031\000\032\000\033\000\034\000\
\035\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\010\000\011\000\000\000\000\000\000\000\224\002\
\000\000\000\000\000\000\157\000\037\000\000\000\039\000\000\000\
\040\000\041\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\054\000\013\000\014\000\015\000\016\000\017\000\
\018\000\019\000\020\000\021\000\022\000\023\000\024\000\025\000\
\026\000\027\000\028\000\029\000\030\000\031\000\032\000\033\000\
\034\000\035\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\011\000\000\000\000\000\092\000\
\000\000\000\000\000\000\000\000\157\000\037\000\000\000\039\000\
\000\000\040\000\041\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\054\000\013\000\014\000\015\000\016\000\
\017\000\018\000\019\000\020\000\021\000\022\000\023\000\024\000\
\025\000\026\000\027\000\028\000\029\000\030\000\031\000\032\000\
\033\000\034\000\035\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\011\000\000\000\000\000\
\092\000\000\000\000\000\000\000\000\000\000\000\037\000\000\000\
\039\000\000\000\040\000\041\000\042\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\043\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\051\000\052\000\053\000\054\000\013\000\014\000\015\000\
\016\000\017\000\018\000\019\000\020\000\021\000\022\000\023\000\
\024\000\025\000\026\000\027\000\028\000\029\000\030\000\031\000\
\032\000\033\000\034\000\035\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\037\000\
\000\000\039\000\000\000\040\000\041\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\008\000\000\000\000\000\
\000\000\008\000\000\000\008\000\008\000\008\000\008\000\008\000\
\008\000\008\000\008\000\000\000\000\000\054\000\010\000\008\000\
\008\000\008\000\008\000\008\000\008\000\008\000\008\000\008\000\
\008\000\008\000\008\000\008\000\008\000\008\000\008\000\008\000\
\008\000\008\000\008\000\008\000\009\000\000\000\000\000\000\000\
\009\000\000\000\009\000\009\000\009\000\009\000\009\000\009\000\
\009\000\009\000\000\000\000\000\000\000\012\000\009\000\009\000\
\009\000\009\000\009\000\009\000\009\000\009\000\009\000\009\000\
\009\000\009\000\009\000\009\000\009\000\009\000\009\000\009\000\
\009\000\009\000\009\000\240\000\000\000\000\000\241\000\242\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\008\000\000\000\000\000\000\000\000\000\
\000\000\000\000\240\000\000\000\000\000\241\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\013\000\014\000\
\015\000\016\000\017\000\018\000\019\000\020\000\021\000\022\000\
\023\000\024\000\009\000\000\000\107\000\000\000\000\000\000\000\
\000\000\032\000\033\000\034\000\035\000\013\000\014\000\015\000\
\016\000\017\000\018\000\019\000\020\000\021\000\022\000\023\000\
\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\032\000\033\000\034\000\035\000\000\000\041\000\000\000\000\000\
\000\000\000\000\000\000\000\000\107\000\107\000\107\000\107\000\
\107\000\107\000\107\000\107\000\107\000\107\000\107\000\107\000\
\000\000\000\000\000\000\000\000\041\000\107\000\107\000\107\000\
\107\000\107\000\107\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\179\000\179\000\179\000\179\000\000\000\000\000\107\000\000\000\
\000\000\179\000\000\000\107\000\179\000\179\000\179\000\179\000\
\179\000\000\000\000\000\000\000\179\000\000\000\179\000\179\000\
\179\000\179\000\179\000\000\000\179\000\000\000\179\000\179\000\
\179\000\179\000\179\000\179\000\179\000\179\000\179\000\179\000\
\179\000\179\000\179\000\179\000\179\000\179\000\179\000\179\000\
\179\000\179\000\179\000\179\000\000\000\000\000\000\000\000\000\
\175\000\175\000\175\000\175\000\000\000\000\000\000\000\000\000\
\000\000\175\000\000\000\000\000\175\000\175\000\175\000\175\000\
\175\000\000\000\000\000\000\000\175\000\179\000\175\000\175\000\
\175\000\175\000\175\000\179\000\175\000\000\000\175\000\175\000\
\175\000\175\000\175\000\175\000\175\000\175\000\175\000\175\000\
\175\000\175\000\175\000\175\000\175\000\175\000\175\000\175\000\
\175\000\175\000\175\000\175\000\000\000\000\000\000\000\000\000\
\148\001\149\001\150\001\151\001\000\000\000\000\000\000\000\000\
\000\000\152\001\000\000\000\000\153\001\154\001\155\001\156\001\
\157\001\000\000\000\000\000\000\158\001\175\000\159\001\160\001\
\161\001\162\001\163\001\175\000\164\001\000\000\165\001\000\000\
\166\001\167\001\168\001\169\001\170\001\171\001\172\001\173\001\
\174\001\175\001\176\001\177\001\178\001\179\001\180\001\181\001\
\182\001\183\001\184\001\185\001\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\186\001\000\000\000\000\
\000\000\000\000\000\000\187\001"

let yycheck = "\003\000\
\002\000\033\000\002\000\002\000\002\000\148\000\140\000\003\000\
\008\000\008\000\008\000\106\000\034\000\010\000\079\000\004\000\
\178\000\193\000\177\000\187\000\021\001\032\000\033\000\182\000\
\000\000\064\001\091\000\248\000\189\001\000\001\000\000\153\000\
\154\000\055\001\054\001\178\000\156\000\075\001\008\001\173\000\
\228\000\121\001\210\000\002\000\081\002\002\000\008\001\014\001\
\156\000\120\001\017\001\122\001\019\001\020\001\076\000\021\001\
\019\001\030\001\025\001\018\001\014\001\000\000\025\001\017\001\
\019\001\035\001\136\000\064\002\035\001\036\001\025\001\014\001\
\018\001\112\001\018\001\018\001\171\000\018\001\014\001\079\000\
\079\000\079\000\018\001\242\000\206\000\019\001\022\001\195\000\
\000\000\253\000\112\001\025\001\014\001\100\001\253\000\254\000\
\018\001\019\001\001\001\002\001\022\001\103\000\091\000\113\000\
\000\000\109\000\019\001\177\000\101\001\113\000\014\001\112\001\
\025\001\109\000\248\000\111\001\075\001\025\001\147\001\041\001\
\079\000\118\002\025\001\112\000\097\001\018\001\106\000\019\001\
\018\001\018\001\052\001\075\001\133\001\025\001\075\001\142\001\
\129\001\005\000\148\000\046\001\251\002\252\002\093\000\094\000\
\148\000\018\001\211\000\212\000\148\000\148\000\148\000\221\000\
\148\000\164\000\108\001\067\001\010\001\035\001\012\001\046\001\
\170\000\014\001\132\001\036\001\115\000\108\001\170\000\133\001\
\023\003\239\000\132\001\138\001\108\001\202\001\178\000\138\001\
\020\001\131\001\178\000\178\000\178\000\088\001\178\000\138\001\
\195\000\093\001\108\001\000\000\131\001\178\000\093\001\171\000\
\036\001\014\001\099\002\131\001\017\001\194\000\076\001\038\001\
\052\001\088\001\239\002\067\001\138\001\117\001\243\002\019\001\
\018\001\131\001\051\002\211\000\211\000\211\000\053\001\067\001\
\128\001\120\001\121\001\122\001\112\001\192\001\111\001\035\001\
\115\001\138\001\090\001\021\001\228\000\228\000\228\000\052\001\
\015\002\237\000\017\002\224\000\018\002\237\000\090\001\237\000\
\081\002\230\000\231\000\106\000\021\001\234\000\138\001\206\000\
\116\000\206\000\215\001\017\002\000\001\212\000\117\000\108\001\
\000\001\123\001\000\001\023\002\021\001\193\001\194\001\014\001\
\116\001\030\001\017\001\133\001\136\000\084\002\003\001\036\001\
\111\001\027\001\028\001\138\000\112\001\111\001\131\001\027\001\
\028\001\018\001\020\001\034\001\027\002\153\000\154\000\108\001\
\129\002\111\001\073\002\006\002\046\001\026\001\199\002\203\001\
\204\001\133\001\046\001\019\001\203\001\204\001\046\001\046\001\
\046\001\019\001\046\001\050\002\171\000\177\000\131\001\134\001\
\000\000\025\001\038\001\069\001\057\001\069\000\112\001\070\001\
\025\001\069\001\018\001\035\001\036\001\030\001\022\001\093\000\
\094\000\053\001\133\001\036\001\041\002\081\001\088\001\112\001\
\019\001\215\001\206\000\133\001\088\001\081\001\025\001\018\001\
\088\001\088\001\088\001\022\001\088\001\115\000\018\001\112\001\
\191\001\221\000\022\001\106\001\133\001\140\002\067\002\023\002\
\084\001\116\001\035\001\019\001\025\001\021\002\118\000\105\001\
\109\001\025\001\014\001\239\000\133\001\041\001\018\001\036\001\
\114\001\029\001\030\001\019\001\025\001\021\001\025\001\023\001\
\052\001\025\001\108\001\111\001\126\001\127\001\128\001\036\001\
\097\001\036\001\034\001\035\001\036\001\004\001\005\001\006\001\
\007\001\008\001\009\001\010\001\011\001\012\001\013\001\014\001\
\015\001\016\001\017\001\018\001\019\001\020\001\021\001\022\001\
\023\001\064\002\133\002\041\002\123\001\245\002\123\001\034\001\
\035\001\021\002\169\002\023\001\008\001\112\001\133\001\038\001\
\133\001\016\002\014\001\187\000\014\001\084\002\034\001\182\002\
\025\001\193\000\022\001\018\001\192\001\067\002\053\001\030\002\
\192\001\032\002\192\001\036\001\161\002\018\001\000\000\138\001\
\112\001\014\001\210\000\025\001\019\001\018\001\019\001\046\002\
\108\001\022\001\025\001\191\001\025\001\178\002\036\001\118\002\
\112\001\040\000\019\001\018\001\224\001\084\001\221\002\212\001\
\025\001\128\002\138\001\216\001\224\001\014\001\201\002\131\001\
\017\001\019\001\035\001\022\001\059\000\024\001\246\000\025\001\
\034\001\035\001\138\001\030\001\067\000\068\000\022\002\014\001\
\111\001\035\001\017\001\074\000\014\001\020\001\063\002\123\001\
\162\002\005\002\006\002\124\001\125\001\005\002\006\002\005\002\
\006\002\133\001\014\001\022\002\018\001\088\001\018\001\165\002\
\166\002\014\002\028\002\162\002\188\002\171\002\014\001\019\001\
\028\002\047\002\018\001\161\002\018\001\025\001\022\001\035\001\
\034\002\033\002\033\002\033\002\016\002\041\001\018\001\108\001\
\019\001\019\001\022\001\112\001\178\002\018\001\025\001\025\001\
\052\001\041\001\030\002\014\001\032\002\035\001\017\001\087\002\
\025\001\020\001\014\001\067\001\052\001\017\001\131\001\000\000\
\020\001\036\001\046\002\014\001\227\002\138\001\017\001\051\002\
\191\001\020\001\019\001\019\001\087\002\021\001\020\001\023\001\
\025\001\025\001\090\001\019\001\000\000\014\001\245\002\031\001\
\020\001\025\001\034\001\035\001\036\001\037\001\038\001\039\001\
\040\001\041\001\014\001\103\002\019\001\081\002\018\001\112\001\
\108\001\109\002\110\002\103\002\022\001\117\001\024\001\091\002\
\026\001\109\002\110\002\018\001\108\001\106\002\107\002\108\002\
\128\001\041\001\019\001\127\002\019\001\041\001\020\001\131\001\
\025\001\133\002\025\001\127\002\052\001\133\002\253\001\133\002\
\052\001\040\003\019\001\131\001\235\002\141\002\141\002\141\002\
\025\001\023\001\019\001\025\001\011\001\129\002\019\001\153\002\
\025\001\016\002\074\001\075\001\025\001\165\001\162\002\019\001\
\009\001\014\001\162\002\162\002\162\002\025\001\162\002\030\002\
\112\001\032\002\018\001\019\001\019\001\162\002\022\001\019\001\
\019\001\089\001\025\001\099\001\018\001\101\001\025\001\046\002\
\019\001\165\002\166\002\018\001\051\002\019\001\025\001\171\002\
\108\001\041\001\138\001\025\001\022\001\201\002\202\002\019\001\
\204\002\201\002\018\001\201\002\052\001\025\001\202\002\196\002\
\204\002\129\001\190\002\018\001\216\002\000\000\019\001\131\001\
\019\001\019\001\081\002\021\001\216\002\023\001\025\001\025\001\
\019\001\019\001\035\001\229\002\091\002\031\001\025\001\025\001\
\034\001\035\001\036\001\037\001\038\001\039\001\040\001\035\001\
\021\001\230\002\050\001\051\001\052\001\053\001\054\001\055\001\
\056\001\117\002\020\001\019\001\000\003\019\001\002\003\235\002\
\004\003\025\001\019\001\025\001\000\003\019\001\002\003\023\001\
\004\003\025\001\129\002\025\001\023\001\021\002\025\001\023\002\
\039\001\040\001\041\001\042\001\043\001\044\001\045\001\046\001\
\047\001\048\001\049\001\050\001\051\001\052\001\053\001\054\001\
\055\001\056\001\038\003\039\003\025\001\021\001\019\001\030\001\
\044\003\025\001\038\003\039\003\025\001\025\001\165\002\166\002\
\044\003\019\001\019\001\019\001\171\002\019\001\112\001\041\001\
\042\001\043\001\044\001\045\001\046\001\047\001\048\001\049\001\
\050\001\051\001\052\001\053\001\054\001\055\001\056\001\190\002\
\112\001\112\001\018\001\000\000\111\001\014\001\021\001\139\001\
\138\001\018\001\019\001\108\001\024\001\022\001\036\001\018\001\
\025\001\005\001\006\001\007\001\008\001\001\000\002\000\003\000\
\004\000\005\000\014\001\019\001\019\001\017\001\018\001\019\001\
\020\001\021\001\022\001\023\001\024\001\025\001\026\001\027\001\
\028\001\029\001\030\001\031\001\235\002\033\001\034\001\035\001\
\036\001\037\001\038\001\039\001\040\001\041\001\042\001\043\001\
\044\001\045\001\046\001\047\001\048\001\049\001\050\001\051\001\
\052\001\053\001\054\001\055\001\056\001\057\001\058\001\059\001\
\060\001\061\001\062\001\063\001\064\001\065\001\066\001\067\001\
\068\001\069\001\070\001\071\001\072\001\073\001\074\001\075\001\
\076\001\077\001\078\001\079\001\139\001\000\000\082\001\035\001\
\019\001\023\001\035\001\108\001\088\001\021\001\036\001\112\001\
\089\001\018\001\035\001\025\001\188\002\097\001\018\001\099\001\
\100\001\101\001\023\001\103\001\104\001\105\001\035\001\014\001\
\020\001\000\000\131\001\035\001\112\001\014\001\114\001\018\001\
\018\001\138\001\036\001\022\001\019\001\024\001\019\001\026\001\
\027\001\028\001\126\001\127\001\128\001\129\001\023\001\025\001\
\018\001\133\001\005\001\006\001\007\001\008\001\138\001\019\001\
\021\001\019\001\142\001\014\001\014\001\014\001\017\001\018\001\
\019\001\020\001\021\001\022\001\023\001\024\001\025\001\026\001\
\027\001\028\001\029\001\030\001\031\001\036\001\033\001\034\001\
\035\001\036\001\037\001\038\001\039\001\040\001\041\001\042\001\
\043\001\044\001\045\001\046\001\047\001\048\001\049\001\050\001\
\051\001\052\001\053\001\054\001\055\001\056\001\057\001\058\001\
\059\001\060\001\061\001\062\001\063\001\064\001\065\001\066\001\
\067\001\068\001\069\001\070\001\071\001\072\001\073\001\074\001\
\075\001\076\001\077\001\078\001\079\001\082\001\023\001\082\001\
\052\001\053\001\054\001\055\001\056\001\088\001\019\001\025\001\
\112\001\021\001\019\001\082\001\036\001\036\001\097\001\000\000\
\099\001\100\001\101\001\021\001\103\001\104\001\105\001\019\001\
\008\001\023\001\036\001\018\001\125\001\112\001\019\001\114\001\
\048\001\049\001\050\001\051\001\052\001\053\001\054\001\055\001\
\056\001\009\001\133\001\126\001\127\001\128\001\129\001\000\000\
\036\001\014\001\133\001\021\001\017\001\018\001\019\001\138\001\
\021\001\022\001\023\001\142\001\025\001\036\001\036\001\035\001\
\029\001\030\001\031\001\000\000\019\001\034\001\035\001\036\001\
\037\001\038\001\039\001\040\001\041\001\042\001\043\001\044\001\
\045\001\046\001\047\001\048\001\049\001\050\001\051\001\052\001\
\053\001\054\001\055\001\056\001\057\001\058\001\059\001\060\001\
\061\001\062\001\063\001\064\001\065\001\066\001\067\001\068\001\
\069\001\070\001\071\001\072\001\073\001\074\001\075\001\076\001\
\077\001\078\001\079\001\038\001\039\001\040\001\041\001\042\001\
\043\001\044\001\045\001\046\001\047\001\048\001\049\001\050\001\
\051\001\052\001\053\001\054\001\055\001\056\001\099\001\021\001\
\101\001\019\001\103\001\104\001\021\001\112\001\036\001\108\001\
\019\001\112\001\021\001\112\001\023\001\112\001\025\001\035\001\
\021\001\000\000\019\001\112\001\031\001\112\001\112\001\034\001\
\035\001\036\001\037\001\038\001\129\001\112\001\131\001\014\001\
\002\000\083\001\017\001\018\001\019\001\138\001\021\001\022\001\
\023\001\117\002\025\001\216\000\140\000\097\001\029\001\030\001\
\031\001\000\000\205\001\034\001\035\001\036\001\037\001\038\001\
\039\001\040\001\041\001\042\001\043\001\044\001\045\001\046\001\
\047\001\048\001\049\001\050\001\051\001\052\001\053\001\054\001\
\055\001\056\001\057\001\058\001\059\001\060\001\061\001\062\001\
\063\001\064\001\065\001\066\001\067\001\068\001\069\001\070\001\
\071\001\072\001\073\001\074\001\075\001\076\001\077\001\078\001\
\079\001\000\000\035\002\229\002\040\003\112\001\044\001\045\001\
\046\001\047\001\048\001\049\001\050\001\051\001\052\001\053\001\
\054\001\055\001\056\001\194\002\099\001\070\002\101\001\184\002\
\103\001\104\001\245\002\117\001\134\001\108\001\053\002\138\001\
\205\000\112\001\123\001\083\002\188\002\090\002\133\001\190\002\
\169\000\069\001\145\002\162\002\028\002\255\255\125\002\008\001\
\255\255\255\255\129\001\255\255\131\001\255\255\255\255\255\255\
\255\255\018\001\019\001\138\001\021\001\022\001\023\001\024\001\
\025\001\026\001\027\001\028\001\029\001\030\001\031\001\255\255\
\255\255\034\001\035\001\036\001\037\001\038\001\039\001\040\001\
\041\001\042\001\043\001\044\001\045\001\046\001\047\001\048\001\
\049\001\050\001\051\001\052\001\053\001\054\001\055\001\056\001\
\255\255\255\255\255\255\008\001\255\255\255\255\255\255\255\255\
\255\255\255\255\000\000\255\255\255\255\018\001\019\001\255\255\
\021\001\022\001\023\001\024\001\025\001\026\001\027\001\028\001\
\029\001\030\001\031\001\255\255\255\255\034\001\035\001\036\001\
\037\001\038\001\039\001\040\001\041\001\042\001\043\001\044\001\
\045\001\046\001\047\001\048\001\049\001\050\001\051\001\052\001\
\053\001\054\001\055\001\056\001\000\000\255\255\255\255\112\001\
\040\001\041\001\042\001\043\001\044\001\045\001\046\001\047\001\
\048\001\049\001\050\001\051\001\052\001\053\001\054\001\055\001\
\056\001\255\255\255\255\132\001\255\255\255\255\255\255\255\255\
\255\255\138\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\000\000\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\019\001\255\255\021\001\255\255\
\023\001\255\255\025\001\112\001\255\255\255\255\255\255\255\255\
\031\001\255\255\255\255\034\001\035\001\036\001\037\001\038\001\
\039\001\040\001\041\001\042\001\043\001\255\255\255\255\132\001\
\255\255\255\255\255\255\018\001\019\001\138\001\021\001\022\001\
\023\001\024\001\025\001\026\001\027\001\028\001\029\001\030\001\
\031\001\255\255\255\255\034\001\035\001\036\001\037\001\038\001\
\039\001\040\001\041\001\042\001\043\001\044\001\045\001\046\001\
\047\001\048\001\049\001\050\001\051\001\052\001\053\001\054\001\
\055\001\056\001\000\000\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\018\001\019\001\255\255\021\001\022\001\
\023\001\024\001\025\001\026\001\027\001\028\001\029\001\030\001\
\031\001\112\001\255\255\034\001\035\001\036\001\037\001\038\001\
\039\001\040\001\041\001\042\001\043\001\044\001\045\001\046\001\
\047\001\048\001\049\001\050\001\051\001\052\001\053\001\054\001\
\055\001\056\001\000\000\138\001\031\001\255\255\255\255\255\255\
\255\255\112\001\037\001\038\001\039\001\040\001\041\001\042\001\
\043\001\044\001\045\001\046\001\047\001\048\001\049\001\050\001\
\051\001\052\001\053\001\054\001\055\001\056\001\255\255\255\255\
\255\255\255\255\255\255\138\001\255\255\255\255\255\255\255\255\
\000\000\042\001\043\001\044\001\045\001\046\001\047\001\048\001\
\049\001\050\001\051\001\052\001\053\001\054\001\055\001\056\001\
\255\255\112\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\019\001\255\255\021\001\
\022\001\023\001\255\255\025\001\255\255\255\255\255\255\029\001\
\030\001\031\001\000\000\138\001\034\001\035\001\036\001\037\001\
\038\001\039\001\040\001\041\001\042\001\043\001\044\001\045\001\
\046\001\047\001\048\001\049\001\050\001\051\001\052\001\053\001\
\054\001\055\001\056\001\255\255\255\255\255\255\255\255\019\001\
\255\255\021\001\255\255\023\001\255\255\025\001\255\255\255\255\
\000\000\029\001\030\001\031\001\255\255\255\255\034\001\035\001\
\036\001\037\001\038\001\039\001\040\001\041\001\042\001\043\001\
\044\001\045\001\046\001\047\001\048\001\049\001\050\001\051\001\
\052\001\053\001\054\001\055\001\056\001\019\001\255\255\021\001\
\255\255\023\001\255\255\025\001\255\255\255\255\255\255\029\001\
\030\001\031\001\112\001\255\255\034\001\035\001\036\001\037\001\
\038\001\039\001\040\001\041\001\042\001\043\001\044\001\045\001\
\046\001\047\001\048\001\049\001\050\001\051\001\052\001\053\001\
\054\001\055\001\056\001\255\255\138\001\018\001\255\255\255\255\
\021\001\022\001\255\255\024\001\025\001\026\001\027\001\028\001\
\000\000\255\255\031\001\255\255\112\001\255\255\035\001\255\255\
\037\001\038\001\039\001\040\001\041\001\042\001\043\001\044\001\
\045\001\046\001\047\001\048\001\049\001\050\001\051\001\052\001\
\053\001\054\001\055\001\056\001\255\255\019\001\138\001\021\001\
\000\000\023\001\255\255\025\001\255\255\255\255\255\255\029\001\
\030\001\031\001\112\001\255\255\034\001\035\001\036\001\037\001\
\038\001\039\001\040\001\041\001\042\001\043\001\044\001\045\001\
\046\001\047\001\048\001\049\001\050\001\051\001\052\001\053\001\
\054\001\055\001\056\001\255\255\138\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\019\001\255\255\021\001\
\000\000\023\001\255\255\025\001\255\255\255\255\255\255\029\001\
\030\001\031\001\255\255\255\255\034\001\035\001\036\001\037\001\
\038\001\039\001\040\001\041\001\042\001\043\001\044\001\045\001\
\046\001\047\001\048\001\049\001\050\001\051\001\052\001\053\001\
\054\001\055\001\056\001\019\001\000\000\021\001\255\255\023\001\
\255\255\025\001\112\001\255\255\255\255\255\255\255\255\031\001\
\255\255\255\255\034\001\035\001\036\001\037\001\038\001\039\001\
\040\001\041\001\042\001\043\001\044\001\045\001\046\001\047\001\
\048\001\049\001\050\001\051\001\138\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\019\001\255\255\021\001\
\000\000\023\001\255\255\025\001\255\255\255\255\255\255\255\255\
\255\255\031\001\112\001\255\255\034\001\035\001\036\001\037\001\
\038\001\039\001\040\001\041\001\042\001\043\001\044\001\045\001\
\046\001\047\001\048\001\049\001\050\001\051\001\052\001\053\001\
\054\001\055\001\056\001\019\001\138\001\021\001\000\000\023\001\
\255\255\025\001\255\255\255\255\255\255\255\255\255\255\031\001\
\112\001\255\255\034\001\035\001\036\001\037\001\038\001\039\001\
\040\001\041\001\042\001\043\001\044\001\045\001\046\001\047\001\
\048\001\049\001\050\001\051\001\000\000\255\255\255\255\255\255\
\255\255\255\255\138\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\014\001\255\255\014\001\
\255\255\018\001\112\001\018\001\255\255\022\001\255\255\000\000\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\036\001\035\001\036\001\255\255\255\255\
\041\001\255\255\041\001\019\001\138\001\021\001\000\000\023\001\
\255\255\025\001\255\255\052\001\255\255\052\001\255\255\031\001\
\112\001\255\255\034\001\035\001\036\001\037\001\038\001\039\001\
\040\001\041\001\042\001\043\001\044\001\045\001\046\001\047\001\
\048\001\049\001\000\000\019\001\255\255\021\001\255\255\023\001\
\255\255\025\001\138\001\255\255\255\255\255\255\255\255\031\001\
\255\255\255\255\034\001\035\001\036\001\037\001\038\001\039\001\
\040\001\041\001\042\001\043\001\044\001\045\001\046\001\047\001\
\048\001\049\001\255\255\108\001\255\255\108\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\019\001\255\255\021\001\255\255\023\001\
\255\255\025\001\131\001\255\255\131\001\255\255\255\255\031\001\
\112\001\255\255\034\001\035\001\036\001\037\001\038\001\039\001\
\040\001\041\001\042\001\043\001\044\001\045\001\046\001\047\001\
\255\255\255\255\255\255\255\255\255\255\255\255\000\000\019\001\
\255\255\021\001\138\001\023\001\255\255\025\001\255\255\255\255\
\112\001\255\255\255\255\031\001\255\255\255\255\034\001\035\001\
\036\001\037\001\038\001\039\001\040\001\041\001\042\001\043\001\
\044\001\045\001\046\001\047\001\255\255\255\255\255\255\255\255\
\255\255\255\255\138\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\019\001\255\255\021\001\255\255\023\001\
\255\255\025\001\255\255\255\255\255\255\014\001\255\255\031\001\
\112\001\018\001\034\001\035\001\036\001\037\001\038\001\039\001\
\040\001\041\001\042\001\043\001\044\001\045\001\046\001\047\001\
\255\255\255\255\255\255\036\001\255\255\255\255\255\255\255\255\
\041\001\019\001\138\001\021\001\255\255\023\001\255\255\025\001\
\255\255\255\255\255\255\052\001\112\001\031\001\255\255\255\255\
\034\001\035\001\036\001\037\001\038\001\039\001\040\001\041\001\
\042\001\043\001\044\001\045\001\046\001\047\001\255\255\019\001\
\255\255\021\001\255\255\023\001\255\255\025\001\138\001\255\255\
\000\000\255\255\255\255\031\001\255\255\255\255\034\001\035\001\
\036\001\037\001\038\001\039\001\040\001\041\001\042\001\043\001\
\112\001\255\255\019\001\255\255\021\001\255\255\023\001\000\000\
\025\001\255\255\255\255\108\001\255\255\255\255\031\001\255\255\
\255\255\034\001\035\001\036\001\037\001\038\001\039\001\255\255\
\255\255\019\001\138\001\021\001\255\255\023\001\255\255\025\001\
\255\255\255\255\131\001\255\255\255\255\031\001\112\001\255\255\
\034\001\035\001\036\001\037\001\255\255\255\255\255\255\255\255\
\014\001\255\255\255\255\255\255\018\001\019\001\255\255\255\255\
\022\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\138\001\255\255\255\255\255\255\112\001\035\001\036\001\255\255\
\255\255\255\255\255\255\041\001\255\255\255\255\255\255\255\255\
\000\000\255\255\255\255\255\255\255\255\255\255\052\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\138\001\112\001\
\004\001\005\001\006\001\007\001\008\001\009\001\010\001\011\001\
\012\001\013\001\014\001\015\001\016\001\017\001\018\001\019\001\
\020\001\021\001\022\001\023\001\255\255\255\255\112\001\255\255\
\255\255\138\001\255\255\005\001\006\001\007\001\008\001\009\001\
\255\255\255\255\255\255\013\001\014\001\255\255\016\001\017\001\
\018\001\255\255\020\001\021\001\255\255\255\255\108\001\255\255\
\138\001\027\001\028\001\255\255\255\255\255\255\032\001\033\001\
\255\255\255\255\036\001\255\255\038\001\255\255\255\255\041\001\
\255\255\255\255\255\255\255\255\255\255\131\001\255\255\255\255\
\050\001\051\001\052\001\255\255\255\255\255\255\255\255\057\001\
\058\001\059\001\060\001\061\001\062\001\063\001\064\001\065\001\
\066\001\067\001\068\001\069\001\070\001\071\001\072\001\073\001\
\074\001\075\001\076\001\077\001\078\001\079\001\080\001\081\001\
\255\255\083\001\084\001\085\001\086\001\087\001\088\001\089\001\
\090\001\091\001\092\001\093\001\094\001\095\001\096\001\255\255\
\255\255\099\001\100\001\101\001\255\255\103\001\104\001\105\001\
\255\255\255\255\108\001\255\255\255\255\255\255\112\001\255\255\
\114\001\255\255\116\001\117\001\118\001\119\001\120\001\121\001\
\122\001\123\001\255\255\125\001\126\001\127\001\128\001\129\001\
\130\001\131\001\132\001\133\001\255\255\135\001\014\001\255\255\
\255\255\255\255\018\001\019\001\255\255\255\255\022\001\255\255\
\255\255\255\255\161\000\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\035\001\036\001\014\001\255\255\016\001\
\017\001\041\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\052\001\255\255\005\000\255\255\
\255\255\255\255\255\255\036\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\057\001\058\001\059\001\060\001\061\001\062\001\063\001\064\001\
\065\001\066\001\067\001\068\001\069\001\070\001\071\001\072\001\
\073\001\074\001\075\001\076\001\077\001\078\001\079\001\255\255\
\255\255\255\255\255\255\242\000\108\001\255\255\255\255\255\255\
\016\001\017\001\255\255\255\255\255\255\255\255\253\000\255\255\
\255\255\098\001\099\001\100\001\101\001\255\255\103\001\104\001\
\105\001\255\255\255\255\131\001\255\255\255\255\255\255\255\255\
\255\255\114\001\255\255\116\001\117\001\118\001\119\001\120\001\
\121\001\122\001\025\001\255\255\255\255\126\001\127\001\128\001\
\129\001\057\001\058\001\059\001\060\001\061\001\062\001\063\001\
\064\001\065\001\066\001\067\001\068\001\069\001\070\001\071\001\
\072\001\073\001\074\001\075\001\076\001\077\001\078\001\079\001\
\055\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\136\000\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\098\001\099\001\255\255\101\001\255\255\103\001\
\104\001\255\255\153\000\154\000\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\093\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\129\001\177\000\255\255\255\255\255\255\255\255\255\255\
\255\255\112\001\255\255\255\255\255\255\255\255\005\001\006\001\
\007\001\008\001\009\001\255\255\195\000\255\255\013\001\014\001\
\015\001\255\255\017\001\018\001\019\001\255\255\255\255\206\000\
\255\255\255\255\255\255\255\255\027\001\028\001\255\255\255\255\
\255\255\032\001\033\001\255\255\255\255\255\255\221\000\038\001\
\255\255\255\255\041\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\050\001\051\001\052\001\255\255\255\255\
\239\000\255\255\057\001\058\001\059\001\060\001\061\001\062\001\
\063\001\064\001\065\001\066\001\067\001\068\001\069\001\070\001\
\071\001\072\001\073\001\074\001\075\001\076\001\077\001\078\001\
\079\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\203\001\204\001\093\001\094\001\
\095\001\096\001\255\255\255\255\099\001\255\255\101\001\255\255\
\103\001\104\001\255\255\255\255\255\255\108\001\255\255\255\255\
\255\255\255\255\005\001\006\001\007\001\008\001\009\001\255\255\
\255\255\255\255\013\001\014\001\015\001\255\255\017\001\018\001\
\019\001\255\255\129\001\255\255\131\001\132\001\255\255\255\255\
\027\001\028\001\255\255\255\255\139\001\032\001\033\001\255\255\
\255\255\255\255\255\255\038\001\255\255\255\255\041\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\050\001\
\051\001\052\001\017\002\255\255\255\255\020\002\057\001\058\001\
\059\001\060\001\061\001\062\001\063\001\064\001\065\001\066\001\
\067\001\068\001\069\001\070\001\071\001\072\001\073\001\074\001\
\075\001\076\001\077\001\078\001\079\001\116\001\255\255\255\255\
\255\255\255\255\255\255\255\255\123\001\255\255\255\255\255\255\
\255\255\255\255\093\001\094\001\095\001\096\001\133\001\255\255\
\099\001\255\255\101\001\255\255\103\001\104\001\255\255\255\255\
\255\255\108\001\255\255\255\255\255\255\255\255\005\001\006\001\
\007\001\008\001\009\001\255\255\255\255\255\255\013\001\014\001\
\015\001\255\255\017\001\018\001\019\001\255\255\129\001\255\255\
\131\001\132\001\255\255\255\255\027\001\028\001\255\255\255\255\
\139\001\032\001\033\001\255\255\255\255\255\255\255\255\038\001\
\255\255\255\255\041\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\050\001\051\001\052\001\255\255\255\255\
\255\255\255\255\057\001\058\001\059\001\060\001\061\001\062\001\
\063\001\064\001\065\001\066\001\067\001\068\001\069\001\070\001\
\071\001\072\001\073\001\074\001\075\001\076\001\077\001\078\001\
\079\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\093\001\094\001\
\095\001\096\001\255\255\255\255\099\001\255\255\101\001\255\255\
\103\001\104\001\255\255\255\255\255\255\108\001\255\255\255\255\
\255\255\255\255\005\001\006\001\007\001\008\001\009\001\255\255\
\255\255\255\255\013\001\014\001\015\001\255\255\017\001\018\001\
\019\001\255\255\129\001\255\255\131\001\132\001\255\255\255\255\
\027\001\028\001\255\255\255\255\139\001\032\001\033\001\255\255\
\255\255\255\255\255\255\038\001\255\255\255\255\041\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\050\001\
\051\001\052\001\255\255\255\255\255\255\255\255\057\001\058\001\
\059\001\060\001\061\001\062\001\063\001\064\001\065\001\066\001\
\067\001\068\001\069\001\070\001\071\001\072\001\073\001\074\001\
\075\001\076\001\077\001\078\001\079\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\093\001\094\001\095\001\096\001\255\255\255\255\
\099\001\255\255\101\001\255\255\103\001\104\001\255\255\255\255\
\255\255\108\001\255\255\255\255\255\255\255\255\005\001\006\001\
\007\001\008\001\009\001\255\255\255\255\255\255\013\001\014\001\
\015\001\255\255\017\001\018\001\019\001\255\255\129\001\255\255\
\131\001\132\001\255\255\255\255\027\001\028\001\255\255\255\255\
\139\001\032\001\033\001\255\255\255\255\255\255\255\255\038\001\
\255\255\255\255\041\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\050\001\051\001\052\001\255\255\255\255\
\255\255\255\255\057\001\058\001\059\001\060\001\061\001\062\001\
\063\001\064\001\065\001\066\001\067\001\068\001\069\001\070\001\
\071\001\072\001\073\001\074\001\075\001\076\001\077\001\078\001\
\079\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\093\001\094\001\
\095\001\096\001\255\255\255\255\099\001\255\255\101\001\255\255\
\103\001\104\001\255\255\255\255\255\255\108\001\255\255\255\255\
\255\255\255\255\005\001\006\001\007\001\008\001\009\001\255\255\
\255\255\255\255\013\001\014\001\015\001\255\255\017\001\018\001\
\255\255\255\255\129\001\255\255\131\001\132\001\255\255\255\255\
\027\001\028\001\255\255\255\255\139\001\032\001\033\001\255\255\
\255\255\255\255\255\255\038\001\255\255\255\255\041\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\050\001\
\051\001\052\001\255\255\255\255\255\255\255\255\057\001\058\001\
\059\001\060\001\061\001\062\001\063\001\064\001\065\001\066\001\
\067\001\068\001\069\001\070\001\071\001\072\001\073\001\074\001\
\075\001\076\001\077\001\078\001\079\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\093\001\094\001\095\001\096\001\255\255\255\255\
\099\001\255\255\101\001\255\255\103\001\104\001\255\255\255\255\
\255\255\108\001\255\255\255\255\255\255\255\255\005\001\006\001\
\007\001\008\001\009\001\255\255\255\255\255\255\013\001\014\001\
\015\001\255\255\017\001\018\001\255\255\255\255\129\001\255\255\
\131\001\132\001\255\255\255\255\027\001\028\001\255\255\255\255\
\139\001\032\001\033\001\255\255\255\255\255\255\255\255\038\001\
\255\255\255\255\041\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\050\001\051\001\052\001\255\255\255\255\
\255\255\255\255\057\001\058\001\059\001\060\001\061\001\062\001\
\063\001\064\001\065\001\066\001\067\001\068\001\069\001\070\001\
\071\001\072\001\073\001\074\001\075\001\076\001\077\001\078\001\
\079\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\093\001\094\001\
\095\001\096\001\255\255\255\255\099\001\255\255\101\001\255\255\
\103\001\104\001\255\255\255\255\255\255\108\001\255\255\255\255\
\255\255\255\255\005\001\006\001\007\001\008\001\009\001\255\255\
\255\255\255\255\013\001\014\001\255\255\016\001\017\001\018\001\
\255\255\020\001\129\001\255\255\131\001\132\001\255\255\255\255\
\027\001\028\001\255\255\255\255\139\001\032\001\033\001\255\255\
\255\255\036\001\255\255\038\001\255\255\255\255\041\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\050\001\
\051\001\052\001\255\255\255\255\255\255\255\255\057\001\058\001\
\059\001\060\001\061\001\062\001\063\001\064\001\065\001\066\001\
\067\001\068\001\069\001\070\001\071\001\072\001\073\001\074\001\
\075\001\076\001\077\001\078\001\079\001\080\001\081\001\255\255\
\083\001\084\001\085\001\086\001\087\001\088\001\089\001\090\001\
\091\001\092\001\093\001\094\001\095\001\096\001\255\255\255\255\
\099\001\100\001\101\001\255\255\103\001\104\001\105\001\255\255\
\255\255\108\001\109\001\110\001\255\255\255\255\255\255\114\001\
\255\255\116\001\117\001\118\001\119\001\120\001\121\001\122\001\
\123\001\255\255\255\255\126\001\127\001\128\001\129\001\130\001\
\131\001\132\001\255\255\255\255\135\001\005\001\006\001\007\001\
\008\001\009\001\255\255\255\255\255\255\013\001\014\001\255\255\
\016\001\017\001\018\001\255\255\020\001\255\255\255\255\255\255\
\255\255\255\255\255\255\027\001\028\001\255\255\255\255\255\255\
\032\001\033\001\255\255\255\255\036\001\255\255\038\001\255\255\
\255\255\041\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\050\001\051\001\052\001\255\255\255\255\255\255\
\255\255\057\001\058\001\059\001\060\001\061\001\062\001\063\001\
\064\001\065\001\066\001\067\001\068\001\069\001\070\001\071\001\
\072\001\073\001\074\001\075\001\076\001\077\001\078\001\079\001\
\080\001\081\001\255\255\083\001\084\001\085\001\086\001\087\001\
\088\001\089\001\090\001\091\001\092\001\093\001\094\001\095\001\
\096\001\255\255\255\255\099\001\100\001\101\001\255\255\103\001\
\104\001\105\001\255\255\255\255\108\001\255\255\255\255\255\255\
\112\001\255\255\114\001\255\255\116\001\117\001\118\001\119\001\
\120\001\121\001\122\001\123\001\255\255\255\255\126\001\127\001\
\128\001\129\001\130\001\131\001\132\001\133\001\255\255\135\001\
\005\001\006\001\007\001\008\001\009\001\255\255\255\255\255\255\
\013\001\014\001\255\255\016\001\017\001\018\001\255\255\020\001\
\255\255\255\255\255\255\255\255\255\255\255\255\027\001\028\001\
\255\255\255\255\255\255\032\001\033\001\255\255\255\255\036\001\
\255\255\038\001\255\255\255\255\041\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\050\001\051\001\052\001\
\255\255\255\255\255\255\255\255\057\001\058\001\059\001\060\001\
\061\001\062\001\063\001\064\001\065\001\066\001\067\001\068\001\
\069\001\070\001\071\001\072\001\073\001\074\001\075\001\076\001\
\077\001\078\001\079\001\080\001\081\001\255\255\083\001\084\001\
\085\001\086\001\087\001\088\001\089\001\090\001\091\001\092\001\
\093\001\094\001\095\001\096\001\255\255\255\255\099\001\100\001\
\101\001\255\255\103\001\104\001\105\001\255\255\255\255\108\001\
\255\255\255\255\255\255\112\001\255\255\114\001\255\255\116\001\
\117\001\118\001\119\001\120\001\121\001\122\001\123\001\255\255\
\255\255\126\001\127\001\128\001\129\001\130\001\131\001\132\001\
\133\001\255\255\135\001\005\001\006\001\007\001\008\001\009\001\
\255\255\255\255\255\255\013\001\014\001\255\255\016\001\017\001\
\018\001\255\255\020\001\255\255\255\255\255\255\255\255\255\255\
\255\255\027\001\028\001\255\255\255\255\255\255\032\001\033\001\
\255\255\255\255\036\001\255\255\038\001\255\255\255\255\041\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\050\001\051\001\052\001\255\255\255\255\255\255\255\255\057\001\
\058\001\059\001\060\001\061\001\062\001\063\001\064\001\065\001\
\066\001\067\001\068\001\069\001\070\001\071\001\072\001\073\001\
\074\001\075\001\076\001\077\001\078\001\079\001\080\001\081\001\
\255\255\083\001\084\001\085\001\086\001\087\001\088\001\089\001\
\090\001\091\001\092\001\093\001\094\001\095\001\096\001\255\255\
\255\255\099\001\100\001\101\001\255\255\103\001\104\001\105\001\
\255\255\255\255\108\001\255\255\255\255\255\255\112\001\255\255\
\114\001\255\255\116\001\117\001\118\001\119\001\120\001\121\001\
\122\001\123\001\255\255\255\255\126\001\127\001\128\001\129\001\
\130\001\131\001\132\001\133\001\255\255\135\001\005\001\006\001\
\007\001\008\001\009\001\255\255\255\255\255\255\013\001\014\001\
\255\255\016\001\017\001\018\001\255\255\020\001\255\255\255\255\
\255\255\255\255\255\255\255\255\027\001\028\001\255\255\255\255\
\255\255\032\001\033\001\255\255\255\255\036\001\255\255\038\001\
\255\255\255\255\041\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\050\001\051\001\052\001\255\255\255\255\
\255\255\255\255\057\001\058\001\059\001\060\001\061\001\062\001\
\063\001\064\001\065\001\066\001\067\001\068\001\069\001\070\001\
\071\001\072\001\073\001\074\001\075\001\076\001\077\001\078\001\
\079\001\080\001\081\001\255\255\083\001\084\001\085\001\086\001\
\087\001\088\001\089\001\090\001\091\001\092\001\093\001\094\001\
\095\001\096\001\255\255\255\255\099\001\100\001\101\001\255\255\
\103\001\104\001\105\001\255\255\255\255\108\001\255\255\110\001\
\255\255\255\255\255\255\114\001\255\255\116\001\117\001\118\001\
\119\001\120\001\121\001\122\001\123\001\255\255\255\255\126\001\
\127\001\128\001\129\001\130\001\131\001\132\001\255\255\255\255\
\135\001\005\001\006\001\007\001\008\001\009\001\255\255\255\255\
\255\255\013\001\014\001\255\255\016\001\017\001\018\001\255\255\
\020\001\255\255\255\255\255\255\255\255\255\255\255\255\027\001\
\028\001\255\255\255\255\255\255\032\001\033\001\255\255\255\255\
\036\001\255\255\038\001\255\255\255\255\041\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\050\001\051\001\
\052\001\255\255\255\255\255\255\255\255\057\001\058\001\059\001\
\060\001\061\001\062\001\063\001\064\001\065\001\066\001\067\001\
\068\001\069\001\070\001\071\001\072\001\073\001\074\001\075\001\
\076\001\077\001\078\001\079\001\080\001\081\001\255\255\083\001\
\084\001\085\001\086\001\087\001\088\001\089\001\090\001\091\001\
\092\001\093\001\094\001\095\001\096\001\255\255\255\255\099\001\
\100\001\101\001\255\255\103\001\104\001\105\001\255\255\255\255\
\108\001\255\255\255\255\255\255\255\255\255\255\114\001\255\255\
\116\001\117\001\118\001\119\001\120\001\121\001\122\001\123\001\
\255\255\255\255\126\001\127\001\128\001\129\001\130\001\131\001\
\132\001\255\255\255\255\135\001\005\001\006\001\007\001\008\001\
\009\001\255\255\255\255\255\255\013\001\014\001\255\255\255\255\
\017\001\018\001\255\255\020\001\255\255\255\255\255\255\255\255\
\255\255\255\255\027\001\028\001\255\255\255\255\255\255\032\001\
\033\001\255\255\255\255\036\001\255\255\038\001\255\255\255\255\
\041\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\050\001\051\001\052\001\255\255\255\255\255\255\255\255\
\057\001\058\001\059\001\060\001\061\001\062\001\063\001\064\001\
\065\001\066\001\067\001\068\001\069\001\070\001\071\001\072\001\
\073\001\074\001\075\001\076\001\077\001\078\001\079\001\080\001\
\081\001\255\255\083\001\084\001\085\001\086\001\087\001\088\001\
\089\001\090\001\091\001\092\001\093\001\094\001\095\001\096\001\
\255\255\255\255\099\001\100\001\101\001\255\255\103\001\104\001\
\255\255\255\255\255\255\108\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\123\001\255\255\255\255\255\255\255\255\255\255\
\129\001\130\001\131\001\132\001\255\255\255\255\135\001\005\001\
\006\001\007\001\008\001\009\001\255\255\255\255\255\255\013\001\
\014\001\017\001\255\255\017\001\018\001\255\255\020\001\255\255\
\255\255\255\255\255\255\255\255\255\255\027\001\028\001\255\255\
\255\255\255\255\032\001\033\001\255\255\255\255\036\001\255\255\
\038\001\255\255\255\255\041\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\050\001\051\001\052\001\255\255\
\255\255\057\001\058\001\059\001\060\001\061\001\062\001\063\001\
\064\001\065\001\066\001\067\001\068\001\069\001\070\001\071\001\
\072\001\073\001\074\001\075\001\076\001\077\001\078\001\079\001\
\255\255\255\255\080\001\081\001\255\255\083\001\084\001\085\001\
\086\001\087\001\088\001\089\001\090\001\091\001\092\001\093\001\
\094\001\095\001\096\001\099\001\255\255\101\001\100\001\103\001\
\104\001\255\255\255\255\255\255\255\255\255\255\108\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\005\001\006\001\
\007\001\008\001\009\001\255\255\255\255\123\001\013\001\014\001\
\255\255\129\001\017\001\018\001\130\001\131\001\132\001\255\255\
\255\255\135\001\255\255\255\255\027\001\028\001\255\255\255\255\
\255\255\032\001\033\001\255\255\255\255\036\001\255\255\038\001\
\255\255\255\255\041\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\050\001\051\001\052\001\255\255\255\255\
\255\255\255\255\057\001\058\001\059\001\060\001\061\001\062\001\
\063\001\064\001\065\001\066\001\067\001\068\001\069\001\070\001\
\071\001\072\001\073\001\074\001\075\001\076\001\077\001\078\001\
\079\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\093\001\094\001\
\095\001\096\001\255\255\255\255\099\001\255\255\101\001\255\255\
\103\001\104\001\255\255\255\255\255\255\108\001\255\255\255\255\
\005\001\006\001\007\001\008\001\009\001\255\255\255\255\255\255\
\013\001\014\001\255\255\255\255\017\001\018\001\255\255\255\255\
\255\255\255\255\129\001\255\255\131\001\132\001\027\001\028\001\
\255\255\255\255\255\255\032\001\033\001\255\255\255\255\255\255\
\255\255\038\001\255\255\255\255\041\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\050\001\051\001\052\001\
\255\255\255\255\255\255\255\255\057\001\058\001\059\001\060\001\
\061\001\062\001\063\001\064\001\065\001\066\001\067\001\068\001\
\255\255\255\255\255\255\255\255\255\255\074\001\075\001\076\001\
\077\001\078\001\079\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\093\001\094\001\095\001\096\001\255\255\255\255\099\001\255\255\
\255\255\255\255\255\255\104\001\255\255\255\255\255\255\108\001\
\255\255\255\255\005\001\006\001\007\001\008\001\009\001\255\255\
\255\255\255\255\013\001\014\001\255\255\255\255\017\001\018\001\
\255\255\020\001\021\001\022\001\255\255\024\001\131\001\132\001\
\027\001\028\001\255\255\255\255\255\255\032\001\033\001\255\255\
\255\255\255\255\255\255\038\001\255\255\255\255\041\001\255\255\
\255\255\255\255\005\001\006\001\007\001\008\001\009\001\050\001\
\051\001\052\001\013\001\014\001\255\255\255\255\017\001\018\001\
\255\255\020\001\021\001\022\001\255\255\024\001\255\255\255\255\
\027\001\028\001\255\255\255\255\255\255\032\001\033\001\255\255\
\255\255\255\255\255\255\038\001\255\255\255\255\041\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\050\001\
\051\001\052\001\093\001\094\001\095\001\096\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\108\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\131\001\132\001\093\001\094\001\095\001\096\001\005\001\006\001\
\007\001\008\001\009\001\255\255\255\255\255\255\013\001\014\001\
\255\255\108\001\017\001\018\001\255\255\020\001\255\255\022\001\
\255\255\024\001\255\255\255\255\027\001\028\001\255\255\255\255\
\255\255\032\001\033\001\255\255\255\255\255\255\255\255\038\001\
\131\001\132\001\041\001\255\255\255\255\255\255\005\001\006\001\
\007\001\008\001\009\001\050\001\051\001\052\001\013\001\014\001\
\255\255\255\255\255\255\018\001\255\255\020\001\255\255\255\255\
\255\255\255\255\255\255\255\255\027\001\028\001\255\255\255\255\
\255\255\032\001\033\001\255\255\255\255\255\255\255\255\038\001\
\255\255\255\255\041\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\050\001\051\001\052\001\093\001\094\001\
\095\001\096\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\108\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\131\001\132\001\093\001\094\001\
\095\001\096\001\005\001\006\001\007\001\008\001\009\001\255\255\
\255\255\255\255\013\001\014\001\255\255\108\001\255\255\018\001\
\255\255\255\255\255\255\255\255\023\001\255\255\255\255\255\255\
\027\001\028\001\255\255\255\255\255\255\032\001\033\001\255\255\
\255\255\255\255\255\255\038\001\131\001\132\001\041\001\255\255\
\255\255\255\255\005\001\006\001\007\001\008\001\009\001\050\001\
\051\001\052\001\013\001\014\001\255\255\255\255\255\255\018\001\
\255\255\255\255\255\255\255\255\023\001\255\255\255\255\255\255\
\027\001\028\001\255\255\255\255\255\255\032\001\033\001\255\255\
\255\255\255\255\255\255\038\001\255\255\255\255\041\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\050\001\
\051\001\052\001\093\001\094\001\095\001\096\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\108\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\131\001\132\001\093\001\094\001\095\001\096\001\005\001\006\001\
\007\001\008\001\009\001\255\255\255\255\255\255\013\001\014\001\
\255\255\108\001\255\255\018\001\255\255\020\001\255\255\255\255\
\255\255\255\255\255\255\255\255\027\001\028\001\255\255\255\255\
\255\255\032\001\033\001\255\255\255\255\255\255\255\255\038\001\
\131\001\132\001\041\001\255\255\255\255\255\255\005\001\006\001\
\007\001\008\001\009\001\050\001\051\001\052\001\013\001\014\001\
\255\255\255\255\255\255\018\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\027\001\028\001\255\255\255\255\
\255\255\032\001\033\001\255\255\255\255\036\001\255\255\038\001\
\255\255\255\255\041\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\050\001\051\001\052\001\093\001\094\001\
\095\001\096\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\108\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\131\001\132\001\093\001\094\001\
\095\001\096\001\005\001\006\001\007\001\008\001\009\001\255\255\
\255\255\255\255\013\001\014\001\255\255\108\001\255\255\018\001\
\255\255\020\001\255\255\255\255\255\255\255\255\255\255\255\255\
\027\001\028\001\255\255\255\255\255\255\032\001\033\001\255\255\
\255\255\255\255\255\255\038\001\131\001\132\001\041\001\255\255\
\255\255\255\255\005\001\006\001\007\001\008\001\009\001\050\001\
\051\001\052\001\013\001\014\001\255\255\255\255\255\255\018\001\
\255\255\255\255\255\255\255\255\023\001\255\255\255\255\255\255\
\027\001\028\001\255\255\255\255\255\255\032\001\033\001\255\255\
\255\255\255\255\255\255\038\001\255\255\255\255\041\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\050\001\
\051\001\052\001\093\001\094\001\095\001\096\001\255\255\255\255\
\014\001\255\255\255\255\255\255\018\001\019\001\255\255\255\255\
\022\001\108\001\255\255\025\001\255\255\255\255\255\255\255\255\
\255\255\005\001\006\001\007\001\008\001\009\001\036\001\255\255\
\255\255\013\001\014\001\041\001\255\255\255\255\018\001\019\001\
\131\001\132\001\093\001\094\001\095\001\096\001\052\001\027\001\
\028\001\255\255\255\255\255\255\032\001\033\001\255\255\255\255\
\255\255\108\001\038\001\255\255\255\255\041\001\255\255\255\255\
\255\255\005\001\006\001\007\001\008\001\009\001\050\001\051\001\
\052\001\013\001\014\001\255\255\255\255\255\255\018\001\019\001\
\131\001\132\001\255\255\255\255\255\255\255\255\255\255\027\001\
\028\001\255\255\255\255\255\255\032\001\033\001\255\255\255\255\
\255\255\255\255\038\001\255\255\255\255\041\001\108\001\255\255\
\255\255\255\255\112\001\255\255\255\255\255\255\050\001\051\001\
\052\001\093\001\094\001\095\001\096\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\131\001\255\255\255\255\
\108\001\255\255\255\255\255\255\138\001\255\255\255\255\255\255\
\005\001\006\001\007\001\008\001\009\001\255\255\255\255\255\255\
\013\001\014\001\255\255\255\255\255\255\018\001\255\255\131\001\
\132\001\093\001\094\001\095\001\096\001\255\255\027\001\028\001\
\255\255\017\001\255\255\032\001\033\001\255\255\255\255\255\255\
\108\001\038\001\255\255\255\255\041\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\050\001\051\001\052\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\131\001\
\132\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\057\001\058\001\059\001\060\001\061\001\062\001\063\001\
\064\001\065\001\066\001\067\001\068\001\255\255\255\255\255\255\
\255\255\255\255\074\001\075\001\076\001\077\001\078\001\079\001\
\093\001\094\001\095\001\096\001\017\001\255\255\019\001\020\001\
\255\255\255\255\255\255\255\255\025\001\255\255\255\255\108\001\
\255\255\030\001\255\255\099\001\255\255\255\255\035\001\036\001\
\104\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\131\001\132\001\
\255\255\255\255\255\255\255\255\057\001\058\001\059\001\060\001\
\061\001\062\001\063\001\064\001\065\001\066\001\067\001\068\001\
\069\001\070\001\071\001\072\001\073\001\074\001\075\001\076\001\
\077\001\078\001\079\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\097\001\255\255\099\001\100\001\
\101\001\255\255\103\001\104\001\105\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\114\001\255\255\255\255\
\017\001\255\255\019\001\020\001\255\255\255\255\255\255\255\255\
\025\001\126\001\127\001\128\001\129\001\030\001\255\255\255\255\
\133\001\255\255\035\001\036\001\255\255\138\001\255\255\255\255\
\255\255\142\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\057\001\058\001\059\001\060\001\061\001\062\001\063\001\064\001\
\065\001\066\001\067\001\068\001\069\001\070\001\071\001\072\001\
\073\001\074\001\075\001\076\001\077\001\078\001\079\001\014\001\
\255\255\255\255\255\255\018\001\019\001\255\255\255\255\022\001\
\255\255\255\255\025\001\255\255\255\255\255\255\255\255\255\255\
\097\001\255\255\099\001\100\001\101\001\036\001\103\001\104\001\
\105\001\255\255\041\001\014\001\255\255\255\255\255\255\018\001\
\019\001\114\001\255\255\022\001\255\255\052\001\025\001\255\255\
\255\255\255\255\255\255\255\255\255\255\126\001\127\001\128\001\
\129\001\036\001\255\255\014\001\133\001\255\255\041\001\018\001\
\019\001\138\001\255\255\022\001\255\255\142\001\025\001\014\001\
\255\255\052\001\255\255\018\001\019\001\255\255\255\255\022\001\
\255\255\036\001\025\001\255\255\255\255\255\255\041\001\255\255\
\255\255\255\255\255\255\255\255\255\255\036\001\255\255\255\255\
\255\255\052\001\041\001\255\255\255\255\108\001\255\255\255\255\
\255\255\112\001\255\255\255\255\255\255\052\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\131\001\255\255\255\255\255\255\
\255\255\108\001\255\255\138\001\255\255\112\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\131\001\108\001\255\255\255\255\255\255\112\001\014\001\138\001\
\255\255\017\001\018\001\255\255\255\255\108\001\022\001\255\255\
\255\255\112\001\255\255\255\255\255\255\255\255\255\255\255\255\
\131\001\255\255\255\255\255\255\036\001\255\255\255\255\138\001\
\255\255\041\001\255\255\255\255\131\001\255\255\255\255\255\255\
\255\255\255\255\255\255\138\001\052\001\255\255\255\255\255\255\
\255\255\057\001\058\001\059\001\060\001\061\001\062\001\063\001\
\064\001\065\001\066\001\067\001\068\001\069\001\070\001\071\001\
\072\001\073\001\074\001\075\001\076\001\077\001\078\001\079\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\014\001\255\255\255\255\017\001\
\018\001\255\255\255\255\099\001\022\001\101\001\255\255\103\001\
\104\001\255\255\255\255\255\255\108\001\255\255\255\255\255\255\
\112\001\035\001\036\001\255\255\255\255\255\255\255\255\041\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\129\001\052\001\131\001\255\255\133\001\255\255\057\001\
\058\001\059\001\060\001\061\001\062\001\063\001\064\001\065\001\
\066\001\067\001\068\001\069\001\070\001\071\001\072\001\073\001\
\074\001\075\001\076\001\077\001\078\001\079\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\017\001\255\255\255\255\020\001\255\255\255\255\
\255\255\099\001\025\001\101\001\255\255\103\001\104\001\030\001\
\255\255\255\255\108\001\255\255\255\255\036\001\112\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\129\001\
\255\255\131\001\057\001\058\001\059\001\060\001\061\001\062\001\
\063\001\064\001\065\001\066\001\067\001\068\001\069\001\070\001\
\071\001\072\001\073\001\074\001\075\001\076\001\077\001\078\001\
\079\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\097\001\255\255\099\001\255\255\101\001\255\255\
\103\001\104\001\105\001\255\255\255\255\255\255\255\255\255\255\
\255\255\017\001\255\255\114\001\020\001\255\255\255\255\255\255\
\255\255\025\001\255\255\255\255\255\255\255\255\030\001\126\001\
\127\001\128\001\129\001\255\255\036\001\255\255\133\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\057\001\058\001\059\001\060\001\061\001\062\001\063\001\
\064\001\065\001\066\001\067\001\068\001\069\001\070\001\071\001\
\072\001\073\001\074\001\075\001\076\001\077\001\078\001\079\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\014\001\255\255\255\255\017\001\255\255\
\255\255\097\001\255\255\099\001\255\255\101\001\255\255\103\001\
\104\001\105\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\036\001\114\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\126\001\127\001\
\128\001\129\001\255\255\255\255\255\255\133\001\057\001\058\001\
\059\001\060\001\061\001\062\001\063\001\064\001\065\001\066\001\
\067\001\068\001\255\255\255\255\255\255\255\255\255\255\074\001\
\075\001\076\001\077\001\078\001\079\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\015\001\255\255\017\001\255\255\
\019\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\099\001\255\255\255\255\255\255\255\255\104\001\105\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\114\001\
\255\255\116\001\117\001\118\001\119\001\120\001\121\001\122\001\
\255\255\255\255\255\255\126\001\127\001\128\001\057\001\058\001\
\059\001\060\001\061\001\062\001\063\001\064\001\065\001\066\001\
\067\001\068\001\069\001\070\001\071\001\072\001\073\001\074\001\
\075\001\076\001\077\001\078\001\079\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\015\001\255\255\017\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\099\001\255\255\101\001\255\255\103\001\104\001\255\255\255\255\
\034\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\129\001\057\001\
\058\001\059\001\060\001\061\001\062\001\063\001\064\001\065\001\
\066\001\067\001\068\001\069\001\070\001\071\001\072\001\073\001\
\074\001\075\001\076\001\077\001\078\001\079\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\015\001\255\255\
\017\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\099\001\255\255\101\001\255\255\103\001\104\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\129\001\
\057\001\058\001\059\001\060\001\061\001\062\001\063\001\064\001\
\065\001\066\001\067\001\068\001\069\001\070\001\071\001\072\001\
\073\001\074\001\075\001\076\001\077\001\078\001\079\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\015\001\
\255\255\017\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\099\001\255\255\101\001\255\255\103\001\104\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\129\001\057\001\058\001\059\001\060\001\061\001\062\001\063\001\
\064\001\065\001\066\001\067\001\068\001\069\001\070\001\071\001\
\072\001\073\001\074\001\075\001\076\001\077\001\078\001\079\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\016\001\017\001\255\255\255\255\255\255\021\001\255\255\
\255\255\255\255\255\255\099\001\255\255\101\001\255\255\103\001\
\104\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\129\001\057\001\058\001\059\001\060\001\061\001\062\001\
\063\001\064\001\065\001\066\001\067\001\068\001\069\001\070\001\
\071\001\072\001\073\001\074\001\075\001\076\001\077\001\078\001\
\079\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\016\001\017\001\255\255\255\255\255\255\021\001\
\255\255\255\255\255\255\098\001\099\001\255\255\101\001\255\255\
\103\001\104\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\129\001\057\001\058\001\059\001\060\001\061\001\
\062\001\063\001\064\001\065\001\066\001\067\001\068\001\069\001\
\070\001\071\001\072\001\073\001\074\001\075\001\076\001\077\001\
\078\001\079\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\017\001\255\255\255\255\020\001\
\255\255\255\255\255\255\255\255\098\001\099\001\255\255\101\001\
\255\255\103\001\104\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\129\001\057\001\058\001\059\001\060\001\
\061\001\062\001\063\001\064\001\065\001\066\001\067\001\068\001\
\069\001\070\001\071\001\072\001\073\001\074\001\075\001\076\001\
\077\001\078\001\079\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\017\001\255\255\255\255\
\020\001\255\255\255\255\255\255\255\255\255\255\099\001\255\255\
\101\001\255\255\103\001\104\001\105\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\114\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\126\001\127\001\128\001\129\001\057\001\058\001\059\001\
\060\001\061\001\062\001\063\001\064\001\065\001\066\001\067\001\
\068\001\069\001\070\001\071\001\072\001\073\001\074\001\075\001\
\076\001\077\001\078\001\079\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\099\001\
\255\255\101\001\255\255\103\001\104\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\018\001\255\255\255\255\
\255\255\022\001\255\255\024\001\025\001\026\001\027\001\028\001\
\029\001\030\001\031\001\255\255\255\255\129\001\035\001\036\001\
\037\001\038\001\039\001\040\001\041\001\042\001\043\001\044\001\
\045\001\046\001\047\001\048\001\049\001\050\001\051\001\052\001\
\053\001\054\001\055\001\056\001\018\001\255\255\255\255\255\255\
\022\001\255\255\024\001\025\001\026\001\027\001\028\001\029\001\
\030\001\031\001\255\255\255\255\255\255\035\001\036\001\037\001\
\038\001\039\001\040\001\041\001\042\001\043\001\044\001\045\001\
\046\001\047\001\048\001\049\001\050\001\051\001\052\001\053\001\
\054\001\055\001\056\001\014\001\255\255\255\255\017\001\018\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\112\001\255\255\255\255\255\255\255\255\
\255\255\255\255\014\001\255\255\255\255\017\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\057\001\058\001\
\059\001\060\001\061\001\062\001\063\001\064\001\065\001\066\001\
\067\001\068\001\112\001\255\255\017\001\255\255\255\255\255\255\
\255\255\076\001\077\001\078\001\079\001\057\001\058\001\059\001\
\060\001\061\001\062\001\063\001\064\001\065\001\066\001\067\001\
\068\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\076\001\077\001\078\001\079\001\255\255\104\001\255\255\255\255\
\255\255\255\255\255\255\255\255\057\001\058\001\059\001\060\001\
\061\001\062\001\063\001\064\001\065\001\066\001\067\001\068\001\
\255\255\255\255\255\255\255\255\104\001\074\001\075\001\076\001\
\077\001\078\001\079\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\005\001\006\001\007\001\008\001\255\255\255\255\099\001\255\255\
\255\255\014\001\255\255\104\001\017\001\018\001\019\001\020\001\
\021\001\255\255\255\255\255\255\025\001\255\255\027\001\028\001\
\029\001\030\001\031\001\255\255\033\001\255\255\035\001\036\001\
\037\001\038\001\039\001\040\001\041\001\042\001\043\001\044\001\
\045\001\046\001\047\001\048\001\049\001\050\001\051\001\052\001\
\053\001\054\001\055\001\056\001\255\255\255\255\255\255\255\255\
\005\001\006\001\007\001\008\001\255\255\255\255\255\255\255\255\
\255\255\014\001\255\255\255\255\017\001\018\001\019\001\020\001\
\021\001\255\255\255\255\255\255\025\001\082\001\027\001\028\001\
\029\001\030\001\031\001\088\001\033\001\255\255\035\001\036\001\
\037\001\038\001\039\001\040\001\041\001\042\001\043\001\044\001\
\045\001\046\001\047\001\048\001\049\001\050\001\051\001\052\001\
\053\001\054\001\055\001\056\001\255\255\255\255\255\255\255\255\
\005\001\006\001\007\001\008\001\255\255\255\255\255\255\255\255\
\255\255\014\001\255\255\255\255\017\001\018\001\019\001\020\001\
\021\001\255\255\255\255\255\255\025\001\082\001\027\001\028\001\
\029\001\030\001\031\001\088\001\033\001\255\255\035\001\255\255\
\037\001\038\001\039\001\040\001\041\001\042\001\043\001\044\001\
\045\001\046\001\047\001\048\001\049\001\050\001\051\001\052\001\
\053\001\054\001\055\001\056\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\082\001\255\255\255\255\
\255\255\255\255\255\255\088\001"

let yynames_const = "\
  "

let yynames_block = "\
  TUnknown\000\
  TCommentSpace\000\
  TCommentNewline\000\
  TComment\000\
  TInt\000\
  TFloat\000\
  TChar\000\
  TString\000\
  TQuote\000\
  TPct\000\
  TFormat\000\
  TSubString\000\
  TDecimal\000\
  TIdent\000\
  TKRParam\000\
  Tconstructorname\000\
  TypedefIdent\000\
  TOPar\000\
  TCPar\000\
  TOBrace\000\
  TCBrace\000\
  TOCro\000\
  TCCro\000\
  TDot\000\
  TComma\000\
  TPtrOp\000\
  TInc\000\
  TDec\000\
  TAssign\000\
  TEq\000\
  TWhy\000\
  TTilde\000\
  TBang\000\
  TEllipsis\000\
  TDotDot\000\
  TPtVirg\000\
  TOrLog\000\
  TAndLog\000\
  TOr\000\
  TXor\000\
  TAnd\000\
  TEqEq\000\
  TNotEq\000\
  TInf\000\
  TSup\000\
  TInfEq\000\
  TSupEq\000\
  TShl\000\
  TShr\000\
  TPlus\000\
  TMinus\000\
  TMul\000\
  TDiv\000\
  TMod\000\
  TMax\000\
  TMin\000\
  Tchar\000\
  Tshort\000\
  Tint\000\
  Tdouble\000\
  Tfloat\000\
  Tlong\000\
  Tunsigned\000\
  Tsigned\000\
  Tvoid\000\
  Tsize_t\000\
  Tssize_t\000\
  Tptrdiff_t\000\
  Tauto\000\
  Tregister\000\
  Textern\000\
  Tstatic\000\
  Ttypedef\000\
  Tconst\000\
  Tvolatile\000\
  Tstruct\000\
  Tunion\000\
  Tenum\000\
  Tdecimal\000\
  Texec\000\
  Tbreak\000\
  Telse\000\
  Tswitch\000\
  Tcase\000\
  Tcontinue\000\
  Tfor\000\
  Tdo\000\
  Tif\000\
  Twhile\000\
  Treturn\000\
  Tgoto\000\
  Tdefault\000\
  Tsizeof\000\
  Tnew\000\
  Tdelete\000\
  Tdefined\000\
  TOParCplusplusInit\000\
  Tnamespace\000\
  Trestrict\000\
  Tasm\000\
  Tattribute\000\
  TattributeNoarg\000\
  Tinline\000\
  Ttypeof\000\
  TDefine\000\
  TDefParamVariadic\000\
  TCppEscapedNewline\000\
  TCppConcatOp\000\
  TOParDefine\000\
  TOBraceDefineInit\000\
  TIdentDefine\000\
  TDefEOL\000\
  TInclude\000\
  TIncludeStart\000\
  TIncludeFilename\000\
  TIfdef\000\
  TIfdefelif\000\
  TIfdefelse\000\
  TEndif\000\
  TIfdefBool\000\
  TIfdefMisc\000\
  TIfdefVersion\000\
  TUifdef\000\
  TUelseif\000\
  TUendif\000\
  TUndef\000\
  TPragma\000\
  TCppDirectiveOther\000\
  TMacroAttr\000\
  TMacroStmt\000\
  TMacroIdentBuilder\000\
  TMacroString\000\
  TMacroDecl\000\
  TMacroDeclConst\000\
  TMacroIterator\000\
  TCommentSkipTagStart\000\
  TCommentSkipTagEnd\000\
  TCParEOL\000\
  TAction\000\
  TCommentMisc\000\
  TCommentCpp\000\
  EOF\000\
  TTODO\000\
  "

let yyact = [|
  (fun _ -> failwith "parser")
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'translation_unit) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 667 "parser_c.mly"
                          ( _1 )
# 3192 "parser_c.ml"
               : Ast_c.program))
; (fun __caml_parser_env ->
    Obj.repr(
# 671 "parser_c.mly"
     ( [] )
# 3198 "parser_c.ml"
               : 'translation_unit))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'translation_unit) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'external_declaration) in
    Obj.repr(
# 673 "parser_c.mly"
     ( !LP._lexer_hint.context_stack <- [LP.InTopLevel]; _1 @ [_2] )
# 3206 "parser_c.ml"
               : 'translation_unit))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 5 : 'translation_unit) in
    let _2 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 3 : string * Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : 'translation_unit) in
    let _6 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 675 "parser_c.mly"
     ( !LP._lexer_hint.context_stack <- [LP.InTopLevel];
       _1 @ [Namespace (_5, [_2; snd _3; _4; _6])] )
# 3219 "parser_c.ml"
               : 'translation_unit))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 688 "parser_c.mly"
                ( _1 )
# 3226 "parser_c.ml"
               : 'ident))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 689 "parser_c.mly"
                ( _1 )
# 3233 "parser_c.ml"
               : 'ident))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 693 "parser_c.mly"
                ( _1 )
# 3240 "parser_c.ml"
               : 'identifier))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 702 "parser_c.mly"
     ( RegularName (mk_string_wrap _1) )
# 3247 "parser_c.ml"
               : 'identifier_cpp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'ident_extra_cpp) in
    Obj.repr(
# 703 "parser_c.mly"
                   ( _1 )
# 3254 "parser_c.ml"
               : 'identifier_cpp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 707 "parser_c.mly"
     ( RegularName (mk_string_wrap _1) )
# 3261 "parser_c.ml"
               : 'ident_cpp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 709 "parser_c.mly"
     ( RegularName (mk_string_wrap _1) )
# 3268 "parser_c.ml"
               : 'ident_cpp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'ident_extra_cpp) in
    Obj.repr(
# 710 "parser_c.mly"
                   ( _1 )
# 3275 "parser_c.ml"
               : 'ident_cpp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : string * Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'identifier_cpp_list) in
    Obj.repr(
# 714 "parser_c.mly"
     (
       CppConcatenatedName (
         match _3 with
         | [] -> raise (Impossible 87)
         | (x,concatnull)::xs ->
             assert (concatnull = []);
             (mk_string_wrap _1, [])::(x,[_2])::xs
       )
   )
# 3292 "parser_c.ml"
               : 'ident_extra_cpp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 724 "parser_c.mly"
     ( CppVariadicName (fst _2, [_1; snd _2]) )
# 3300 "parser_c.ml"
               : 'ident_extra_cpp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : (string * Ast_c.info)) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'param_define_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 726 "parser_c.mly"
     ( CppIdentBuilder ((fst _1, [snd _1;_2;_4]), _3) )
# 3310 "parser_c.ml"
               : 'ident_extra_cpp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 729 "parser_c.mly"
          ( [mk_string_wrap _1, []] )
# 3317 "parser_c.ml"
               : 'identifier_cpp_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'identifier_cpp_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 730 "parser_c.mly"
                                           ( _1 @ [mk_string_wrap _3, [_2]] )
# 3326 "parser_c.ml"
               : 'identifier_cpp_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'assign_expr) in
    Obj.repr(
# 737 "parser_c.mly"
                           ( _1 )
# 3333 "parser_c.ml"
               : Ast_c.expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.expression) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'assign_expr) in
    Obj.repr(
# 738 "parser_c.mly"
                           ( mk_e (Sequence (_1,_3)) [_2] )
# 3342 "parser_c.ml"
               : Ast_c.expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'cond_expr) in
    Obj.repr(
# 744 "parser_c.mly"
                                 ( _1 )
# 3349 "parser_c.ml"
               : 'assign_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'cast_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.assignOp) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'assign_expr) in
    Obj.repr(
# 745 "parser_c.mly"
                                 ( mk_e(Assignment (_1, _2, _3)) [])
# 3358 "parser_c.ml"
               : 'assign_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'cast_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'assign_expr) in
    Obj.repr(
# 746 "parser_c.mly"
                                 ( mk_e (Assignment (_1, (SimpleAssign, [_2]),_3)) [])
# 3367 "parser_c.ml"
               : 'assign_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 754 "parser_c.mly"
     ( _1 )
# 3374 "parser_c.ml"
               : 'cond_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'gcc_opt_expr) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : 'assign_expr) in
    Obj.repr(
# 756 "parser_c.mly"
     ( mk_e (CondExpr (_1,_3,_5)) [_2;_4] )
# 3385 "parser_c.ml"
               : 'cond_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'cast_expr) in
    Obj.repr(
# 760 "parser_c.mly"
                                 ( _1 )
# 3392 "parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 761 "parser_c.mly"
                                 ( mk_e(Binary (_1, (Arith Mul,[_2]), _3)) [] )
# 3401 "parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 762 "parser_c.mly"
                                 ( mk_e(Binary (_1, (Arith Div, [_2]), _3)) [] )
# 3410 "parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 763 "parser_c.mly"
                                 ( mk_e(Binary (_1, (Arith Min, [_2]), _3)) [] )
# 3419 "parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 764 "parser_c.mly"
                                 ( mk_e(Binary (_1, (Arith Max, [_2]), _3)) [] )
# 3428 "parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 765 "parser_c.mly"
                                 ( mk_e(Binary (_1, (Arith Mod, [_2]), _3)) [] )
# 3437 "parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 766 "parser_c.mly"
                                 ( mk_e(Binary (_1, (Arith Plus, [_2]), _3)) [] )
# 3446 "parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 767 "parser_c.mly"
                                 ( mk_e(Binary (_1, (Arith Minus, [_2]), _3)) [] )
# 3455 "parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 768 "parser_c.mly"
                                 ( mk_e(Binary (_1, (Arith DecLeft, [_2]), _3)) [] )
# 3464 "parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 769 "parser_c.mly"
                                 ( mk_e(Binary (_1, (Arith DecRight, [_2]), _3)) [] )
# 3473 "parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 770 "parser_c.mly"
                                 ( mk_e(Binary (_1, (Logical Inf, [_2]), _3)) [] )
# 3482 "parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 771 "parser_c.mly"
                                 ( mk_e(Binary (_1, (Logical Sup, [_2]), _3)) [] )
# 3491 "parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 772 "parser_c.mly"
                                 ( mk_e(Binary (_1, (Logical InfEq, [_2]), _3)) [] )
# 3500 "parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 773 "parser_c.mly"
                                 ( mk_e(Binary (_1, (Logical SupEq, [_2]), _3)) [] )
# 3509 "parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 774 "parser_c.mly"
                                 ( mk_e(Binary (_1, (Logical Eq, [_2]), _3)) [] )
# 3518 "parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 775 "parser_c.mly"
                                 ( mk_e(Binary (_1, (Logical NotEq, [_2]), _3)) [] )
# 3527 "parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 776 "parser_c.mly"
                                 ( mk_e(Binary (_1, (Arith And, [_2]), _3)) [] )
# 3536 "parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 777 "parser_c.mly"
                                 ( mk_e(Binary (_1, (Arith Or, [_2]), _3)) [] )
# 3545 "parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 778 "parser_c.mly"
                                 ( mk_e(Binary (_1, (Arith Xor, [_2]), _3)) [] )
# 3554 "parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 779 "parser_c.mly"
                                 ( mk_e(Binary (_1, (Logical AndLog, [_2]), _3)) [] )
# 3563 "parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 780 "parser_c.mly"
                                 ( mk_e(Binary (_1, (Logical OrLog, [_2]), _3)) [] )
# 3572 "parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'unary_expr) in
    Obj.repr(
# 783 "parser_c.mly"
                                     ( _1 )
# 3579 "parser_c.ml"
               : 'cast_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'topar2) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.fullType) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'tcpar2) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'cast_expr) in
    Obj.repr(
# 784 "parser_c.mly"
                                     ( mk_e(Cast (_2, _4)) [_1;_3] )
# 3589 "parser_c.ml"
               : 'cast_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'postfix_expr) in
    Obj.repr(
# 792 "parser_c.mly"
                                   ( _1 )
# 3596 "parser_c.ml"
               : 'unary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'unary_expr) in
    Obj.repr(
# 793 "parser_c.mly"
                                   ( mk_e(Infix (_2, Inc))    [_1] )
# 3604 "parser_c.ml"
               : 'unary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'unary_expr) in
    Obj.repr(
# 794 "parser_c.mly"
                                   ( mk_e(Infix (_2, Dec))    [_1] )
# 3612 "parser_c.ml"
               : 'unary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'unary_op) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'cast_expr) in
    Obj.repr(
# 795 "parser_c.mly"
                                   ( mk_e(Unary (_2, fst _1)) [snd _1] )
# 3620 "parser_c.ml"
               : 'unary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'unary_expr) in
    Obj.repr(
# 796 "parser_c.mly"
                                   ( mk_e(SizeOfExpr (_2))    [_1] )
# 3628 "parser_c.ml"
               : 'unary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'topar2) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.fullType) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'tcpar2) in
    Obj.repr(
# 797 "parser_c.mly"
                                   ( mk_e(SizeOfType (_3))    [_1;_2;_4] )
# 3638 "parser_c.ml"
               : 'unary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'new_argument) in
    Obj.repr(
# 798 "parser_c.mly"
                                   ( mk_e(New (None, _2))     [_1] )
# 3646 "parser_c.ml"
               : 'unary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'argument_list_ne) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : 'new_argument) in
    Obj.repr(
# 799 "parser_c.mly"
                                                  ( mk_e(New (Some _3, _5))             [_1; _2; _4] )
# 3657 "parser_c.ml"
               : 'unary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'cast_expr) in
    Obj.repr(
# 800 "parser_c.mly"
                                   ( mk_e(Delete _2)          [_1] )
# 3665 "parser_c.ml"
               : 'unary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'identifier_cpp) in
    Obj.repr(
# 801 "parser_c.mly"
                                   ( mk_e(Defined _2)         [_1] )
# 3673 "parser_c.ml"
               : 'unary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'identifier_cpp) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 803 "parser_c.mly"
 ( mk_e(Defined _3) [_1;_2;_4] )
# 3683 "parser_c.ml"
               : 'unary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : string * Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'argument_list_ne) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 807 "parser_c.mly"
     ( let fn = mk_e(Ident (RegularName (mk_string_wrap _1))) [] in
       Left (mk_e(FunCall (fn, _3)) [_2;_4]) )
# 3694 "parser_c.ml"
               : 'new_argument))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : string * Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 810 "parser_c.mly"
     ( let fn = mk_e(Ident (RegularName (mk_string_wrap _1))) [] in
       Left(mk_e(FunCall (fn, [])) [_2;_3]) )
# 3704 "parser_c.ml"
               : 'new_argument))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : string * Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'argument_list_ne) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 813 "parser_c.mly"
     ( let fn = mk_e(Ident (RegularName (mk_string_wrap _1))) [] in
       Left (mk_e(FunCall (fn, _3)) [_2;_4]) )
# 3715 "parser_c.ml"
               : 'new_argument))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : string * Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 816 "parser_c.mly"
     ( let fn = mk_e(Ident (RegularName (mk_string_wrap _1))) [] in
       Left (mk_e(FunCall (fn, [])) [_2;_3]) )
# 3725 "parser_c.ml"
               : 'new_argument))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'type_spec) in
    Obj.repr(
# 819 "parser_c.mly"
     ( let ty = addTypeD (_1,nullDecl) in
       let ((returnType,hasreg), iihasreg) = fixDeclSpecForParam ty in
       Right (ArgType { p_namei = None; p_type = returnType;
			p_register = hasreg, iihasreg;
		      } )
     )
# 3737 "parser_c.ml"
               : 'new_argument))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'new_argument) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.expression) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 826 "parser_c.mly"
     (
       match _1 with
	 Left(e) -> Left(mk_e(ArrayAccess (e, _3)) [_2;_4])
       | Right(ArgType(ty)) -> (* lots of hacks to make the right type *)
	   let fty = mk_ty (Array (Some _3, ty.Ast_c.p_type)) [_2;_4] in
	   let pty = { ty with p_type = fty } in
	   Right(ArgType pty)
       | _ -> raise (Impossible 88)
     )
# 3755 "parser_c.ml"
               : 'new_argument))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 837 "parser_c.mly"
          ( GetRef,     _1 )
# 3762 "parser_c.ml"
               : 'unary_op))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 838 "parser_c.mly"
          ( DeRef,      _1 )
# 3769 "parser_c.ml"
               : 'unary_op))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 839 "parser_c.mly"
          ( UnPlus,     _1 )
# 3776 "parser_c.ml"
               : 'unary_op))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 840 "parser_c.mly"
          ( UnMinus,    _1 )
# 3783 "parser_c.ml"
               : 'unary_op))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 841 "parser_c.mly"
          ( Tilde,      _1 )
# 3790 "parser_c.ml"
               : 'unary_op))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 842 "parser_c.mly"
          ( Not,        _1 )
# 3797 "parser_c.ml"
               : 'unary_op))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 846 "parser_c.mly"
           ( GetRefLabel, _1 )
# 3804 "parser_c.ml"
               : 'unary_op))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'primary_expr) in
    Obj.repr(
# 849 "parser_c.mly"
                              ( _1 )
# 3811 "parser_c.ml"
               : 'postfix_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'postfix_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.expression) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 851 "parser_c.mly"
     ( mk_e(ArrayAccess (_1, _3)) [_2;_4] )
# 3821 "parser_c.ml"
               : 'postfix_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'postfix_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'argument_list_ne) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 853 "parser_c.mly"
     ( mk_e(FunCall (_1, _3)) [_2;_4] )
# 3831 "parser_c.ml"
               : 'postfix_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'postfix_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 854 "parser_c.mly"
                              ( mk_e(FunCall (_1, [])) [_2;_3] )
# 3840 "parser_c.ml"
               : 'postfix_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'postfix_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'ident_cpp) in
    Obj.repr(
# 855 "parser_c.mly"
                                 ( mk_e(RecordAccess   (_1,_3)) [_2] )
# 3849 "parser_c.ml"
               : 'postfix_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'postfix_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'ident_cpp) in
    Obj.repr(
# 856 "parser_c.mly"
                                 ( mk_e(RecordPtAccess (_1,_3)) [_2] )
# 3858 "parser_c.ml"
               : 'postfix_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'postfix_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 857 "parser_c.mly"
                              ( mk_e(Postfix (_1, Inc)) [_2] )
# 3866 "parser_c.ml"
               : 'postfix_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'postfix_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 858 "parser_c.mly"
                              ( mk_e(Postfix (_1, Dec)) [_2] )
# 3874 "parser_c.ml"
               : 'postfix_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : 'topar2) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.fullType) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'tcpar2) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 862 "parser_c.mly"
     ( mk_e(Constructor (_2, (InitList [], [_4;_5]))) [_1;_3] )
# 3885 "parser_c.ml"
               : 'postfix_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 6 : 'topar2) in
    let _2 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.fullType) in
    let _3 = (Parsing.peek_val __caml_parser_env 4 : 'tcpar2) in
    let _4 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 2 : 'initialize_list) in
    let _6 = (Parsing.peek_val __caml_parser_env 1 : 'gcc_comma_opt_struct) in
    let _7 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 864 "parser_c.mly"
     ( mk_e(Constructor (_2, (InitList (List.rev _5),[_4;_7] @ _6))) [_1;_3] )
# 3898 "parser_c.ml"
               : 'postfix_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'identifier_cpp) in
    Obj.repr(
# 868 "parser_c.mly"
                   ( mk_e(Ident  (_1)) [] )
# 3905 "parser_c.ml"
               : 'primary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * (Ast_c.sign * Ast_c.base)) * Ast_c.info) in
    Obj.repr(
# 870 "parser_c.mly"
    ( let (str,(sign,base)) = fst _1 in
      mk_e(Constant (Int (str,Si(sign,base)))) [snd _1] )
# 3913 "parser_c.ml"
               : 'primary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.floatType) * Ast_c.info) in
    Obj.repr(
# 872 "parser_c.mly"
           ( mk_e(Constant (Float  (fst _1))) [snd _1] )
# 3920 "parser_c.ml"
               : 'primary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.isWchar) * Ast_c.info) in
    Obj.repr(
# 873 "parser_c.mly"
           ( mk_e(Constant (String (fst _1))) [snd _1] )
# 3927 "parser_c.ml"
               : 'primary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : (string * Ast_c.isWchar) * Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'string_fragments) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.isWchar) * Ast_c.info) in
    Obj.repr(
# 875 "parser_c.mly"
     ( let ((fullstring,isW),lqinfo) = _1 in
       let (_,rqinfo) = _3 in
       mk_e (Ast_c.StringConstant(_2, fullstring, isW)) [lqinfo;rqinfo] )
# 3938 "parser_c.ml"
               : 'primary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.isWchar) * Ast_c.info) in
    Obj.repr(
# 878 "parser_c.mly"
           ( mk_e(Constant (Char   (fst _1))) [snd _1] )
# 3945 "parser_c.ml"
               : 'primary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * string (*n*) * string (*p*)) * Ast_c.info) in
    Obj.repr(
# 879 "parser_c.mly"
            ( let (a,b,c) = fst _1 in
              mk_e(Constant (DecimalConst (a,b,c))) [snd _1] )
# 3953 "parser_c.ml"
               : 'primary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.expression) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 881 "parser_c.mly"
                    ( mk_e(ParenExpr (_2)) [_1;_3] )
# 3962 "parser_c.ml"
               : 'primary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.info)) in
    Obj.repr(
# 884 "parser_c.mly"
                ( mk_e(Constant (MultiString [fst _1])) [snd _1] )
# 3969 "parser_c.ml"
               : 'primary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'string_elem) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'string_list) in
    Obj.repr(
# 886 "parser_c.mly"
     ( mk_e(Constant (MultiString ["TODO: MultiString"])) (_1 @ _2) )
# 3977 "parser_c.ml"
               : 'primary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'compound) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 889 "parser_c.mly"
                         ( mk_e(StatementExpr (_2)) [_1;_3] )
# 3986 "parser_c.ml"
               : 'primary_expr))
; (fun __caml_parser_env ->
    Obj.repr(
# 892 "parser_c.mly"
               ( [] )
# 3992 "parser_c.ml"
               : 'string_fragments))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'string_fragment) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'string_fragments) in
    Obj.repr(
# 893 "parser_c.mly"
                                    ( _1 :: _2 )
# 4000 "parser_c.ml"
               : 'string_fragments))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'string_format) in
    Obj.repr(
# 896 "parser_c.mly"
                      ( Ast_c.FormatFragment(_2), [_1] )
# 4008 "parser_c.ml"
               : 'string_fragment))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 897 "parser_c.mly"
              ( Ast_c.ConstantFragment(fst _1), [snd _1] )
# 4015 "parser_c.ml"
               : 'string_fragment))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 900 "parser_c.mly"
           ( Ast_c.ConstantFormat(fst _1), [snd _1] )
# 4022 "parser_c.ml"
               : 'string_format))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'assign_expr) in
    Obj.repr(
# 909 "parser_c.mly"
               ( Left _1 )
# 4029 "parser_c.ml"
               : 'argument_ne))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'parameter_decl) in
    Obj.repr(
# 910 "parser_c.mly"
                  ( Right (ArgType _1)  )
# 4036 "parser_c.ml"
               : 'argument_ne))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'action_higherordermacro_ne) in
    Obj.repr(
# 911 "parser_c.mly"
                              ( Right (ArgAction _1) )
# 4043 "parser_c.ml"
               : 'argument_ne))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'assign_expr) in
    Obj.repr(
# 915 "parser_c.mly"
               ( Left _1 )
# 4050 "parser_c.ml"
               : 'argument))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'parameter_decl) in
    Obj.repr(
# 916 "parser_c.mly"
                  ( Right (ArgType _1)  )
# 4057 "parser_c.ml"
               : 'argument))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'action_higherordermacro) in
    Obj.repr(
# 918 "parser_c.mly"
                           ( Right (ArgAction _1) )
# 4064 "parser_c.ml"
               : 'argument))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'taction_list_ne) in
    Obj.repr(
# 922 "parser_c.mly"
     ( if _1=[]
       then ActMisc [Ast_c.fakeInfo()]
       else ActMisc _1
     )
# 4074 "parser_c.ml"
               : 'action_higherordermacro_ne))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'taction_list) in
    Obj.repr(
# 930 "parser_c.mly"
     ( if _1=[]
       then ActMisc [Ast_c.fakeInfo()]
       else ActMisc _1
     )
# 4084 "parser_c.ml"
               : 'action_higherordermacro))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'cond_expr) in
    Obj.repr(
# 941 "parser_c.mly"
                      ( _1  )
# 4091 "parser_c.ml"
               : 'const_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 944 "parser_c.mly"
              ( et "topar2" (); _1  )
# 4098 "parser_c.ml"
               : 'topar2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 945 "parser_c.mly"
              ( et "tcpar2" (); _1 (*TODO? et ? sure ? c pas dt plutot ? *) )
# 4105 "parser_c.ml"
               : 'tcpar2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'statement2) in
    Obj.repr(
# 953 "parser_c.mly"
                      ( mk_st (fst _1) (snd _1) )
# 4112 "parser_c.ml"
               : Ast_c.statement))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'labeled) in
    Obj.repr(
# 956 "parser_c.mly"
                   ( Labeled      (fst _1), snd _1 )
# 4119 "parser_c.ml"
               : 'statement2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'compound) in
    Obj.repr(
# 957 "parser_c.mly"
                   ( Compound     (fst _1), snd _1 )
# 4126 "parser_c.ml"
               : 'statement2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'expr_statement) in
    Obj.repr(
# 958 "parser_c.mly"
                   ( ExprStatement(fst _1), snd _1 )
# 4133 "parser_c.ml"
               : 'statement2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'selection) in
    Obj.repr(
# 959 "parser_c.mly"
                   ( Selection    (fst _1), snd _1 @ [fakeInfo()] )
# 4140 "parser_c.ml"
               : 'statement2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'iteration) in
    Obj.repr(
# 960 "parser_c.mly"
                   ( Iteration    (fst _1), snd _1 @ [fakeInfo()] )
# 4147 "parser_c.ml"
               : 'statement2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'jump) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 961 "parser_c.mly"
                   ( Jump         (fst _1), snd _1 @ [_2] )
# 4155 "parser_c.ml"
               : 'statement2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'asmbody) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 964 "parser_c.mly"
                                                ( Asm _3, [_1;_2;_4;_5] )
# 4166 "parser_c.ml"
               : 'statement2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 2 : 'asmbody) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _6 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 965 "parser_c.mly"
                                                ( Asm _4, [_1;_2;_3;_5;_6] )
# 4178 "parser_c.ml"
               : 'statement2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.info)) in
    Obj.repr(
# 968 "parser_c.mly"
              ( MacroStmt, [snd _1] )
# 4185 "parser_c.ml"
               : 'statement2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'identifier) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'exec_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 970 "parser_c.mly"
                                      ( Exec(_3), [_1;snd _2;_4] )
# 4195 "parser_c.ml"
               : 'statement2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'ident_cpp) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'sw_stat_or_decl) in
    Obj.repr(
# 977 "parser_c.mly"
                                              ( Label (_1, _3),  [_2] )
# 4204 "parser_c.ml"
               : 'labeled))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'const_expr) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'sw_stat_or_decl) in
    Obj.repr(
# 978 "parser_c.mly"
                                              ( Case (_2, _4),       [_1; _3] )
# 4214 "parser_c.ml"
               : 'labeled))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 4 : 'const_expr) in
    let _3 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 2 : 'const_expr) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _6 = (Parsing.peek_val __caml_parser_env 0 : 'sw_stat_or_decl) in
    Obj.repr(
# 980 "parser_c.mly"
     ( CaseRange (_2, _4, _6), [_1;_3;_5] )
# 4226 "parser_c.ml"
               : 'labeled))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'sw_stat_or_decl) in
    Obj.repr(
# 981 "parser_c.mly"
                                         ( Default _3,             [_1; _2] )
# 4235 "parser_c.ml"
               : 'labeled))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'decl) in
    Obj.repr(
# 984 "parser_c.mly"
             ( mk_st (Decl (_1 Ast_c.LocalDecl)) Ast_c.noii )
# 4242 "parser_c.ml"
               : 'sw_stat_or_decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.statement) in
    Obj.repr(
# 985 "parser_c.mly"
             ( _1 )
# 4249 "parser_c.ml"
               : 'sw_stat_or_decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'ident_cpp) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 996 "parser_c.mly"
     ( Label (_1, (mk_st (ExprStatement None) Ast_c.noii)), [_2] )
# 4257 "parser_c.ml"
               : 'end_labeled))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'const_expr) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 998 "parser_c.mly"
     ( Case (_2, (mk_st (ExprStatement None) Ast_c.noii)), [_1;_3] )
# 4266 "parser_c.ml"
               : 'end_labeled))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1000 "parser_c.mly"
     ( Default (mk_st (ExprStatement None) Ast_c.noii),    [_1; _2] )
# 4274 "parser_c.ml"
               : 'end_labeled))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'tobrace) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'compound2) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'tcbrace) in
    Obj.repr(
# 1006 "parser_c.mly"
                                    ( _2, [_1; _3]  )
# 4283 "parser_c.ml"
               : 'compound))
; (fun __caml_parser_env ->
    Obj.repr(
# 1018 "parser_c.mly"
                     ( ([]) )
# 4289 "parser_c.ml"
               : 'compound2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'stat_or_decl_list) in
    Obj.repr(
# 1019 "parser_c.mly"
                     ( _1 )
# 4296 "parser_c.ml"
               : 'compound2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'stat_or_decl) in
    Obj.repr(
# 1023 "parser_c.mly"
                                  ( [_1] )
# 4303 "parser_c.ml"
               : 'stat_or_decl_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'end_labeled) in
    Obj.repr(
# 1025 "parser_c.mly"
                ( [StmtElem (mk_st (Labeled  (fst _1)) (snd _1))] )
# 4310 "parser_c.ml"
               : 'stat_or_decl_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'stat_or_decl) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'stat_or_decl_list) in
    Obj.repr(
# 1027 "parser_c.mly"
                                  ( _1 :: _2 )
# 4318 "parser_c.ml"
               : 'stat_or_decl_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'decl) in
    Obj.repr(
# 1030 "parser_c.mly"
             ( StmtElem (mk_st (Decl (_1 Ast_c.LocalDecl)) Ast_c.noii) )
# 4325 "parser_c.ml"
               : 'stat_or_decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.statement) in
    Obj.repr(
# 1031 "parser_c.mly"
             ( StmtElem _1 )
# 4332 "parser_c.ml"
               : 'stat_or_decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'function_definition) in
    Obj.repr(
# 1034 "parser_c.mly"
                       ( StmtElem (mk_st (NestedFunc _1) Ast_c.noii) )
# 4339 "parser_c.ml"
               : 'stat_or_decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_directive) in
    Obj.repr(
# 1038 "parser_c.mly"
     ( CppDirectiveStmt _1 )
# 4346 "parser_c.ml"
               : 'stat_or_decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_ifdef_directive) in
    Obj.repr(
# 1040 "parser_c.mly"
     ( IfdefStmt _1 )
# 4353 "parser_c.ml"
               : 'stat_or_decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1044 "parser_c.mly"
                ( None,    [_1] )
# 4360 "parser_c.ml"
               : 'expr_statement))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.expression) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1045 "parser_c.mly"
                ( Some _1, [_2] )
# 4368 "parser_c.ml"
               : 'expr_statement))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.expression) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.statement) in
    Obj.repr(
# 1049 "parser_c.mly"
     ( If (_3, _5, (mk_st (ExprStatement None) Ast_c.noii)),   [_1;_2;_4] )
# 4379 "parser_c.ml"
               : 'selection))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 6 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.expression) in
    let _4 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.statement) in
    let _6 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _7 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.statement) in
    Obj.repr(
# 1051 "parser_c.mly"
     ( If (_3, _5, _7),  [_1;_2;_4;_6] )
# 4392 "parser_c.ml"
               : 'selection))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.expression) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.statement) in
    Obj.repr(
# 1053 "parser_c.mly"
     ( Switch (_3,_5),   [_1;_2;_4]  )
# 4403 "parser_c.ml"
               : 'selection))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 8 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 7 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 6 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.expression) in
    let _5 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _6 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.statement) in
    let _7 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _8 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _9 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.statement) in
    Obj.repr(
# 1056 "parser_c.mly"
     ( Ifdef_Ite (_4,_6,_9), [_1;_2;_3;_5;_7;_8] )
# 4418 "parser_c.ml"
               : 'selection))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 10 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 9 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 8 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 7 : Ast_c.expression) in
    let _5 = (Parsing.peek_val __caml_parser_env 6 : Ast_c.info) in
    let _6 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.statement) in
    let _7 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _8 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _9 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.statement) in
    let _10 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _11 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.statement) in
    Obj.repr(
# 1059 "parser_c.mly"
     ( Ifdef_Ite2 (_4,_6,_9,_11), [_1;_2;_3;_5;_7;_8;_10] )
# 4435 "parser_c.ml"
               : 'selection))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.expression) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.statement) in
    Obj.repr(
# 1063 "parser_c.mly"
     ( While (_3,_5),                [_1;_2;_4] )
# 4446 "parser_c.ml"
               : 'iteration))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 6 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.statement) in
    let _3 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.expression) in
    let _6 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _7 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1065 "parser_c.mly"
     ( DoWhile (_2,_5),              [_1;_3;_4;_6;_7] )
# 4459 "parser_c.ml"
               : 'iteration))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 3 : 'expr_statement) in
    let _4 = (Parsing.peek_val __caml_parser_env 2 : 'expr_statement) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _6 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.statement) in
    Obj.repr(
# 1067 "parser_c.mly"
     ( For (ForExp _3,_4,(None, []),_6),    [_1;_2;_5])
# 4471 "parser_c.ml"
               : 'iteration))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 6 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 4 : 'expr_statement) in
    let _4 = (Parsing.peek_val __caml_parser_env 3 : 'expr_statement) in
    let _5 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.expression) in
    let _6 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _7 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.statement) in
    Obj.repr(
# 1069 "parser_c.mly"
     ( For (ForExp _3,_4,(Some _5, []),_7), [_1;_2;_6] )
# 4484 "parser_c.ml"
               : 'iteration))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 3 : 'decl) in
    let _4 = (Parsing.peek_val __caml_parser_env 2 : 'expr_statement) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _6 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.statement) in
    Obj.repr(
# 1072 "parser_c.mly"
     ( For (ForDecl (_3 Ast_c.LocalDecl),_4,(None, []),_6),    [_1;_2;_5])
# 4496 "parser_c.ml"
               : 'iteration))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 6 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 4 : 'decl) in
    let _4 = (Parsing.peek_val __caml_parser_env 3 : 'expr_statement) in
    let _5 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.expression) in
    let _6 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _7 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.statement) in
    Obj.repr(
# 1074 "parser_c.mly"
     ( For (ForDecl (_3 Ast_c.LocalDecl),_4,(Some _5, []),_7), [_1;_2;_6] )
# 4509 "parser_c.ml"
               : 'iteration))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : (string * Ast_c.info)) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'argument_list_ne) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.statement) in
    Obj.repr(
# 1077 "parser_c.mly"
     ( MacroIteration (fst _1, _3, _5), [snd _1;_2;_4] )
# 4520 "parser_c.ml"
               : 'iteration))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : (string * Ast_c.info)) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.statement) in
    Obj.repr(
# 1079 "parser_c.mly"
     ( MacroIteration (fst _1, [], _4), [snd _1;_2;_3] )
# 4530 "parser_c.ml"
               : 'iteration))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'ident_cpp) in
    Obj.repr(
# 1083 "parser_c.mly"
                    ( Goto (_2),  [_1] )
# 4538 "parser_c.ml"
               : 'jump))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1084 "parser_c.mly"
                ( Continue,       [_1] )
# 4545 "parser_c.ml"
               : 'jump))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1085 "parser_c.mly"
                ( Break,          [_1] )
# 4552 "parser_c.ml"
               : 'jump))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1086 "parser_c.mly"
                ( Return,         [_1] )
# 4559 "parser_c.ml"
               : 'jump))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.expression) in
    Obj.repr(
# 1087 "parser_c.mly"
                ( ReturnExpr _2,  [_1] )
# 4567 "parser_c.ml"
               : 'jump))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.expression) in
    Obj.repr(
# 1088 "parser_c.mly"
                   ( GotoComputed _3, [_1;_2] )
# 4576 "parser_c.ml"
               : 'jump))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.isWchar) * Ast_c.info) in
    Obj.repr(
# 1096 "parser_c.mly"
           ( [snd _1] )
# 4583 "parser_c.ml"
               : 'string_elem))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.info)) in
    Obj.repr(
# 1098 "parser_c.mly"
                ( [snd _1] )
# 4590 "parser_c.ml"
               : 'string_elem))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'string_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'colon_asm_list) in
    Obj.repr(
# 1102 "parser_c.mly"
                               ( _1, _2 )
# 4598 "parser_c.ml"
               : 'asmbody))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'string_list) in
    Obj.repr(
# 1103 "parser_c.mly"
               ( _1, [] )
# 4605 "parser_c.ml"
               : 'asmbody))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'colon_option_list) in
    Obj.repr(
# 1106 "parser_c.mly"
                                     ( Colon _2, [_1]   )
# 4613 "parser_c.ml"
               : 'colon_asm))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.isWchar) * Ast_c.info) in
    Obj.repr(
# 1109 "parser_c.mly"
                                ( ColonMisc, [snd _1] )
# 4620 "parser_c.ml"
               : 'colon_option))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : (string * Ast_c.isWchar) * Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'asm_expr) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1110 "parser_c.mly"
                                ( ColonExpr _3, [snd _1; _2;_4] )
# 4630 "parser_c.ml"
               : 'colon_option))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 6 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 5 : 'identifier) in
    let _3 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 3 : (string * Ast_c.isWchar) * Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _6 = (Parsing.peek_val __caml_parser_env 1 : 'asm_expr) in
    let _7 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1113 "parser_c.mly"
     ( ColonExpr _6, [_1;snd _2;_3;snd _4; _5; _7 ] )
# 4643 "parser_c.ml"
               : 'colon_option))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'identifier) in
    Obj.repr(
# 1114 "parser_c.mly"
                                    ( ColonMisc, [snd _1] )
# 4650 "parser_c.ml"
               : 'colon_option))
; (fun __caml_parser_env ->
    Obj.repr(
# 1115 "parser_c.mly"
                                    ( ColonMisc, [] )
# 4656 "parser_c.ml"
               : 'colon_option))
; (fun __caml_parser_env ->
    Obj.repr(
# 1119 "parser_c.mly"
                ( [] )
# 4662 "parser_c.ml"
               : 'exec_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'identifier_cpp) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'exec_ident) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'exec_list) in
    Obj.repr(
# 1121 "parser_c.mly"
      ( (ExecEval (_3 (mk_e (Ident _2) [])), [_1]) :: _4 )
# 4672 "parser_c.ml"
               : 'exec_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : string * Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'exec_ident2) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'exec_list) in
    Obj.repr(
# 1123 "parser_c.mly"
      ( (ExecToken, [snd _1]) :: _2 @ _3 )
# 4681 "parser_c.ml"
               : 'exec_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'token) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'exec_list) in
    Obj.repr(
# 1124 "parser_c.mly"
                    ( (ExecToken, [_1]) :: _2 )
# 4689 "parser_c.ml"
               : 'exec_list))
; (fun __caml_parser_env ->
    Obj.repr(
# 1127 "parser_c.mly"
    ( function prev -> prev )
# 4695 "parser_c.ml"
               : 'exec_ident))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : string * Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'exec_ident) in
    Obj.repr(
# 1129 "parser_c.mly"
     ( function prev ->
       let fld = RegularName (mk_string_wrap _2) in
       _3 (mk_e(RecordAccess   (prev,fld)) [_1]) )
# 4706 "parser_c.ml"
               : 'exec_ident))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : string * Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'exec_ident) in
    Obj.repr(
# 1133 "parser_c.mly"
     ( function prev ->
       let fld = RegularName (mk_string_wrap _2) in
       _3 (mk_e(RecordPtAccess   (prev,fld)) [_1]) )
# 4717 "parser_c.ml"
               : 'exec_ident))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.expression) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'exec_ident) in
    Obj.repr(
# 1137 "parser_c.mly"
     ( function prev ->
       _4 (mk_e(ArrayAccess   (prev,_2)) [_1;_3]) )
# 4728 "parser_c.ml"
               : 'exec_ident))
; (fun __caml_parser_env ->
    Obj.repr(
# 1141 "parser_c.mly"
    ( [] )
# 4734 "parser_c.ml"
               : 'exec_ident2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : string * Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'exec_ident2) in
    Obj.repr(
# 1143 "parser_c.mly"
    ( (ExecToken, [_1]) :: (ExecToken, [snd _2]) :: _3 )
# 4743 "parser_c.ml"
               : 'exec_ident2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'assign_expr) in
    Obj.repr(
# 1145 "parser_c.mly"
                      ( _1 )
# 4750 "parser_c.ml"
               : 'asm_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1148 "parser_c.mly"
            ( _1 )
# 4757 "parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1149 "parser_c.mly"
            ( _1 )
# 4764 "parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1150 "parser_c.mly"
            ( _1 )
# 4771 "parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1151 "parser_c.mly"
            ( _1 )
# 4778 "parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1152 "parser_c.mly"
            ( _1 )
# 4785 "parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1153 "parser_c.mly"
            ( _1 )
# 4792 "parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1154 "parser_c.mly"
            ( _1 )
# 4799 "parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1155 "parser_c.mly"
            ( _1 )
# 4806 "parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1156 "parser_c.mly"
            ( _1 )
# 4813 "parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1157 "parser_c.mly"
            ( _1 )
# 4820 "parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.assignOp) in
    Obj.repr(
# 1158 "parser_c.mly"
            ( List.hd (snd _1) )
# 4827 "parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1160 "parser_c.mly"
            ( _1 )
# 4834 "parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1161 "parser_c.mly"
            ( _1 )
# 4841 "parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1162 "parser_c.mly"
            ( _1 )
# 4848 "parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1163 "parser_c.mly"
            ( _1 )
# 4855 "parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1164 "parser_c.mly"
            ( _1 )
# 4862 "parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1165 "parser_c.mly"
            ( _1 )
# 4869 "parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1167 "parser_c.mly"
            ( _1 )
# 4876 "parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1168 "parser_c.mly"
            ( _1 )
# 4883 "parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1169 "parser_c.mly"
            ( _1 )
# 4890 "parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1170 "parser_c.mly"
            ( _1 )
# 4897 "parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1171 "parser_c.mly"
            ( _1 )
# 4904 "parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1172 "parser_c.mly"
            ( _1 )
# 4911 "parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1173 "parser_c.mly"
            ( _1 )
# 4918 "parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1175 "parser_c.mly"
            ( _1 )
# 4925 "parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1176 "parser_c.mly"
            ( _1 )
# 4932 "parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1179 "parser_c.mly"
            ( _1 )
# 4939 "parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1180 "parser_c.mly"
            ( _1 )
# 4946 "parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1184 "parser_c.mly"
            ( _1 )
# 4953 "parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1185 "parser_c.mly"
            ( _1 )
# 4960 "parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1186 "parser_c.mly"
            ( _1 )
# 4967 "parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 1188 "parser_c.mly"
                 ( snd _1 )
# 4974 "parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1190 "parser_c.mly"
            ( _1 )
# 4981 "parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1191 "parser_c.mly"
            ( _1 )
# 4988 "parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * (Ast_c.sign * Ast_c.base)) * Ast_c.info) in
    Obj.repr(
# 1192 "parser_c.mly"
            ( snd _1 )
# 4995 "parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.floatType) * Ast_c.info) in
    Obj.repr(
# 1193 "parser_c.mly"
            ( snd _1 )
# 5002 "parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.isWchar) * Ast_c.info) in
    Obj.repr(
# 1194 "parser_c.mly"
            ( snd _1 )
# 5009 "parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.isWchar) * Ast_c.info) in
    Obj.repr(
# 1195 "parser_c.mly"
            ( snd _1 )
# 5016 "parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1206 "parser_c.mly"
                        ( Right3 (BaseType Void),            [_1] )
# 5023 "parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1207 "parser_c.mly"
                        ( Right3 (BaseType (IntType CChar)), [_1])
# 5030 "parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1208 "parser_c.mly"
                        ( Right3 (BaseType (IntType (Si (Signed,CInt)))), [_1])
# 5037 "parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1209 "parser_c.mly"
                        ( Right3 (BaseType (FloatType CFloat)),  [_1])
# 5044 "parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1210 "parser_c.mly"
                        ( Right3 (BaseType (FloatType CDouble)), [_1] )
# 5051 "parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1211 "parser_c.mly"
                        ( Right3 (BaseType SizeType),            [_1] )
# 5058 "parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1212 "parser_c.mly"
                        ( Right3 (BaseType SSizeType),           [_1] )
# 5065 "parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1213 "parser_c.mly"
                        ( Right3 (BaseType PtrDiffType),         [_1] )
# 5072 "parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1214 "parser_c.mly"
                        ( Middle3 Short,  [_1])
# 5079 "parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1215 "parser_c.mly"
                        ( Middle3 Long,   [_1])
# 5086 "parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1216 "parser_c.mly"
                        ( Left3 Signed,   [_1])
# 5093 "parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1217 "parser_c.mly"
                        ( Left3 UnSigned, [_1])
# 5100 "parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'struct_or_union_spec) in
    Obj.repr(
# 1218 "parser_c.mly"
                        ( Right3 (fst _1), snd _1 )
# 5107 "parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'enum_spec) in
    Obj.repr(
# 1219 "parser_c.mly"
                        ( Right3 (fst _1), snd _1 )
# 5114 "parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 3 : 'const_expr) in
    let _4 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : 'const_expr) in
    let _6 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1221 "parser_c.mly"
     ( Right3 (Decimal(_3,Some _5)), [_1;_2;_4;_6] )
# 5126 "parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'const_expr) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1223 "parser_c.mly"
     ( Right3 (Decimal(_3,None)), [_1;_2;_4] )
# 5136 "parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 1239 "parser_c.mly"
     ( let name = RegularName (mk_string_wrap _1) in
       Right3 (TypeName (name, Ast_c.noTypedefDef())),[] )
# 5144 "parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'assign_expr) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1242 "parser_c.mly"
                                   ( Right3 (TypeOfExpr (_3)), [_1;_2;_4] )
# 5154 "parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.fullType) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1243 "parser_c.mly"
                                   ( Right3 (TypeOfType (_3)), [_1;_2;_4] )
# 5164 "parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'type_spec2) in
    Obj.repr(
# 1249 "parser_c.mly"
                         ( dt "type" (); _1   )
# 5171 "parser_c.ml"
               : 'type_spec))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1256 "parser_c.mly"
             ( {const=true  ; volatile=false}, _1 )
# 5178 "parser_c.ml"
               : 'type_qualif))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1257 "parser_c.mly"
             ( {const=false ; volatile=true},  _1 )
# 5185 "parser_c.ml"
               : 'type_qualif))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1259 "parser_c.mly"
             ( (* TODO *) {const=false ; volatile=false},  _1 )
# 5192 "parser_c.ml"
               : 'type_qualif))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1267 "parser_c.mly"
                                    ( raise Todo )
# 5201 "parser_c.ml"
               : 'attribute))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.info)) in
    Obj.repr(
# 1269 "parser_c.mly"
              ( Attribute (fst _1), [snd _1] )
# 5208 "parser_c.ml"
               : 'attribute))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'pointer) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'direct_d) in
    Obj.repr(
# 1284 "parser_c.mly"
                    ( let (attr,ptr) = _1 in
                      (attr, (fst _2, fun x -> x +> ptr +> (snd _2))) )
# 5217 "parser_c.ml"
               : 'declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'direct_d) in
    Obj.repr(
# 1286 "parser_c.mly"
                    ( (Ast_c.noattr, _1)  )
# 5224 "parser_c.ml"
               : 'declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'tmul) in
    Obj.repr(
# 1290 "parser_c.mly"
                          ( (Ast_c.noattr,fun x -> mk_ty (Pointer x) [_1]) )
# 5231 "parser_c.ml"
               : 'pointer))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'tmul) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'pointer) in
    Obj.repr(
# 1292 "parser_c.mly"
     ( let (attr,ptr) = _2 in
       (attr,fun x -> mk_ty (Pointer (ptr x)) [_1]) )
# 5240 "parser_c.ml"
               : 'pointer))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'tmul) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'type_qualif_list) in
    Obj.repr(
# 1295 "parser_c.mly"
     ( let (attr,tq) = _2 in
       (attr,fun x -> (tq.qualifD, mk_tybis (Pointer x) [_1])))
# 5249 "parser_c.ml"
               : 'pointer))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'tmul) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'type_qualif_list) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'pointer) in
    Obj.repr(
# 1298 "parser_c.mly"
     ( let (attr1,tq) = _2 in
       let (attr2,ptr) = _3 in
       (attr1@attr2,fun x -> (tq.qualifD, mk_tybis (Pointer (ptr x)) [_1])) )
# 5260 "parser_c.ml"
               : 'pointer))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1303 "parser_c.mly"
        ( _1 )
# 5267 "parser_c.ml"
               : 'tmul))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1305 "parser_c.mly"
     ( if !Flag.c_plus_plus
     then _1
     else
       let i = Ast_c.parse_info_of_info _1 in
       raise (Semantic("& not allowed in C types, try -c++ option", i)) )
# 5278 "parser_c.ml"
               : 'tmul))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'identifier_cpp) in
    Obj.repr(
# 1314 "parser_c.mly"
     ( (_1, fun x -> x) )
# 5285 "parser_c.ml"
               : 'direct_d))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'declarator) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1316 "parser_c.mly"
     ( let (attr,dec) = _2 in  (* attr gets ignored... *)
       (fst dec, fun x -> mk_ty (ParenType ((snd dec) x)) [_1;_3]) )
# 5295 "parser_c.ml"
               : 'direct_d))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'direct_d) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'tocro) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'tccro) in
    Obj.repr(
# 1319 "parser_c.mly"
     ( (fst _1,fun x->(snd _1) (mk_ty (Array (None,x)) [_2;_3])) )
# 5304 "parser_c.ml"
               : 'direct_d))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'direct_d) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'tocro) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'const_expr) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'tccro) in
    Obj.repr(
# 1321 "parser_c.mly"
     ( (fst _1,fun x->(snd _1) (mk_ty (Array (Some _3,x)) [_2;_4])) )
# 5314 "parser_c.ml"
               : 'direct_d))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'direct_d) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'topar) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'tcpar) in
    Obj.repr(
# 1323 "parser_c.mly"
     ( (fst _1,
       fun x->(snd _1)
         (mk_ty (FunctionType (x,(([],(false, []))))) [_2;_3]))
     )
# 5326 "parser_c.ml"
               : 'direct_d))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'direct_d) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'topar) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'parameter_type_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'tcpar) in
    Obj.repr(
# 1328 "parser_c.mly"
     ( (fst _1,fun x->(snd _1)
       (mk_ty (FunctionType (x, _3)) [_2;_4]))
     )
# 5338 "parser_c.ml"
               : 'direct_d))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1337 "parser_c.mly"
             ( et "tocro" ();_1 )
# 5345 "parser_c.ml"
               : 'tocro))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1338 "parser_c.mly"
             ( dt "tccro" ();_1 )
# 5352 "parser_c.ml"
               : 'tccro))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'pointer) in
    Obj.repr(
# 1342 "parser_c.mly"
                                      ( snd _1 )
# 5359 "parser_c.ml"
               : 'abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'direct_abstract_declarator) in
    Obj.repr(
# 1343 "parser_c.mly"
                                      ( _1 )
# 5366 "parser_c.ml"
               : 'abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'pointer) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'direct_abstract_declarator) in
    Obj.repr(
# 1344 "parser_c.mly"
                                      ( fun x -> x +> _2 +> (snd _1) )
# 5374 "parser_c.ml"
               : 'abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'abstract_declarator) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1348 "parser_c.mly"
     ( fun x -> mk_ty (ParenType (_2 x)) [_1;_3] )
# 5383 "parser_c.ml"
               : 'direct_abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1351 "parser_c.mly"
     ( fun x -> mk_ty (Array (None, x)) [_1;_2] )
# 5391 "parser_c.ml"
               : 'direct_abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'const_expr) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1353 "parser_c.mly"
     ( fun x -> mk_ty (Array (Some _2, x)) [_1;_3] )
# 5400 "parser_c.ml"
               : 'direct_abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'direct_abstract_declarator) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1355 "parser_c.mly"
     ( fun x -> _1 (mk_ty (Array (None, x))  [_2;_3]) )
# 5409 "parser_c.ml"
               : 'direct_abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'direct_abstract_declarator) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'const_expr) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1357 "parser_c.mly"
     ( fun x -> _1 (mk_ty (Array (Some _3,x))  [_2;_4]) )
# 5419 "parser_c.ml"
               : 'direct_abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1359 "parser_c.mly"
     ( fun x -> mk_ty (FunctionType (x, ([], (false,  [])))) [_1;_2] )
# 5427 "parser_c.ml"
               : 'direct_abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'topar) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'parameter_type_list) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'tcpar) in
    Obj.repr(
# 1361 "parser_c.mly"
     ( fun x -> mk_ty (FunctionType (x, _2))  [_1;_3] )
# 5436 "parser_c.ml"
               : 'direct_abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'direct_abstract_declarator) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'topar) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'tcpar) in
    Obj.repr(
# 1372 "parser_c.mly"
     ( fun x -> _1 (mk_ty (FunctionType (x, (([], (false, []))))) [_2;_3]) )
# 5445 "parser_c.ml"
               : 'direct_abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'direct_abstract_declarator) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'topar) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'parameter_type_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'tcpar) in
    Obj.repr(
# 1374 "parser_c.mly"
     ( fun x -> _1 (mk_ty (FunctionType (x, _3)) [_2;_4]) )
# 5455 "parser_c.ml"
               : 'direct_abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'parameter_list) in
    Obj.repr(
# 1380 "parser_c.mly"
                                   ( (_1, (false, [])))
# 5462 "parser_c.ml"
               : 'parameter_type_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'parameter_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1381 "parser_c.mly"
                                   ( (_1, (true,  [_2;_3])) )
# 5471 "parser_c.ml"
               : 'parameter_type_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 1385 "parser_c.mly"
            (
     let name = RegularName (mk_string_wrap _1) in
     LP.add_ident (str_of_name name);
     { p_namei = Some name;
       p_type = mk_ty NoType [];
       p_register = (false, []);
     }
   )
# 5485 "parser_c.ml"
               : 'parameter_decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'decl_spec) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'declaratorp) in
    Obj.repr(
# 1394 "parser_c.mly"
     ( let ((returnType,hasreg),iihasreg) = fixDeclSpecForParam (snd _1) in
       let (name, ftyp) = _2 in
       { p_namei = Some (name);
         p_type = ftyp returnType;
         p_register = (hasreg, iihasreg);
       }
     )
# 5499 "parser_c.ml"
               : 'parameter_decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'decl_spec) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'abstract_declaratorp) in
    Obj.repr(
# 1402 "parser_c.mly"
     ( let ((returnType,hasreg), iihasreg) = fixDeclSpecForParam (snd _1) in
       { p_namei = None;
         p_type = _2 returnType;
         p_register = hasreg, iihasreg;
       }
     )
# 5512 "parser_c.ml"
               : 'parameter_decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'decl_spec) in
    Obj.repr(
# 1409 "parser_c.mly"
     ( let ((returnType,hasreg), iihasreg) = fixDeclSpecForParam (snd _1) in
       { p_namei = None;
         p_type = returnType;
         p_register = hasreg, iihasreg;
       }
     )
# 5524 "parser_c.ml"
               : 'parameter_decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'parameter_decl2) in
    Obj.repr(
# 1421 "parser_c.mly"
                                ( et "param" ();  _1 )
# 5531 "parser_c.ml"
               : 'parameter_decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'declarator) in
    Obj.repr(
# 1424 "parser_c.mly"
               ( let (attr,dec) = _1 in (* attr gets ignored *)
                 LP.add_ident (str_of_name (fst dec)); dec )
# 5539 "parser_c.ml"
               : 'declaratorp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'declarator) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'attributes) in
    Obj.repr(
# 1428 "parser_c.mly"
               ( let (attr,dec) = _1 in (* attr gets ignored *)
                 LP.add_ident (str_of_name (fst dec)); dec )
# 5548 "parser_c.ml"
               : 'declaratorp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'abstract_declarator) in
    Obj.repr(
# 1432 "parser_c.mly"
                       ( _1 )
# 5555 "parser_c.ml"
               : 'abstract_declaratorp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'type_spec) in
    Obj.repr(
# 1442 "parser_c.mly"
                                ( addTypeD (_1, nullDecl) )
# 5562 "parser_c.ml"
               : 'spec_qualif_list2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'type_qualif) in
    Obj.repr(
# 1443 "parser_c.mly"
                                ( {nullDecl with qualifD = (fst _1,[snd _1])})
# 5569 "parser_c.ml"
               : 'spec_qualif_list2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'type_spec) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'spec_qualif_list) in
    Obj.repr(
# 1444 "parser_c.mly"
                                ( addTypeD (_1,_2)   )
# 5577 "parser_c.ml"
               : 'spec_qualif_list2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'type_qualif) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'spec_qualif_list) in
    Obj.repr(
# 1445 "parser_c.mly"
                                ( addQualifD (_1,_2) )
# 5585 "parser_c.ml"
               : 'spec_qualif_list2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'spec_qualif_list2) in
    Obj.repr(
# 1447 "parser_c.mly"
                                               (  dt "spec_qualif" (); _1 )
# 5592 "parser_c.ml"
               : 'spec_qualif_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'type_qualif) in
    Obj.repr(
# 1452 "parser_c.mly"
               ( (Ast_c.noattr,{nullDecl with qualifD = (fst _1,[snd _1])}) )
# 5599 "parser_c.ml"
               : 'type_qualif_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'attribute) in
    Obj.repr(
# 1453 "parser_c.mly"
                                ( ([_1],nullDecl) )
# 5606 "parser_c.ml"
               : 'type_qualif_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'type_qualif_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'type_qualif) in
    Obj.repr(
# 1454 "parser_c.mly"
                                ( (fst _1,addQualifD (_2,snd _1)) )
# 5614 "parser_c.ml"
               : 'type_qualif_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'type_qualif_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'attribute) in
    Obj.repr(
# 1455 "parser_c.mly"
                                ( ((fst _1)@[_2],snd _1) )
# 5622 "parser_c.ml"
               : 'type_qualif_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'spec_qualif_list) in
    Obj.repr(
# 1463 "parser_c.mly"
     ( let (returnType, _) = fixDeclSpecForDecl _1 in  returnType )
# 5629 "parser_c.ml"
               : Ast_c.fullType))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'spec_qualif_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'abstract_declaratort) in
    Obj.repr(
# 1465 "parser_c.mly"
     ( let (returnType, _) = fixDeclSpecForDecl _1 in _2 returnType )
# 5637 "parser_c.ml"
               : Ast_c.fullType))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'abstract_declarator) in
    Obj.repr(
# 1470 "parser_c.mly"
                       ( _1 )
# 5644 "parser_c.ml"
               : 'abstract_declaratort))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'decl_spec) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1480 "parser_c.mly"
     ( function local ->
       let (returnType,storage) = fixDeclSpecForDecl (snd _1) in
       let iistart = Ast_c.fakeInfo () in
       DeclList ([{v_namei = None; v_type = returnType;
                   v_storage = unwrap storage; v_local = local;
                   v_attr = fst _1;
                   v_type_bis = ref None;
                },[]],
                (_2::iistart::snd storage))
     )
# 5661 "parser_c.ml"
               : 'decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'decl_spec) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'init_declarator_list) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1491 "parser_c.mly"
     ( function local ->
       let (returnType,storage) = fixDeclSpecForDecl (snd _1) in
       let iistart = Ast_c.fakeInfo () in
       DeclList (
         (_2 +> List.map (fun ((((name,f),attrs), ini), iivirg) ->
           let s = str_of_name name in
	   if fst (unwrap storage) = StoTypedef
	   then LP.add_typedef s;
           {v_namei = Some (name, ini);
            v_type = f returnType;
            v_storage = unwrap storage;
            v_local = local;
            v_attr = (fst _1)@attrs;
            v_type_bis = ref None;
           },
           iivirg
         )
         ),  (_3::iistart::snd storage))
     )
# 5688 "parser_c.ml"
               : 'decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 5 : 'storage_const_opt) in
    let _2 = (Parsing.peek_val __caml_parser_env 4 : (string * Ast_c.info)) in
    let _3 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 2 : 'argument_list) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _6 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1513 "parser_c.mly"
     ( function _ ->
       match _1 with
	 Some (sto,stoii) ->
	   MacroDecl
	     ((sto, fst _2, _4, true), (snd _2::_3::_5::_6::fakeInfo()::stoii))
       | None ->
	   MacroDecl
	     ((NoSto, fst _2, _4, true), [snd _2;_3;_5;_6;fakeInfo()]) )
# 5707 "parser_c.ml"
               : 'decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 7 : 'storage_const_opt) in
    let _2 = (Parsing.peek_val __caml_parser_env 6 : (string * Ast_c.info)) in
    let _3 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 4 : 'argument_list) in
    let _5 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _6 = (Parsing.peek_val __caml_parser_env 2 : 'teq) in
    let _7 = (Parsing.peek_val __caml_parser_env 1 : 'initialize) in
    let _8 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1524 "parser_c.mly"
     ( function _ ->
       match _1 with
	 Some (sto,stoii) ->
	   MacroDeclInit
	     ((sto, fst _2, _4, _7),
	      (snd _2::_3::_5::_6::_8::fakeInfo()::stoii))
       | None ->
	   MacroDeclInit
	     ((NoSto, fst _2, _4, _7), [snd _2;_3;_5;_6;_8;fakeInfo()]) )
# 5729 "parser_c.ml"
               : 'decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'storage_class_spec_nt) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1535 "parser_c.mly"
                                         ( Some (fst _1,[snd _1; _2]) )
# 5737 "parser_c.ml"
               : 'storage_const_opt))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'storage_class_spec_nt) in
    Obj.repr(
# 1536 "parser_c.mly"
                         ( Some (fst _1,[snd _1]) )
# 5744 "parser_c.ml"
               : 'storage_const_opt))
; (fun __caml_parser_env ->
    Obj.repr(
# 1537 "parser_c.mly"
                         ( None )
# 5750 "parser_c.ml"
               : 'storage_const_opt))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'storage_class_spec) in
    Obj.repr(
# 1541 "parser_c.mly"
                      ( ([], {nullDecl with storageD = (fst _1, [snd _1]) }) )
# 5757 "parser_c.ml"
               : 'decl_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'type_spec) in
    Obj.repr(
# 1542 "parser_c.mly"
                      ( ([], addTypeD (_1,nullDecl)) )
# 5764 "parser_c.ml"
               : 'decl_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'type_qualif) in
    Obj.repr(
# 1543 "parser_c.mly"
                      ( ([], {nullDecl with qualifD  = (fst _1, [snd _1]) }) )
# 5771 "parser_c.ml"
               : 'decl_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1544 "parser_c.mly"
                      ( ([], {nullDecl with inlineD = (true, [_1]) }) )
# 5778 "parser_c.ml"
               : 'decl_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'attribute) in
    Obj.repr(
# 1545 "parser_c.mly"
                      ( ([_1], nullDecl) )
# 5785 "parser_c.ml"
               : 'decl_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'storage_class_spec) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'decl_spec2) in
    Obj.repr(
# 1546 "parser_c.mly"
                                 ( (fst _2, addStorageD (_1, snd _2)) )
# 5793 "parser_c.ml"
               : 'decl_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'type_spec) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'decl_spec2) in
    Obj.repr(
# 1547 "parser_c.mly"
                                 ( (fst _2, addTypeD    (_1, snd _2)) )
# 5801 "parser_c.ml"
               : 'decl_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'type_qualif) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'decl_spec2) in
    Obj.repr(
# 1548 "parser_c.mly"
                                 ( (fst _2, addQualifD  (_1, snd _2)) )
# 5809 "parser_c.ml"
               : 'decl_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'decl_spec2) in
    Obj.repr(
# 1549 "parser_c.mly"
                                 ( (fst _2, addInlineD ((true, _1), snd _2)) )
# 5817 "parser_c.ml"
               : 'decl_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'attribute) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'decl_spec2) in
    Obj.repr(
# 1550 "parser_c.mly"
                                 ( (_1::(fst _2), snd _2) )
# 5825 "parser_c.ml"
               : 'decl_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1558 "parser_c.mly"
                ( Sto Static,  _1 )
# 5832 "parser_c.ml"
               : 'storage_class_spec_nt))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1559 "parser_c.mly"
                ( Sto Extern,  _1 )
# 5839 "parser_c.ml"
               : 'storage_class_spec_nt))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1560 "parser_c.mly"
                ( Sto Auto,    _1 )
# 5846 "parser_c.ml"
               : 'storage_class_spec_nt))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1561 "parser_c.mly"
                ( Sto Register,_1 )
# 5853 "parser_c.ml"
               : 'storage_class_spec_nt))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'storage_class_spec_nt) in
    Obj.repr(
# 1564 "parser_c.mly"
                         ( _1 )
# 5860 "parser_c.ml"
               : 'storage_class_spec))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1565 "parser_c.mly"
                ( StoTypedef,  _1 )
# 5867 "parser_c.ml"
               : 'storage_class_spec))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'decl2) in
    Obj.repr(
# 1572 "parser_c.mly"
                         ( et "decl" (); _1 )
# 5874 "parser_c.ml"
               : 'decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'decl_spec2) in
    Obj.repr(
# 1573 "parser_c.mly"
                         ( dt "declspec" (); _1  )
# 5881 "parser_c.ml"
               : 'decl_spec))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'declaratori) in
    Obj.repr(
# 1579 "parser_c.mly"
                                ( (_1, NoInit) )
# 5888 "parser_c.ml"
               : 'init_declarator2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'declaratori) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'teq) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'initialize) in
    Obj.repr(
# 1580 "parser_c.mly"
                                ( (_1, ValInit(_2, _3)) )
# 5897 "parser_c.ml"
               : 'init_declarator2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'declaratori) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'argument_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1583 "parser_c.mly"
     ( (_1, ConstrInit(_3,[_2;_4])) )
# 5907 "parser_c.ml"
               : 'init_declarator2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1589 "parser_c.mly"
          ( et "teq" (); _1 )
# 5914 "parser_c.ml"
               : 'teq))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'init_declarator2) in
    Obj.repr(
# 1591 "parser_c.mly"
                                   ( dt "init" (); _1 )
# 5921 "parser_c.ml"
               : 'init_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'declarator) in
    Obj.repr(
# 1600 "parser_c.mly"
     ( let (attr,dec) = _1 in
       LP.add_ident (str_of_name (fst dec)); dec, attr )
# 5929 "parser_c.ml"
               : 'declaratori))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'declarator) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'gcc_asm_decl) in
    Obj.repr(
# 1604 "parser_c.mly"
     ( let (attr,dec) = _1 in
       LP.add_ident (str_of_name (fst dec)); dec, attr )
# 5938 "parser_c.ml"
               : 'declaratori))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'declarator) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'end_attributes) in
    Obj.repr(
# 1608 "parser_c.mly"
     ( let (attr,dec) = _1 in
       LP.add_ident (str_of_name (fst dec)); dec, attr (* TODO *) )
# 5947 "parser_c.ml"
               : 'declaratori))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'asmbody) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1613 "parser_c.mly"
                                         (  )
# 5957 "parser_c.ml"
               : 'gcc_asm_decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : 'asmbody) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1614 "parser_c.mly"
                                        (  )
# 5968 "parser_c.ml"
               : 'gcc_asm_decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'assign_expr) in
    Obj.repr(
# 1620 "parser_c.mly"
     ( InitExpr _1,                [] )
# 5975 "parser_c.ml"
               : 'initialize))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'tobrace_ini) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'initialize_list) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'gcc_comma_opt_struct) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'tcbrace_ini) in
    Obj.repr(
# 1622 "parser_c.mly"
     ( InitList (List.rev _2),     [_1;_4] @ _3 )
# 5985 "parser_c.ml"
               : 'initialize))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'tobrace_ini) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'tcbrace_ini) in
    Obj.repr(
# 1624 "parser_c.mly"
     ( InitList [],       [_1;_2] )
# 5993 "parser_c.ml"
               : 'initialize))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'initialize2) in
    Obj.repr(
# 1635 "parser_c.mly"
                                      ( [_1,   []] )
# 6000 "parser_c.ml"
               : 'initialize_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'initialize_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'initialize2) in
    Obj.repr(
# 1636 "parser_c.mly"
                                      ( (_3,  [_2])::_1 )
# 6009 "parser_c.ml"
               : 'initialize_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'cond_expr) in
    Obj.repr(
# 1642 "parser_c.mly"
     ( InitExpr _1,   [] )
# 6016 "parser_c.ml"
               : 'initialize2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'tobrace_ini) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'initialize_list) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'gcc_comma_opt_struct) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'tcbrace_ini) in
    Obj.repr(
# 1644 "parser_c.mly"
     ( InitList (List.rev _2),   [_1;_4] @ _3 )
# 6026 "parser_c.ml"
               : 'initialize2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'tobrace_ini) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'tcbrace_ini) in
    Obj.repr(
# 1646 "parser_c.mly"
     ( InitList [],  [_1;_2]  )
# 6034 "parser_c.ml"
               : 'initialize2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'designator_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'initialize2) in
    Obj.repr(
# 1650 "parser_c.mly"
     ( InitDesignators (_1, _3), [_2] )
# 6043 "parser_c.ml"
               : 'initialize2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'ident) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'initialize2) in
    Obj.repr(
# 1654 "parser_c.mly"
     ( InitFieldOld (fst _1, _3),     [snd _1; _2] )
# 6052 "parser_c.ml"
               : 'initialize2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'ident) in
    Obj.repr(
# 1665 "parser_c.mly"
     ( DesignatorField (fst _2), [_1;snd _2] )
# 6060 "parser_c.ml"
               : 'designator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'const_expr) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1667 "parser_c.mly"
     ( DesignatorIndex (_2),  [_1;_3] )
# 6069 "parser_c.ml"
               : 'designator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : 'const_expr) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : 'const_expr) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1669 "parser_c.mly"
     ( DesignatorRange (_2, _4),  [_1;_3;_5] )
# 6080 "parser_c.ml"
               : 'designator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1677 "parser_c.mly"
          (  [_1] )
# 6087 "parser_c.ml"
               : 'gcc_comma_opt_struct))
; (fun __caml_parser_env ->
    Obj.repr(
# 1678 "parser_c.mly"
                    (  [Ast_c.fakeInfo() +> Ast_c.rewrap_str ","]  )
# 6093 "parser_c.ml"
               : 'gcc_comma_opt_struct))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : 'struct_or_union) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : 'ident) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'tobrace_struct) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : 'struct_decl_list_gcc) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : 'tcbrace_struct) in
    Obj.repr(
# 1693 "parser_c.mly"
     ( StructUnion (fst _1, Some (fst _2), _4),  [snd _1;snd _2;_3;_5]  )
# 6104 "parser_c.ml"
               : 's_or_u_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'struct_or_union) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'tobrace_struct) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'struct_decl_list_gcc) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'tcbrace_struct) in
    Obj.repr(
# 1695 "parser_c.mly"
     ( StructUnion (fst _1, None, _3), [snd _1;_2;_4] )
# 6114 "parser_c.ml"
               : 's_or_u_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'struct_or_union) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'ident) in
    Obj.repr(
# 1697 "parser_c.mly"
     ( StructUnionName (fst _1, fst _2), [snd _1;snd _2] )
# 6122 "parser_c.ml"
               : 's_or_u_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1700 "parser_c.mly"
             ( Struct, _1 )
# 6129 "parser_c.ml"
               : 'struct_or_union2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1701 "parser_c.mly"
             ( Union, _1 )
# 6136 "parser_c.ml"
               : 'struct_or_union2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'attributes) in
    Obj.repr(
# 1703 "parser_c.mly"
                        ( Struct, _1 (* TODO *) )
# 6144 "parser_c.ml"
               : 'struct_or_union2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'attributes) in
    Obj.repr(
# 1704 "parser_c.mly"
                        ( Union, _1  (* TODO *) )
# 6152 "parser_c.ml"
               : 'struct_or_union2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'field_declaration) in
    Obj.repr(
# 1709 "parser_c.mly"
                     ( DeclarationField _1 )
# 6159 "parser_c.ml"
               : 'struct_decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1710 "parser_c.mly"
           ( EmptyField _1  )
# 6166 "parser_c.ml"
               : 'struct_decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : 'identifier) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'argument_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1716 "parser_c.mly"
     ( MacroDeclField ((fst _1, _3), [snd _1;_2;_4;_5;fakeInfo()]) )
# 6177 "parser_c.ml"
               : 'struct_decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_directive) in
    Obj.repr(
# 1720 "parser_c.mly"
     ( CppDirectiveStruct _1 )
# 6184 "parser_c.ml"
               : 'struct_decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_ifdef_directive) in
    Obj.repr(
# 1722 "parser_c.mly"
     ( IfdefStruct _1 )
# 6191 "parser_c.ml"
               : 'struct_decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'spec_qualif_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'struct_declarator_list) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1727 "parser_c.mly"
     (
       let (returnType,storage) = fixDeclSpecForDecl _1 in
       if fst (unwrap storage) <> NoSto
       then internal_error "parsing dont allow this";

       let iistart = Ast_c.fakeInfo () in (* for parallelism with DeclList *)
       FieldDeclList (_2 +> (List.map (fun (f, iivirg) ->
         f returnType, iivirg))
                         ,[_3;iistart])
         (* dont need to check if typedef or func initialised cos
          * grammar dont allow typedef nor initialiser in struct
          *)
     )
# 6212 "parser_c.ml"
               : 'field_declaration))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'spec_qualif_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1742 "parser_c.mly"
     (
       (* gccext: allow empty elements if it is a structdef or enumdef *)
       let (returnType,storage) = fixDeclSpecForDecl _1 in
       if fst (unwrap storage) <> NoSto
       then internal_error "parsing dont allow this";

       let iistart = Ast_c.fakeInfo () in (* for parallelism with DeclList *)
       FieldDeclList ([(Simple (None, returnType)) , []], [_2;iistart])
     )
# 6228 "parser_c.ml"
               : 'field_declaration))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'declaratorsd) in
    Obj.repr(
# 1758 "parser_c.mly"
     ( (fun x -> Simple   (Some (fst _1), (snd _1) x)) )
# 6235 "parser_c.ml"
               : 'struct_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'dotdot) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'const_expr2) in
    Obj.repr(
# 1760 "parser_c.mly"
     ( (fun x -> BitField (None, x, _1, _2)) )
# 6243 "parser_c.ml"
               : 'struct_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'declaratorsd) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'dotdot) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'const_expr2) in
    Obj.repr(
# 1762 "parser_c.mly"
     ( (fun x -> BitField (Some (fst _1), ((snd _1) x), _2, _3)) )
# 6252 "parser_c.ml"
               : 'struct_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'declarator) in
    Obj.repr(
# 1770 "parser_c.mly"
     ( let (attr,dec) = _1 in (* attr ignored *)
       (*also ? LP.add_ident (fst (fst dec)); *) dec )
# 6260 "parser_c.ml"
               : 'declaratorsd))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'declarator) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'attributes) in
    Obj.repr(
# 1773 "parser_c.mly"
                           ( let (attr,dec) = _1 in dec )
# 6268 "parser_c.ml"
               : 'declaratorsd))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 's_or_u_spec2) in
    Obj.repr(
# 1778 "parser_c.mly"
                                   ( dt "su" (); _1 )
# 6275 "parser_c.ml"
               : 'struct_or_union_spec))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'struct_or_union2) in
    Obj.repr(
# 1779 "parser_c.mly"
                                  ( et "su" (); _1 )
# 6282 "parser_c.ml"
               : 'struct_or_union))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'struct_decl2) in
    Obj.repr(
# 1780 "parser_c.mly"
                           ( et "struct" (); _1 )
# 6289 "parser_c.ml"
               : 'struct_decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1782 "parser_c.mly"
                 ( et "dotdot" (); _1 )
# 6296 "parser_c.ml"
               : 'dotdot))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'const_expr) in
    Obj.repr(
# 1783 "parser_c.mly"
                        ( dt "const_expr2" (); _1 )
# 6303 "parser_c.ml"
               : 'const_expr2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'struct_decl_list) in
    Obj.repr(
# 1786 "parser_c.mly"
                     ( _1 )
# 6310 "parser_c.ml"
               : 'struct_decl_list_gcc))
; (fun __caml_parser_env ->
    Obj.repr(
# 1787 "parser_c.mly"
                         ( [] )
# 6316 "parser_c.ml"
               : 'struct_decl_list_gcc))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : 'tobrace_enum) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'enumerator_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : 'gcc_comma_opt_struct) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : 'tcbrace_enum) in
    Obj.repr(
# 1795 "parser_c.mly"
     ( Enum (None,    _3),           [_1;_2;_5] @ _4 )
# 6327 "parser_c.ml"
               : 'enum_spec))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 4 : 'ident) in
    let _3 = (Parsing.peek_val __caml_parser_env 3 : 'tobrace_enum) in
    let _4 = (Parsing.peek_val __caml_parser_env 2 : 'enumerator_list) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : 'gcc_comma_opt_struct) in
    let _6 = (Parsing.peek_val __caml_parser_env 0 : 'tcbrace_enum) in
    Obj.repr(
# 1797 "parser_c.mly"
     ( Enum (Some (fst _2), _4),     [_1; snd _2; _3;_6] @ _5 )
# 6339 "parser_c.ml"
               : 'enum_spec))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'ident) in
    Obj.repr(
# 1799 "parser_c.mly"
     ( EnumName (fst _2),       [_1; snd _2] )
# 6347 "parser_c.ml"
               : 'enum_spec))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'idente) in
    Obj.repr(
# 1802 "parser_c.mly"
                          ( _1, None     )
# 6354 "parser_c.ml"
               : 'enumerator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'idente) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'const_expr) in
    Obj.repr(
# 1803 "parser_c.mly"
                          ( _1, Some (_2, _3) )
# 6363 "parser_c.ml"
               : 'enumerator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'ident_cpp) in
    Obj.repr(
# 1810 "parser_c.mly"
                  ( LP.add_ident (str_of_name _1); _1 )
# 6370 "parser_c.ml"
               : 'idente))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'function_def) in
    Obj.repr(
# 1817 "parser_c.mly"
                                     ( fixFunc _1 )
# 6377 "parser_c.ml"
               : 'function_definition))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'decl) in
    Obj.repr(
# 1820 "parser_c.mly"
                  ( [_1 Ast_c.LocalDecl]   )
# 6384 "parser_c.ml"
               : 'decl_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'decl_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'decl) in
    Obj.repr(
# 1821 "parser_c.mly"
                  ( _1 @ [_2 Ast_c.LocalDecl] )
# 6392 "parser_c.ml"
               : 'decl_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_directive) in
    Obj.repr(
# 1825 "parser_c.mly"
                                    ( )
# 6399 "parser_c.ml"
               : 'cpp_directive_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'cpp_directive_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_directive) in
    Obj.repr(
# 1826 "parser_c.mly"
                                    ( )
# 6407 "parser_c.ml"
               : 'cpp_directive_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'start_fun) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'compound) in
    Obj.repr(
# 1829 "parser_c.mly"
                           ( LP.del_scope(); (_1, _2, None) )
# 6415 "parser_c.ml"
               : 'function_def))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'start_fun) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'cpp_directive_list) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'compound) in
    Obj.repr(
# 1830 "parser_c.mly"
                                         ( LP.del_scope(); (_1, _3, None) )
# 6424 "parser_c.ml"
               : 'function_def))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'start_fun) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'decl_list) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'compound) in
    Obj.repr(
# 1831 "parser_c.mly"
                                     (
     (* TODO: undo the typedef added ? *)
     LP.del_scope();
     (_1, _3, Some _2)
   )
# 6437 "parser_c.ml"
               : 'function_def))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'start_fun2) in
    Obj.repr(
# 1838 "parser_c.mly"
  ( LP.new_scope();
    fix_add_params_ident _1;
    (* toreput? !LP._lexer_hint.toplevel <- false;  *)
    _1
  )
# 6448 "parser_c.ml"
               : 'start_fun))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'decl_spec) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'declaratorfd) in
    Obj.repr(
# 1845 "parser_c.mly"
     ( let (returnType,storage) = fixDeclSpecForFuncDef (snd _1) in
       let (id, attrs) = _2 in
       (fst id, fixOldCDecl ((snd id) returnType) , storage, (fst _1)@attrs)
     )
# 6459 "parser_c.ml"
               : 'start_fun2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'ctor_dtor) in
    Obj.repr(
# 1849 "parser_c.mly"
               ( _1 )
# 6466 "parser_c.ml"
               : 'start_fun2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : string * Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'topar) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'tcpar) in
    Obj.repr(
# 1852 "parser_c.mly"
                                (
     let id = RegularName (mk_string_wrap _1) in
     let ret = mk_ty NoType [] in
     let ty = mk_ty (FunctionType (ret, (([], (false, []))))) [_2;_3] in
     let storage = ((NoSto,false),[]) in
     let attrs = [] in
     (id, ty, storage, attrs) )
# 6481 "parser_c.ml"
               : 'ctor_dtor))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : string * Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'topar) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'parameter_type_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'tcpar) in
    Obj.repr(
# 1859 "parser_c.mly"
                                                    (
     let id = RegularName (mk_string_wrap _1) in
     let ret = mk_ty NoType [] in
     let ty = mk_ty (FunctionType (ret, _3)) [_2;_4] in
     let storage = ((NoSto,false),[]) in
     let attrs = [] in
     (id, ty, storage, attrs) )
# 6497 "parser_c.ml"
               : 'ctor_dtor))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'declarator) in
    Obj.repr(
# 1881 "parser_c.mly"
   ( et "declaratorfd" (); let (attr,dec) = _1 in dec, attr )
# 6504 "parser_c.ml"
               : 'declaratorfd))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'declarator) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'end_attributes) in
    Obj.repr(
# 1884 "parser_c.mly"
   ( et "declaratorfd" (); let (attr,dec) = _1 in dec, attr )
# 6512 "parser_c.ml"
               : 'declaratorfd))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : (Ast_c.info * bool ref)) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.info)) in
    Obj.repr(
# 1893 "parser_c.mly"
     (
       let (i1, in_ifdef) = _1 in
       let (s, i2) = _2 in

       (* redo some lexing work :( *)
       let inc_file =
         match () with
         | _ when s =~ "^\"\\(.*\\)\"$" ->
             Local (Common.split "/" (matched1 s))
         | _ when s =~ "^\\<\\(.*\\)\\>$" ->
             NonLocal (Common.split "/" (matched1 s))
         | _ ->
             Weird s
       in
       Include { i_include = (inc_file, [i1;i2]);
                 i_rel_pos = Ast_c.noRelPos();
                 i_overall_rel_pos = Ast_c.noRelPos();
                 i_is_in_ifdef = !in_ifdef;
                 i_content = Ast_c.noi_content;
       }
     )
# 6540 "parser_c.ml"
               : 'cpp_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : (string * Ast_c.info)) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'define_val) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1916 "parser_c.mly"
     ( Define ((fst _2, [_1; snd _2;_4]), (DefineVar, _3)) )
# 6550 "parser_c.ml"
               : 'cpp_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 6 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 5 : (string * Ast_c.info)) in
    let _3 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 3 : 'param_define_list) in
    let _5 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _6 = (Parsing.peek_val __caml_parser_env 1 : 'define_val) in
    let _7 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1923 "parser_c.mly"
     ( Define
         ((fst _2, [_1; snd _2; _7]),
           (DefineFunc (_4, [_3;_5]), _6))
     )
# 6566 "parser_c.ml"
               : 'cpp_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : (string * Ast_c.info)) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1929 "parser_c.mly"
     ( Define((fst _2, [_1; snd _2; _3]), (Undef,DefineEmpty)) )
# 6575 "parser_c.ml"
               : 'cpp_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : (string * Ast_c.info)) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'pragmainfo) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1932 "parser_c.mly"
     ( Pragma((fst _2, [_1; snd _2; _4]), _3) )
# 6585 "parser_c.ml"
               : 'cpp_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1934 "parser_c.mly"
                      ( OtherDirective ([_1]) )
# 6592 "parser_c.ml"
               : 'cpp_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'argument_list_ne) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1937 "parser_c.mly"
                                ( (PragmaTuple (_2, [_1;_3])) )
# 6601 "parser_c.ml"
               : 'pragmainfo))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1938 "parser_c.mly"
               ( PragmaTuple ([], [_1;_2]) )
# 6609 "parser_c.ml"
               : 'pragmainfo))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'ident_define_list_ne) in
    Obj.repr(
# 1939 "parser_c.mly"
                        ( PragmaIdList _1 )
# 6616 "parser_c.ml"
               : 'pragmainfo))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.expression) in
    Obj.repr(
# 1945 "parser_c.mly"
             ( DefineExpr _1 )
# 6623 "parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.statement) in
    Obj.repr(
# 1946 "parser_c.mly"
             ( DefineStmt _1 )
# 6630 "parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'decl) in
    Obj.repr(
# 1947 "parser_c.mly"
             ( DefineStmt (mk_st (Decl (_1 Ast_c.NotLocalDecl)) Ast_c.noii) )
# 6637 "parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'decl_spec) in
    Obj.repr(
# 1957 "parser_c.mly"
     ( let returnType = fixDeclSpecForMacro (snd _1) in
       DefineType returnType
     )
# 6646 "parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'decl_spec) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'abstract_declarator) in
    Obj.repr(
# 1961 "parser_c.mly"
     ( let returnType = fixDeclSpecForMacro (snd _1) in
       let typ = _2 returnType in
       DefineType typ
     )
# 6657 "parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'stat_or_decl) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'stat_or_decl_list) in
    Obj.repr(
# 1973 "parser_c.mly"
     ( DefineMulti
	 (List.map
	    (function
		StmtElem e -> e
	      | _ -> failwith "unexpected statement for DefineMulti")
	    (_1 :: _2)) )
# 6670 "parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'function_definition) in
    Obj.repr(
# 1987 "parser_c.mly"
                       ( DefineFunction _1 )
# 6677 "parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : 'initialize_list) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'gcc_comma_opt_struct) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : 'comma_opt) in
    Obj.repr(
# 1990 "parser_c.mly"
    ( DefineInit (InitList (List.rev _2), [_1;_4] @ _3 @ _5)  )
# 6688 "parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.statement) in
    let _3 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.expression) in
    let _6 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1994 "parser_c.mly"
     (
       (* TOREPUT
       if fst $5 <> "0"
       then pr2 "WEIRD: in macro and have not a while(0)";
       *)
       DefineDoWhileZero ((_2,_5),   [_1;_3;_4;_6])
     )
# 6706 "parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'asmbody) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2002 "parser_c.mly"
                                         ( DefineTodo )
# 6716 "parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : 'asmbody) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2003 "parser_c.mly"
                                         ( DefineTodo )
# 6727 "parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    Obj.repr(
# 2007 "parser_c.mly"
                   ( DefineEmpty )
# 6733 "parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 2013 "parser_c.mly"
                        ( mk_string_wrap _1 )
# 6740 "parser_c.ml"
               : 'param_define))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 2014 "parser_c.mly"
                        ( mk_string_wrap _1 )
# 6747 "parser_c.ml"
               : 'param_define))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.info)) in
    Obj.repr(
# 2015 "parser_c.mly"
                        ( mk_string_wrap _1 )
# 6754 "parser_c.ml"
               : 'param_define))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2016 "parser_c.mly"
                        ( "...", [_1] )
# 6761 "parser_c.ml"
               : 'param_define))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2018 "parser_c.mly"
                        ( "register", [_1] )
# 6768 "parser_c.ml"
               : 'param_define))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (Ast_c.ifdef_guard * (int * int) option ref * Ast_c.info)) in
    Obj.repr(
# 2025 "parser_c.mly"
     ( let (cond,tag,ii) = _1 in
       IfdefDirective ((Ifdef cond, IfdefTag (Common.some !tag)),  [ii]) )
# 6776 "parser_c.ml"
               : 'cpp_ifdef_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : ((int * int) option ref * Ast_c.info)) in
    Obj.repr(
# 2028 "parser_c.mly"
     ( let (tag,ii) = _1 in
       IfdefDirective ((IfdefElse, IfdefTag (Common.some !tag)), [ii]) )
# 6784 "parser_c.ml"
               : 'cpp_ifdef_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (Ast_c.ifdef_guard * (int * int) option ref * Ast_c.info)) in
    Obj.repr(
# 2031 "parser_c.mly"
     ( let (cond,tag,ii) = _1 in
       IfdefDirective ((IfdefElseif cond, IfdefTag (Common.some !tag)), [ii]) )
# 6792 "parser_c.ml"
               : 'cpp_ifdef_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : ((int * int) option ref * Ast_c.info)) in
    Obj.repr(
# 2034 "parser_c.mly"
     ( let (tag,ii) = _1 in
       IfdefDirective ((IfdefEndif, IfdefTag (Common.some !tag)), [ii]) )
# 6800 "parser_c.ml"
               : 'cpp_ifdef_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (bool * (int * int) option ref * Ast_c.info)) in
    Obj.repr(
# 2038 "parser_c.mly"
     ( let (_b, tag,ii) = _1 in
       IfdefDirective ((Ifdef Gnone, IfdefTag (Common.some !tag)), [ii]) )
# 6808 "parser_c.ml"
               : 'cpp_ifdef_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (bool * (int * int) option ref * Ast_c.info)) in
    Obj.repr(
# 2041 "parser_c.mly"
     ( let (_b, tag,ii) = _1 in
       IfdefDirective ((Ifdef Gnone, IfdefTag (Common.some !tag)), [ii]) )
# 6816 "parser_c.ml"
               : 'cpp_ifdef_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (bool * (int * int) option ref * Ast_c.info)) in
    Obj.repr(
# 2044 "parser_c.mly"
     ( let (_b, tag,ii) = _1 in
       IfdefDirective ((Ifdef Gnone, IfdefTag (Common.some !tag)), [ii]) )
# 6824 "parser_c.ml"
               : 'cpp_ifdef_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : 'identifier) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'argument_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2055 "parser_c.mly"
     (
       if args_are_params _3
       then
	 (* if all args are params, assume it is a prototype of a function
	    with no return type *)
	 let parameters = args_to_params _3 None in
	 let paramlist = (parameters, (false, [])) in (* no varargs *)
	 let id = RegularName (mk_string_wrap _1) in
	 let ret =
	   warning "type defaults to 'int'"
	     (mk_ty defaultInt [fakeInfo fake_pi]) in
	 let ty =
	   fixOldCDecl (mk_ty (FunctionType (ret, paramlist)) [_2;_4]) in
	 let attrs = Ast_c.noattr in
	 let sto = (NoSto, false), [] in
	 let iistart = Ast_c.fakeInfo () in
	 Declaration(
	 DeclList ([{v_namei = Some (id,NoInit); v_type = ty;
                      v_storage = unwrap sto; v_local = NotLocalDecl;
                      v_attr = attrs; v_type_bis = ref None;
                    },[]],
                   (_5::iistart::snd sto)))
       else
	 Declaration
	   (MacroDecl((NoSto, fst _1, _3, true), [snd _1;_2;_4;_5;fakeInfo()]))
           (* old: MacroTop (fst $1, $3,    [snd $1;$2;$4;$5])  *)
     )
# 6861 "parser_c.ml"
               : 'cpp_other))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : 'identifier) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'argument_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : 'compound) in
    Obj.repr(
# 2085 "parser_c.mly"
                                                 (
   let parameters = args_to_params _3 (Some (snd _1)) in
   let paramlist = (parameters, (false, [])) in (* no varargs *)
   let fninfo =
     let id = RegularName (mk_string_wrap _1) in
     let ret =
       warning "type defaults to 'int'"
	 (mk_ty defaultInt [fakeInfo fake_pi]) in
     let ty = mk_ty (FunctionType (ret, paramlist)) [_2;_4] in
     let attrs = Ast_c.noattr in
     let sto = (NoSto, false), [] in
     (id, fixOldCDecl ty, sto, attrs) in
   let fundef = fixFunc (fninfo, _5, None) in
   Definition fundef
 )
# 6886 "parser_c.ml"
               : 'cpp_other))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'identifier) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'argument_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2103 "parser_c.mly"
     ( Declaration
	 (MacroDecl ((NoSto, fst _1, _3, false), [snd _1;_2;_4;fakeInfo()])) )
# 6897 "parser_c.ml"
               : 'cpp_other))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'identifier) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2107 "parser_c.mly"
                      ( EmptyDef [snd _1;_2] )
# 6905 "parser_c.ml"
               : 'cpp_other))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'function_definition) in
    Obj.repr(
# 2116 "parser_c.mly"
                                     ( Definition _1 )
# 6912 "parser_c.ml"
               : 'external_declaration))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'decl) in
    Obj.repr(
# 2117 "parser_c.mly"
                                     ( Declaration (_1 Ast_c.NotLocalDecl) )
# 6919 "parser_c.ml"
               : 'external_declaration))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : string * Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : 'translation_unit) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2122 "parser_c.mly"
     ( !LP._lexer_hint.context_stack <- [LP.InTopLevel];
       Namespace (_4, [_1; snd _2; _3; _5]) )
# 6931 "parser_c.ml"
               : Ast_c.toplevel))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'external_declaration) in
    Obj.repr(
# 2125 "parser_c.mly"
                                                ( _1 )
# 6938 "parser_c.ml"
               : Ast_c.toplevel))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_directive) in
    Obj.repr(
# 2129 "parser_c.mly"
     ( CppTop _1 )
# 6945 "parser_c.ml"
               : Ast_c.toplevel))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_other) in
    Obj.repr(
# 2131 "parser_c.mly"
     ( _1 )
# 6952 "parser_c.ml"
               : Ast_c.toplevel))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_ifdef_directive) in
    Obj.repr(
# 2133 "parser_c.mly"
     ( IfdefTop _1 )
# 6959 "parser_c.ml"
               : Ast_c.toplevel))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'asmbody) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2136 "parser_c.mly"
                                                ( EmptyDef [_1;_2;_4;_5] )
# 6970 "parser_c.ml"
               : Ast_c.toplevel))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2143 "parser_c.mly"
              ( EmptyDef [_1] )
# 6977 "parser_c.ml"
               : Ast_c.toplevel))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2146 "parser_c.mly"
              ( FinalDef _1 )
# 6984 "parser_c.ml"
               : Ast_c.toplevel))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2155 "parser_c.mly"
                  ( LP.push_context LP.InFunction; LP.new_scope (); _1 )
# 6991 "parser_c.ml"
               : 'tobrace))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2156 "parser_c.mly"
                  ( LP.pop_context();              LP.del_scope (); _1 )
# 6998 "parser_c.ml"
               : 'tcbrace))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2158 "parser_c.mly"
                      ( LP.push_context LP.InEnum; _1 )
# 7005 "parser_c.ml"
               : 'tobrace_enum))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2159 "parser_c.mly"
                      ( LP.pop_context (); _1 )
# 7012 "parser_c.ml"
               : 'tcbrace_enum))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2161 "parser_c.mly"
                     ( LP.push_context LP.InInitializer; _1 )
# 7019 "parser_c.ml"
               : 'tobrace_ini))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2162 "parser_c.mly"
                     ( LP.pop_context (); _1 )
# 7026 "parser_c.ml"
               : 'tcbrace_ini))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2164 "parser_c.mly"
                        ( LP.push_context LP.InStruct; _1)
# 7033 "parser_c.ml"
               : 'tobrace_struct))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2165 "parser_c.mly"
                        ( LP.pop_context (); _1 )
# 7040 "parser_c.ml"
               : 'tcbrace_struct))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2171 "parser_c.mly"
     ( LP.new_scope ();et "topar" ();
       LP.push_context LP.InParameter;
       _1
     )
# 7050 "parser_c.ml"
               : 'topar))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2176 "parser_c.mly"
     ( LP.del_scope ();dt "tcpar" ();
       LP.pop_context ();
       _1
     )
# 7060 "parser_c.ml"
               : 'tcpar))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'string_elem) in
    Obj.repr(
# 2215 "parser_c.mly"
               ( _1 )
# 7067 "parser_c.ml"
               : 'string_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'string_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'string_elem) in
    Obj.repr(
# 2216 "parser_c.mly"
                           ( _1 @ _2 )
# 7075 "parser_c.ml"
               : 'string_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'colon_asm) in
    Obj.repr(
# 2219 "parser_c.mly"
             ( [_1] )
# 7082 "parser_c.ml"
               : 'colon_asm_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'colon_asm_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'colon_asm) in
    Obj.repr(
# 2220 "parser_c.mly"
                             ( _1 @ [_2] )
# 7090 "parser_c.ml"
               : 'colon_asm_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'colon_option) in
    Obj.repr(
# 2223 "parser_c.mly"
                ( [_1, []] )
# 7097 "parser_c.ml"
               : 'colon_option_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'colon_option_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'colon_option) in
    Obj.repr(
# 2224 "parser_c.mly"
                                         ( _1 @ [_3, [_2]] )
# 7106 "parser_c.ml"
               : 'colon_option_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'argument_ne) in
    Obj.repr(
# 2228 "parser_c.mly"
                                         ( [_1, []] )
# 7113 "parser_c.ml"
               : 'argument_list_ne))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'argument_list_ne) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'argument) in
    Obj.repr(
# 2229 "parser_c.mly"
                                    ( _1 @ [_3,    [_2]] )
# 7122 "parser_c.ml"
               : 'argument_list_ne))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'argument) in
    Obj.repr(
# 2232 "parser_c.mly"
                                      ( [_1, []] )
# 7129 "parser_c.ml"
               : 'argument_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'argument_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'argument) in
    Obj.repr(
# 2233 "parser_c.mly"
                                 ( _1 @ [_3,    [_2]] )
# 7138 "parser_c.ml"
               : 'argument_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.info)) in
    Obj.repr(
# 2243 "parser_c.mly"
                             ( [RegularName (mk_string_wrap _1), []] )
# 7145 "parser_c.ml"
               : 'ident_define_list_ne))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'ident_define_list_ne) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.info)) in
    Obj.repr(
# 2245 "parser_c.mly"
     ( _1 @ [RegularName (mk_string_wrap _2), []] )
# 7153 "parser_c.ml"
               : 'ident_define_list_ne))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'struct_decl) in
    Obj.repr(
# 2249 "parser_c.mly"
                                 ( [_1] )
# 7160 "parser_c.ml"
               : 'struct_decl_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'struct_decl_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'struct_decl) in
    Obj.repr(
# 2250 "parser_c.mly"
                                 ( _1 @ [_2] )
# 7168 "parser_c.ml"
               : 'struct_decl_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'struct_declarator) in
    Obj.repr(
# 2254 "parser_c.mly"
                                                   ( [_1,           []] )
# 7175 "parser_c.ml"
               : 'struct_declarator_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'struct_declarator_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'struct_declarator) in
    Obj.repr(
# 2255 "parser_c.mly"
                                                   ( _1 @ [_3,     [_2]] )
# 7184 "parser_c.ml"
               : 'struct_declarator_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'enumerator) in
    Obj.repr(
# 2259 "parser_c.mly"
                                     ( [_1,          []]   )
# 7191 "parser_c.ml"
               : 'enumerator_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'enumerator_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'enumerator) in
    Obj.repr(
# 2260 "parser_c.mly"
                                     ( _1 @ [_3,    [_2]] )
# 7200 "parser_c.ml"
               : 'enumerator_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'init_declarator) in
    Obj.repr(
# 2264 "parser_c.mly"
                                               ( [_1,   []] )
# 7207 "parser_c.ml"
               : 'init_declarator_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'init_declarator_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'init_declarator) in
    Obj.repr(
# 2265 "parser_c.mly"
                                               ( _1 @ [_3,     [_2]] )
# 7216 "parser_c.ml"
               : 'init_declarator_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'parameter_decl) in
    Obj.repr(
# 2269 "parser_c.mly"
                                        ( [_1, []] )
# 7223 "parser_c.ml"
               : 'parameter_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'parameter_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'parameter_decl) in
    Obj.repr(
# 2270 "parser_c.mly"
                                        ( _1 @ [_3,  [_2]] )
# 7232 "parser_c.ml"
               : 'parameter_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2273 "parser_c.mly"
                           ( [_1] )
# 7239 "parser_c.ml"
               : 'taction_list_ne))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'taction_list_ne) in
    Obj.repr(
# 2274 "parser_c.mly"
                           ( _1 :: _2 )
# 7247 "parser_c.ml"
               : 'taction_list_ne))
; (fun __caml_parser_env ->
    Obj.repr(
# 2282 "parser_c.mly"
                        ( [] )
# 7253 "parser_c.ml"
               : 'taction_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'taction_list) in
    Obj.repr(
# 2283 "parser_c.mly"
                        ( _1 :: _2 )
# 7261 "parser_c.ml"
               : 'taction_list))
; (fun __caml_parser_env ->
    Obj.repr(
# 2286 "parser_c.mly"
                   ( [] )
# 7267 "parser_c.ml"
               : 'param_define_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'param_define) in
    Obj.repr(
# 2287 "parser_c.mly"
                                          ( [_1, []] )
# 7274 "parser_c.ml"
               : 'param_define_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'param_define_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'param_define) in
    Obj.repr(
# 2288 "parser_c.mly"
                                          ( _1 @ [_3, [_2]] )
# 7283 "parser_c.ml"
               : 'param_define_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'designator) in
    Obj.repr(
# 2291 "parser_c.mly"
              ( [_1] )
# 7290 "parser_c.ml"
               : 'designator_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'designator_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'designator) in
    Obj.repr(
# 2292 "parser_c.mly"
                              ( _1 @ [_2] )
# 7298 "parser_c.ml"
               : 'designator_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'attribute) in
    Obj.repr(
# 2295 "parser_c.mly"
             ( [_1] )
# 7305 "parser_c.ml"
               : 'attribute_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'attribute_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'attribute) in
    Obj.repr(
# 2296 "parser_c.mly"
                            ( _1 @ [_2] )
# 7313 "parser_c.ml"
               : 'attribute_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'attribute_list) in
    Obj.repr(
# 2298 "parser_c.mly"
                           ( _1 )
# 7320 "parser_c.ml"
               : 'attributes))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2300 "parser_c.mly"
                      ( _1 )
# 7327 "parser_c.ml"
               : 'end_attributes))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2303 "parser_c.mly"
          (  [_1] )
# 7334 "parser_c.ml"
               : 'comma_opt))
; (fun __caml_parser_env ->
    Obj.repr(
# 2304 "parser_c.mly"
                    (  []  )
# 7340 "parser_c.ml"
               : 'comma_opt))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.expression) in
    Obj.repr(
# 2313 "parser_c.mly"
               ( Some _1 )
# 7347 "parser_c.ml"
               : 'gcc_opt_expr))
; (fun __caml_parser_env ->
    Obj.repr(
# 2314 "parser_c.mly"
                   ( None  )
# 7353 "parser_c.ml"
               : 'gcc_opt_expr))
(* Entry main *)
; (fun __caml_parser_env -> raise (Parsing.YYexit (Parsing.peek_val __caml_parser_env 0)))
(* Entry celem *)
; (fun __caml_parser_env -> raise (Parsing.YYexit (Parsing.peek_val __caml_parser_env 0)))
(* Entry statement *)
; (fun __caml_parser_env -> raise (Parsing.YYexit (Parsing.peek_val __caml_parser_env 0)))
(* Entry expr *)
; (fun __caml_parser_env -> raise (Parsing.YYexit (Parsing.peek_val __caml_parser_env 0)))
(* Entry type_name *)
; (fun __caml_parser_env -> raise (Parsing.YYexit (Parsing.peek_val __caml_parser_env 0)))
|]
let yytables =
  { Parsing.actions=yyact;
    Parsing.transl_const=yytransl_const;
    Parsing.transl_block=yytransl_block;
    Parsing.lhs=yylhs;
    Parsing.len=yylen;
    Parsing.defred=yydefred;
    Parsing.dgoto=yydgoto;
    Parsing.sindex=yysindex;
    Parsing.rindex=yyrindex;
    Parsing.gindex=yygindex;
    Parsing.tablesize=yytablesize;
    Parsing.table=yytable;
    Parsing.check=yycheck;
    Parsing.error_function=parse_error;
    Parsing.names_const=yynames_const;
    Parsing.names_block=yynames_block }
let main (lexfun : Lexing.lexbuf -> token) (lexbuf : Lexing.lexbuf) =
   (Parsing.yyparse yytables 1 lexfun lexbuf : Ast_c.program)
let celem (lexfun : Lexing.lexbuf -> token) (lexbuf : Lexing.lexbuf) =
   (Parsing.yyparse yytables 2 lexfun lexbuf : Ast_c.toplevel)
let statement (lexfun : Lexing.lexbuf -> token) (lexbuf : Lexing.lexbuf) =
   (Parsing.yyparse yytables 3 lexfun lexbuf : Ast_c.statement)
let expr (lexfun : Lexing.lexbuf -> token) (lexbuf : Lexing.lexbuf) =
   (Parsing.yyparse yytables 4 lexfun lexbuf : Ast_c.expression)
let type_name (lexfun : Lexing.lexbuf -> token) (lexbuf : Lexing.lexbuf) =
   (Parsing.yyparse yytables 5 lexfun lexbuf : Ast_c.fullType)
